
/*
 * Computer Algebra Kit (c) 1995,97 by Comp.Alg.Objects.  All Rights Reserved.
 */

#ifndef __CAEXPRESSION_HEADER__
#define __CAEXPRESSION_HEADER__

@interface Expression : CAObject
{
    STR		head;
    id		object;
    id		expressions;
}

+ newStrValue:(STR)strValue;
+ newIntValue:(int)intValue;
+ newErrorMsg:(STR)aMsg;
+ newHead:(STR)strValue expressions:aCollection;
+ newHead:(STR)strValue object:anObject;
+ newNullaryHead:(STR)strValue;
+ newUnaryHead:(STR)strValue:a;
+ newBinaryHead:(STR)strValue:a:b;
- copy;
- deepCopy;
- clear;

- (STR) head;
- expressions;
- object;
- firstExpression;
- lastExpression;
- (int) numExpressions;
- (int) intValue;

- (BOOL) containsHead:(STR)aHead;
- (BOOL) isEqual:anExpression;

- expandVariables;

- simplify;

- asExpression;
- expression:anExpression;

- printToFile:(FILE *)aFile;
@end

#endif /* __CAEXPRESSION_HEADER__ */

