
/*
 * Computer Algebra Kit (c) 1993,97 by Comp.Alg.Objects.  All Rights Reserved.
 */

#ifndef __CAINTEGERMODP_HEADER__
#define __CAINTEGERMODP_HEADER__

#include "cobject.h"

#define USHRT_MAX_PRIME 65521U
typedef unsigned short ca_modp_t;

@interface IntegerModp : CAObject
{
    ca_modp_t		value;
    unsigned short	modulus;
}

+ newModulus:(unsigned short)aPrime;
+ newIntValue:(int)intValue modulus:(unsigned short)aPrime;

- (unsigned) hash;
- (BOOL) isEqual:b;
- (unsigned short) modulus;
- (int) intValue;
- intValue:(int)aValue;

- zero;
- (BOOL) isZero;
- (BOOL) isOpposite:b;
- negate;
- double;
- add:b;
- subtract:b;

- one;
- minusOne;
- (BOOL) isOne;
- (BOOL) isMinusOne;
- square;
- multiply:b;
- inverse;
- divide:b;

- (int) characteristic;
- frobenius;
- frobeniusInverse;

- (BOOL) printsLeadingSign;
- printToFile:(FILE *)aFile;
@end

#endif /* __CAINTEGERMODP_HEADER__ */

