
/*
 * Computer Algebra Kit (c) 1993,97 by Comp.Alg.Objects.  All Rights Reserved.
 */

#ifndef __CATERM_HEADER__
#define __CATERM_HEADER__

#include "cobject.h"

@interface Term : CAObject
{
    id		scalarZero;
    id		coefficient;
    id		symbol;
    int		exponent;	
}

+ newScalar:aScalar symbol:aSymbol exponent:(int)anExponent;
+ newCoefficient:aCoefficient symbol:aSymbol exponent:(int)anExponent;
- copy;
- deepCopy;
- clear;

- scalarZero;
- coefficient;
- symbol;
- (int) exponent;
- (int) degree;
- (unsigned) hash;
- (BOOL) isEqual:b;
- (int) compareExponents:b;

- (int) intValue;
- intValue:(int)aValue;
- (float) floatValue;
- floatValue:(float)aValue;
- asScalar;
- asSymbol;

- zero;
- (BOOL) isZero;
- (BOOL) isOpposite:b;
- negate;
- double;
- add:b;
- subtract:b;

- one;
- (BOOL) isOne;
- (BOOL) isMinusOne;
- square;
- inverse;
- multiplyScalar:b;
- multiplyCoefficient:b;
- multiply:b;
- divideScalar:b;
- divideCoefficient:b;
- divide:b;

- power:(int)n;
- root:(int)n;
- squareRoot;

- frobenius;
- frobeniusInverse;

- derive;
- integrate;

- asExpression;

- (BOOL) printsLeadingSign;
- (BOOL) printsSum;
- (BOOL) printsProduct;
- printToFile:(FILE *)aFile;
@end

#endif /* __CATERM_HEADER__ */

