
/*
 * Portable Object Compiler (c) 97,98 by Stes & Lerman.  All Rights Reserved.
 */

#ifndef __BLOCK_H__
#define __BLOCK_H__

#ifndef __OBJECT_INCLUDED__
#define __OBJECT_INCLUDED__
#include "Object.h" /* Stepstone Object.h assumes #import */
#endif

#ifndef OBJCRTEXPORT
#define OBJCRTEXPORT /* empty */
#endif

/* allows"manual" construction of Blocks, ie. without compiler support */
extern id OBJCRTEXPORT errorBlock(int tag,STR msg,...);
extern id OBJCRTEXPORT newBlock(int n,IMP fn,void*data);

/*
 * Common Tags for Block Exceptions raised by runtime and objpak.
 */

#define OC_MEMERROR 100
#define OC_NOIXVARS 101
#define OC_NOFILER 102

#define OC_BOUNDSERROR 110
#define OC_OBJECTNOTFOUND 111
#define OC_BUFFEROVERFLOW 112

#define OC_CLASSNOTFOUND 120
#define OC_SELNOTFOUND 121
#define OC_SUBCLASSRESPONSIBILITY 122
#define OC_SHOULDNOTIMPLEMENT 123
#define OC_NOTIMPLEMENTED 124
#define OC_DOESNOTRECOGNIZE 125

@interface Block : Object
{
        int tag;
	int nVars;
	IMP fn; /* it's not _really_ an IMP, it's just a func pointer */
	void* data;
}
+ initialize;

- (int) tag;
- setTag:(int)aTag;

- raise;
- ifException:aHandler;
- resume;
- ifOutOfMemory:aBlock;
- ifClassNotFound:aBlock;

- value;
- atExit;
- value:anObject;
- value:firstObject with:secondObject;

+ idTrue;
+ idFalse;
- repeatTimes:(int)n;
- (BOOL) isFalse;
- (BOOL) isTrue;
- whileTrue:aBlock;
- whileFalse:aBlock;
- untilFalse:aBlock;
- untilTrue:aBlock;
@end

/* some defs needed when cross-compiling with a DIFFERENT compiler */
/* placed this here 'cause we will have a different objcrt.h and Object.h */

#ifndef __PORTABLE_OBJC__

void *OC_Malloc(size_t); /* allocate memory from the system */
void *OC_MallocAtomic(size_t); /* allocate memory from the system */
void *OC_Realloc(void *,size_t);/* reallocate memory from the system */
void *OC_Free(void *data);/* deallocate OC_Malloc'ed memory and return NULL */

#endif /* __PORTABLE_OBJC__ */

#endif /* __BLOCK_H__ */



