
/*
 * Portable Object Compiler (c) 1997 by David Stes.  All Rights Reserved.
 */

#ifndef __OBJPOINT_H__
#define __OBJPOINT_H__

#include "objc.h"

@interface Point : Object
{
    int xLoc;
    int yLoc;
}

+ new;
+ x:(int)x y:(int)y;

- x:(int)x y:(int)y;
- x:(int)x;
- y:(int)y;
- (int) x;
- (int) y;

- (unsigned) hash;
- (BOOL) isEqual:aPoint;
- (BOOL) isBelow:aPoint;
- (BOOL) isAbove:aPoint;
- (BOOL) isLeft:aPoint;
- (BOOL) isRight:aPoint;

- moveBy:aPoint;
- moveBy:(int)x:(int)y;
- moveTo:aPoint;
- plus:aPoint;

- printToFile:(FILE *)aFile;
#ifdef __PORTABLE_OBJC__

- fileOutOn:aFiler;
- fileInFrom:aFiler;
#endif /* __PORTABLE_OBJC__ */

@end

#endif /* __OBJPOINT_H__ */

