
/*
 * Computer Algebra Kit (c) 1994,97 by Comp.Alg.Objects.  All Rights Reserved.
 */

#ifndef __CACOLLECTION_HEADER__
#define __CACOLLECTION_HEADER__

#include "cobject.h"

typedef id *ca_mmbs_t;

typedef struct ca_cltn {
    int			count;
    int			capacity;
    ca_mmbs_t		members;
} *ca_cltn_t;

@interface CACollection : CAObject
{
    struct ca_cltn		value;
}
- check;

- _setUpCapacity:(int)aCapacity;
+ new;
- newCapacity:(int)aCapacity;
+ newCapacity:(int)aCapacity;
+ newStrValue:(STR)strValue;
- capacity:(int)aCapacity;
- empty;
- copy;
- deepCopy;
- clear;

- (ca_cltn_t) ca_cltn_value;
- (BOOL) isEqual:aCollection;
- (unsigned) hash;
- (BOOL) isEmpty;
- (BOOL) notEmpty;
- (int) numMembers;

- insert:anObject;
- insertIfAbsent:anObject;
- insert:anObject at:(int)i;

- removeMember;
- removeMemberAt:(int)i;
- removeMember:anObject;

- replaceMemberAt:(int)i with:anObject;
- swapMembersAt:(int)i:(int)j;

- eachMember;
- eachMemberReversed;
- memberAt:(int)i;
- (float) floatValueAt:(int)i;
- (int) intValueAt:(int)i;
- lastMember;
- (int) findMember:anObject;

- (BOOL) isSorted;
- (BOOL) notSorted;
- sort;
- reverse;

- merge:aCltn;
- union:aCltn;

- asExpression;
- expression:anExpression;
- strValue:(STR)aValue;

- printToFile:(FILE *)aFile;

- fileOutOn:aFiler;
- fileInFrom:aFiler;
@end

#endif /* __CACOLLECTION_HEADER__ */

