
/*
 * Computer Algebra Kit (c) 1993,95 by Comp.Alg.Objects.  All Rights Reserved.
 */

#include "cakit.h"

@implementation CACollectionSequence
- _setUpContent:aCollection
{
    content = aCollection;
    numMembers = [content numMembers];
    return self;
}

+ newContent:aCollection
{
    return [[super new] _setUpContent:aCollection];
}

- copy
{
    self = [super copy];
    content = [content cheapCopy];
    assert(-1 <= index && index <= numMembers);
    return self;
}

- clear
{
    content = [content free];return [super clear];
}


- (int) numMembers
{
    return numMembers;
}

- (BOOL) isEmpty
{
    return numMembers == 0;
}

- toFirstMember
{
    index = -1;return self;
}

- toLastMember
{
    index = numMembers;return self;
}

- toMemberAt:(int)i
{
    index = i-1;return self;
}

- nextMember
{
    index = (index > numMembers)?numMembers:index+1;
    return (0 <= index && index < numMembers)?[content memberAt:index]:nil;
}

- previousMember
{
    index = (index < 0)?-1:index-1;
    return (0 <= index && index < numMembers)?[content memberAt:index]:nil;
}

@end

