
/*
 * Computer Algebra Kit (c) 1995,97 by Comp.Alg.Objects.  All Rights Reserved.
 */

#ifndef __CAEXPRESSION_HEADER__
#define __CAEXPRESSION_HEADER__

@interface Expression : CAObject
{
    STR		head;
    id		object;
    id		expressions;
}

- newStrValueNoEval:(STR)strValue;
+ newStrValueNoEval:(STR)strValue;
+ newStrValue:(STR)strValue;
- newIntValue:(int)intValue;
+ newIntValue:(int)intValue;
- newErrorMsg:(STR)aMsg;
+ newErrorMsg:(STR)aMsg;
- newHead:(STR)strValue expressions:aCollection;
+ newHead:(STR)strValue expressions:aCollection;
- newHead:(STR)strValue object:anObject;
+ newHead:(STR)strValue object:anObject;
- newNullaryHead:(STR)strValue;
+ newNullaryHead:(STR)strValue;
- newUnaryHead:(STR)strValue:a;
+ newUnaryHead:(STR)strValue:a;
- newBinaryHead:(STR)strValue:a:b;
+ newBinaryHead:(STR)strValue:a:b;
- copy;
- deepCopy;
- clear;

- (STR) head;
- expressions;
- object;
- firstExpression;
- lastExpression;
- (int) numExpressions;
- (int) intValue;

- (BOOL) containsHead:(STR)aHead;
- (BOOL) isEqual:anExpression;
- (int) compare:anExpression;

- (BOOL) isMatch:anExpression keyTable:kTable valueTable:vTable;

- substitute;

- addAsVariableTo:aCltn;
- addAdditiveVariablesTo:aCltn;
- additiveVariables;
- addMultiplicativeVariablesTo:aCltn;
- multiplicativeVariables;
- addExpandVariablesTo:aCltn;
- expandVariables;

- simplifyIfNotAdditive;
- simplifyIfNotMultiplicative;
- simplifyIfNotElementary;
- simplify;

- asExpression;
- expression:anExpression;

- fullFormToFile:(FILE *)aFile;
- printToFile:(FILE *)aFile;
@end

#endif /* __CAEXPRESSION_HEADER__ */

