#include "cakit.h"

static void ca_vardns_ix_init(ca_vardns_ixt ix,id self)
{
    ix->n = [[self symbols] numMembers];ix->i = -1;
}

static void ca_vardns_ix_clear(ca_vardns_ixt ix)
{
    /* nothing to clear */
}

static int ca_vardns_ix_count(ca_vardns_ixt ix)
{
    return ix->n; /* total number, not just nonzeroes */ 
}

static int ca_vardns_ix_isempty(ca_vardns_ixt ix)
{
    return ix->n == 0; 
}

static int ca_vardns_ix_ismatch(ca_vardns_ixt ix)
{
    return (0 <= ix->i && ix->i < ix->n);
}

static void ca_vardns_ix_tofirst(ca_vardns_ixt ix)
{
    ix->i = -1;
}

static void ca_vardns_ix_tolast(ca_vardns_ixt ix)
{
    ix->i = ix->n;
}

static void ca_vardns_ix_to(ca_vardns_ixt ix,int i)
{
    ix->i = i-1;
}

static void ca_vardns_ix_next(ca_vardns_ixt ix)
{
    if (ix->i == ix->n) {
	/* remain on position just after last term */
    } else {
	ix->i = ix->i + 1;
    }
}

static void ca_vardns_ix_prev(ca_vardns_ixt ix)
{
    if (ix->i == -1) {
	/* remain on position just before first term */
    } else {
	ix->i = ix->i - 1;
    }
}

@implementation ca_vardns_sequence : ca_sequence

- _setUpContent:anObject
{
    content = anObject;
    ca_vardns_ix_init(&ix,content);
    return self;
}

+ newContent:anObject
{
    return [[super new] _setUpContent:anObject];
}

- clear
{
    ca_vardns_ix_clear(&ix);
    content = [content free];
    if (currentMember) currentMember = [currentMember free];
    return [super clear];
}

- (int) numMembers
{
    return ca_vardns_ix_count(&ix);
}

- (BOOL) isEmpty
{
    return ca_vardns_ix_isempty(&ix);
}

- toFirstMember
{
    ca_vardns_ix_tofirst(&ix);
    return self;
}

- toLastMember
{
    ca_vardns_ix_tolast(&ix);
    return self;
}

- toMemberAt:(int)i
{
    ca_vardns_ix_to(&ix,i);
    return self;
}

- currentMember
{
    if (currentMember) currentMember = [currentMember free];
    return currentMember = [content elt_ca_vardns_ix:&ix];
}

- nextMember
{
    ca_vardns_ix_next(&ix);
    return [self currentMember];
}

- previousMember
{
    ca_vardns_ix_prev(&ix);
    return [self currentMember];
}

@end

