
/*
 * Computer Algebra Kit (c) 1993,95 by Comp.Alg.Objects.  All Rights Reserved.
 */

#include "cakit.h"

@implementation ca_vardnsrecdegsps_polynomial
+ newScalarZero:aScalar
{
    return [self error:"Can't create variable dense polynomial without cltn of symbols"];
}

+ newScalarZero:aScalar coefficientZero:aCoef symbols:aCltn
{
    return [self subclassResponsibility:_cmd];
}

- newScalarZero:aScalar coefficientZero:aCoef symbols:aCltn
{
    return [self notImplemented:_cmd];
}

+ newScalarZero:aScalar symbols:aCltn
{
    id aCoef,aClass;
    int n = [aCltn numMembers];
    
    assert([aScalar isZero] && n >= 1);
	
    if (n==1) {
	aCoef  = [aScalar cheapCopy];
    } else {
	id newCltn = [aCltn copy];[[newCltn removeMember] free];
	aCoef  = [self newScalarZero:[aScalar cheapCopy] symbols:newCltn];
	aCoef  = [CAPolynomialClass newCarrier:aCoef];
    }
    
    aClass = [aCoef class_vardnsrecdegsps_polynomial];
    return [aClass newScalarZero:aScalar coefficientZero:aCoef symbols:aCltn];
}

- scalarZero
{
    return [self subclassResponsibility:_cmd];
}

- symbols
{
    return [self subclassResponsibility:_cmd];
}

- (BOOL) sameClass:b
{
    id aScalar  = [self scalarZero];
    id aSymbols = [self symbols];
    id bScalar  = [b scalarZero];
    id bSymbols = [b symbols];
    
    if ([super sameClass:b] == NO) return NO;
    if (aScalar != bScalar && [aScalar notEqual:bScalar]) return NO;
    if (aSymbols != bSymbols && [aSymbols notEqual:bSymbols]) return NO;
    
    return YES;
}

- (BOOL)isVariableDense		{ return YES; }
- (BOOL)isVariableSparse	{ return NO;  }
- (BOOL)isRecursive		{ return YES; }
- (BOOL)isExpanded		{ return NO;  }
- (BOOL)isDegreeDense		{ return NO;  }
- (BOOL)isDegreeSparse		{ return YES; }

- emptyScalarZero:aZero
{
    id symbols = [[self symbols] cheapCopy];
    id classCarrier = [aZero class_vardnsrecdegsps_polynomial];
    
    return [classCarrier newScalarZero:aZero symbols:symbols];
}

- emptyVariableDense:aCltn
{
    id classCarrier;
    id scalarZero = [[self scalarZero] cheapCopy];

    classCarrier = [scalarZero class_vardnsrecdegsps_polynomial];
    assert(classCarrier == isa || classCarrier != isa);
    assert([aCltn numMembers] == [[self symbols] numMembers]);
    return [classCarrier newScalarZero:scalarZero symbols:aCltn];
}

- emptyVariableSparse
{
    id classCarrier;
    id scalarZero = [[self scalarZero] cheapCopy];
    
    classCarrier = [scalarZero class_varspsrecdegsps_polynomial];
    return [classCarrier newScalarZero:scalarZero];
}

- emptyExpanded
{
    id classCarrier;
    id symbols = [[self symbols] cheapCopy];
    id scalarZero = [[self scalarZero] cheapCopy];
    
    classCarrier = [scalarZero class_vardnsexpdegsps_polynomial];
    return [classCarrier newScalarZero:scalarZero symbols:symbols];
}

- emptyRecursive
{
    return [self empty];
}

- emptyDegreeSparse
{
    return [self empty];
}

- emptyDegreeDense
{
    id classCarrier;
    id symbols = [[self symbols] cheapCopy];
    id scalarZero = [[self scalarZero] cheapCopy];
    
    classCarrier = [scalarZero class_vardnsrecdegdns_polynomial];
    return [classCarrier newScalarZero:scalarZero symbols:symbols];
}

@end

