
/*
 * Computer Algebra Kit (c) 1992,97 by Comp.Alg.Objects.  All Rights Reserved.
 */

#ifndef __CAINTEGER_HEADER__
#define __CAINTEGER_HEADER__

#include "cobject.h"

#define BigInt Integer

typedef unsigned short ca_intwrd_t;

typedef ca_intwrd_t *ca_intdig_t;

typedef struct ca_int {
    int		sign;
    int		count;
    int		capacity;
    ca_intdig_t	digits;
} *ca_int_t;
#if (0) /* public and private structure must match exactly */
typedef struct ca_int {
    int		sign;
    int		count;
    int		capacity;
    void*	digits;
} *ca_int_t;
#endif /* 0 */

typedef unsigned short int DIGIT;

/* the following type is declared here only to be included once
 * there is *no* special treatment of small integers in CAInteger
 */
typedef struct ca_intobj {
    short int		hit;
    short int		val;
    id			obj;
} *ca_intobj_t;

typedef struct ca_intobj *ca_intobjseq_t;
typedef struct ca_intobj ca_intobj_c;
typedef struct { id proto; } ca_intobj_args;

#define ca_intobj_isvalue	0
#define ca_intobj_pervalue	0

@interface Integer : CAObject
{
    struct ca_int	value;
}
- check;

- _setUpInteger;
+ new;
+ str:(STR)aString;
+ newStrValue:(STR)aString;
- newIntValue:(int)intValue;
+ newIntValue:(int)intValue;
+ int:(int)intValue;
- newFactorial:(int)n;
+ factorial:(int)n;
+ newFactorial:(int)n;
+ fibonacci:(int)n;
- copy;
- deepCopy;
- clear;
- empty;
- (ca_int_t) ca_int_value;
- ca_int_value:(ca_int_t)aValue;
- (ca_int_t) ca_int_reference;
- ca_int_reference:(ca_int_t)aReference;
- class_vector;
- class_vardnsrecdegsps_polynomial;
- class_vardnsrecdegdns_polynomial;
- class_vardnsexpdegsps_polynomial;

- (unsigned) hash;
- (BOOL) isEqual:b;
- (BOOL) notEqual:b;
- (int) numDigits;
- (BOOL) isDigit;

- insertDigit:(DIGIT)d;
- (DIGIT) removeDigit;

- (DIGIT) digitAt:(int)i;
- (DIGIT) lastDigit;
- (DIGIT) leadingDigit;

- (STR) strValue;
- strValue:(STR)aString;

- asNumerical;
- asModp:(unsigned short)p;
- (DIGIT) digitValue;
- digitValue:(DIGIT)aValue;
- (unsigned long) ulongValue;
- ulongValue:(unsigned long)aValue;
- (int) intValue;
- intValue:(int)aValue;
- (double) doubleValue;
- (float) floatValue;

- (int) sign;
- (int) compare:b;

- zero;
- (BOOL) isZero;
- (BOOL) notZero;
- (BOOL) isOpposite:b;
- (BOOL) notOpposite:b;
- negate;
- negateSelf;
- _double:(int)v;
- _doubleSelf:(int)v;
- double;
- doubleSelf;
- _add:(int)v:b:(int)w;
- _addSelf:(int)v:b:(int)w;
- add:b;
- addSelf:b;
- subtract:b;
- subtractSelf:b;
- addDigit:(DIGIT)d;
- addSelfDigit:(DIGIT)d;
- subtractDigit:(DIGIT)d;
- subtractSelfDigit:(DIGIT)d;

- one;
- minusOne;
- _add:(int)v:B multiply:b:(int)w;
- _addSelf:(int)v:B multiply:b:(int)w;
- _multiply:a:(int)v add:B:(int)w;
- _multiplySelf:a:(int)v add:B:(int)w;
- _multiply:a:(int)v add:B multiply:b:(int)w;
- _multiplySelf:a:(int)v add:B multiply:b:(int)w;
- (BOOL) isOne;
- (BOOL) notOne;
- (BOOL) isMinusOne;
- (BOOL) notMinusOne;
- square;
- squareSelf;
- multiply:b;
- multiplySelf:b;
- multiplyDigit:(DIGIT)d;
- multiplySelfDigit:(DIGIT)d;
- inverse;

- divide:b;
- divideSelf:b;
- quotientSelf:b;
- divideDigit:(DIGIT)b;
- divideSelfDigit:(DIGIT)b;
- quotientDigit:(DIGIT)b;
- quotientSelfDigit:(DIGIT)d;
- remainder:b quotient:(id *)q;
- remainderSelf:b quotient:(id *)q;
- quotientDigit:(DIGIT)d remainder:(DIGIT *)r;
- quotientSelfDigit:(DIGIT)d remainder:(DIGIT *)r;
- (DIGIT) remainderDigit:(DIGIT)d;

- (BOOL) isEven;
- (BOOL) isOdd;

- gcd:b;

- asExpression;
- expression:anExpression;

- (BOOL) printsLeadingSign;
- printToFile:(FILE *)aFile;

- fileOutOn:aFiler;
- fileInFrom:aFiler;
@end

#endif /* __CAINTEGER_HEADER__ */

