
/*
 * Computer Algebra Kit (c) 1993,97 by Comp.Alg.Objects.  All Rights Reserved.
 */

#ifndef __CAMATRIX_HEADER__
#define __CAMATRIX_HEADER__

#include "cobject.h"

@interface Matrix : CAObject
{
    id		rows;
    id		scalarZero;
    id		emptyVector;
}
- check;

+ newDiagonal:cltnOfScalars;
+ newCirculant:cltnOfScalars;
+ newCompanion:cltnOfScalars;
+ newHankel:rowScalars:colScalars;
+ newToeplitz:rowScalars:colScalars;
+ newHilbert:(int)n scalarZero:aZero;
+ newHilbert:(int)n;

+ newStrValue:(STR)strValue;
- _setUpScalarZero:aScalarZero numRows:(int)numRows numColumns:(int)numColumns;
- newScalarZero:aScalarZero numRows:(int)numRows numColumns:(int)numColumns;
+ newScalarZero:aScalarZero numRows:(int)numRows numColumns:(int)numColumns;
- newScalar:aScalar numRows:(int)numRows numColumns:(int)numColumns;
+ newScalar:aScalar numRows:(int)numRows numColumns:(int)numColumns;
- copy;
- deepCopy;
- clone;
- rows:c;
- scalarZero:aZero emptyVector:aVector rows:c;
- numRows:(int)numRows numColumns:(int)numColumns;
- emptyVector;
- clear;

- scalarZero;
- rows;
+ classVectors;
- (int) numRows;
- (int) numColumns;
- checkDimensionEqual:b;
- checkSquare;
- (BOOL) isEqual:aMatrix;
- (unsigned) hash;
- (BOOL) isDiagonal;
- (BOOL) isSymmetric;
- (BOOL) isAntiSymmetric;

- insertRow:aVector;
- insertRow:aVector at:(int)i;
- insertColumn:aCollection;
- insertColumn:aCollection at:(int)i;

- removeRow;
- removeRowAt:(int)i;
- removeColumn;
- removeColumnAt:(int)i;

- placeScalar:aScalar at:(int)i:(int)j;
- replaceScalarAt:(int)i:(int)j with:aScalar;

- asNumerical;
- asModp:(unsigned short)p;
- commonDenominator;
- asIntegral;
- asFractional;
- onCommonDenominator:(id *)denominator;

- rowAt:(int)i;
- eachRow;
- eachScalar;
- eachSequence;
- (float) floatValueAt:(int)i:(int)j;

- zero;
- negate;
- double;
- add:b;
- subtract:b;
- addScalar:s;
- subtractScalar:s;

- one;
- square;
- multiply:b;
- multiplyVector:aColumn;

- multiplyScalar:b;
- divideScalar:b;

- transpose;
- transposeSelf;

- determinant;
- determinantGauss;
- determinantBareiss;
- solveVector:y;
- solveGaussDeterminant:(id *)detReference;
- solveBareissDeterminant:(id *)detReference;
- inverse;
- divide:b;
- divideGauss:b;
- (int) rank;
- (int) nullity;
- rowReducedFormRank:(int *)rankReference indexRank:(int**)indexRankReference;
- kernel;
- image;

- trace;
- adjoint;
- adjointSelf;

- asExpression;
- expression:anExpression;
- strValue:(STR)aValue;

- printToFile:(FILE *)aFile;
@end

#endif /* __CAMATRIX_HEADER__ */

