
/*
 * Computer Algebra Kit (c) 1993,95 by Comp.Alg.Objects.  All Rights Reserved.
 */

#include "cakit.h"

@implementation CAMatrixSequenceScalars
- _setUpContent:aMatrix
{
    content = aMatrix;eachSequence = [aMatrix eachSequence];
    return self;
}

+ newContent:aMatrix
{
    return [[super new] _setUpContent:aMatrix];
}

- clear
{
    content = [content free];eachSequence = [eachSequence free];
    return [super clear];
}

- toFirstMember
{
    currentSequence = [eachSequence firstMember];
    [currentSequence toFirstMember];return self;
}

- toLastMember
{
    currentSequence = [eachSequence lastMember];
    [currentSequence toLastMember];return self;
}

- (BOOL) isEmpty
{
    return [eachSequence isEmpty];
}

- (int) numMembers
{
    [self doesNotRecognize:_cmd]; return 0;
}

- toMemberAt:(int)i
{
    [self doesNotRecognize:_cmd]; return self;
}

- nextMember
{
    id nextMember;assert (currentSequence != nil);
    
    if ((nextMember = [currentSequence nextMember])) {
	return nextMember;
    } else {
	if ((currentSequence = [eachSequence nextMember])) {
	    [currentSequence toFirstMember];return [self nextMember];
	} else {
	    [self toLastMember];return nil;
	}
    }	
}

- previousMember
{
    id previousMember;assert (currentSequence != nil);
    
    if ((previousMember = [currentSequence previousMember])) {
	return previousMember;
    } else {
	if (currentSequence = [eachSequence previousMember]) {
	    [currentSequence toLastMember];return [self previousMember];
	} else {
	    [self toFirstMember];return nil;
	}
    }	
}

@end

