#include "cakit.h"

static ca_obj_args ca_obj_getargs(id object)
{
    ca_obj_args args;args.proto = object;return args;
}

static int ca_obj_size(ca_obj_args args)
{
    return 1;			/* pointer increment */
}

static int ca_obj_bsize(ca_obj_args args)
{
    return sizeof(ca_obj_c);	/* byte size carrier */
}

#if 0
static ca_obj_t  ca_obj_id2t(id object) { /* not needed */ }
static ca_obj_c *ca_obj_id2t(id object) { /* not needed */ }
#endif

static ca_obj_t ca_obj_id2ref(id object,ca_obj_c *ref)
{
    return object;			/* read-only, scratch space "ref" */
}

static id ca_obj_t2id(id proto,ca_obj_t t)
{
    return [t cheapCopy];		/* new object, contains copy of "t" */
}

static id ca_obj_c2id(id proto,ca_obj_c *c)
{
    return *c;				/* new object, contains "c" */
}

static int ca_obj_check(ca_obj_t self,ca_obj_args args)
{
    assert(args.proto && self);[args.proto check];[self check];return 1;
}

static void ca_obj_oozero(ca_obj_c *c,ca_obj_args args)
{
    *c = [args.proto zero];
}

static void ca_obj_copy(ca_obj_c *c,ca_obj_t a,ca_obj_args args)
{
    *c = [a cheapCopy];
}

static void ca_obj_deepcopy(ca_obj_c *c,ca_obj_t a,ca_obj_args args)
{
    *c = [a deepCopy];
}

static void ca_obj_move(ca_obj_c *c,ca_obj_c *a,ca_obj_args args)
{
    *c = *a;*a = nil;
}

static void ca_obj_clear(ca_obj_c *c,ca_obj_args args)
{
    *c = [*c free];
}

static unsigned ca_obj_hash(ca_obj_t a,ca_obj_args args)
{
    return [a hash];
}

static int ca_obj_iseq(ca_obj_t a,ca_obj_t b,ca_obj_args args)
{
    return (a==b)?YES:[a isEqual:b];
}

static int ca_obj_sgn(ca_obj_t a,ca_obj_args args)
{
    return [a sign];
}

static int ca_obj_cmp(ca_obj_t a,ca_obj_t b,ca_obj_args args)
{
    return (a==b)?0:[a compare:b];
}

static int ca_obj_iszero(ca_obj_t a,ca_obj_args args)
{
    return [a isZero];
}

static int ca_obj_isop(ca_obj_t a,ca_obj_t b,ca_obj_args args)
{
    return [a isOpposite:b];
}

static void ca_obj_ooneg(ca_obj_c *c,ca_obj_t a,ca_obj_args args)
{
    *c = [a negate];
}

static void ca_obj_inneg(ca_obj_c *c,ca_obj_args args)
{
    *c = [*c negateSelf];
}

static void ca_obj_oodbl(ca_obj_c *c,ca_obj_t a,int v,ca_obj_args args)
{
    *c = [a _double:v];
}

static void ca_obj_indbl(ca_obj_c *c,int v,ca_obj_args args)
{
    *c = [*c _doubleSelf:v];
}

static void ca_obj_ooadd(ca_obj_c *c,ca_obj_t a,int v,ca_obj_t b,int w,ca_obj_args args)
{
    *c = [a _add:v:b:w];
}

static void ca_obj_inadd(ca_obj_c *c,int v,ca_obj_t b,int w,ca_obj_args args)
{
    *c = [*c _addSelf:v:b:w];
}

static int ca_obj_isone(ca_obj_t a,ca_obj_args args)
{
    return [a isOne];
}

static int ca_obj_isminusone(ca_obj_t a,ca_obj_args args)
{
    return [a isMinusOne];
}

static void ca_obj_oosqr(ca_obj_c *c,ca_obj_t a,ca_obj_args args)
{
    *c = [a square];
}

static void ca_obj_insqr(ca_obj_c *c,ca_obj_args args)
{
    *c = [*c squareSelf];
}

static void ca_obj_oomul(ca_obj_c *c,ca_obj_t a,ca_obj_t b,ca_obj_args args)
{
    *c = [a multiply:b];
}

static void ca_obj_inmul(ca_obj_c *c,ca_obj_t b,ca_obj_args args)
{
    *c = [*c multiplySelf:b];
}

static void ca_obj_oomulv(ca_obj_c *c,ca_obj_t a,ca_obj_t b,int v,ca_obj_args args)
{
    *c = [a _multiply:b:v];
}

static void ca_obj_inmulv(ca_obj_c *c,ca_obj_t b,int v,ca_obj_args args)
{
    *c = [*c _multiplySelf:b:v];
}

static void ca_obj_ooaddmul(ca_obj_c *c,ca_obj_t a,int v,ca_obj_t b,ca_obj_t t,int w,ca_obj_args args)
{
    *c = [a _add:v:b multiply:t:w];
}

static void ca_obj_inaddmul(ca_obj_c *c,int v,ca_obj_t b,ca_obj_t t,int w,ca_obj_args args)
{
    *c = [*c _addSelf:v:b multiply:t:w];
}

static void ca_obj_oomuladd(ca_obj_c *c,ca_obj_t a,ca_obj_t s,int v,ca_obj_t b,int w,ca_obj_args args)
{
    *c = [a _multiply:s:v add:b:w];
}

static void ca_obj_inmuladd(ca_obj_c *c,ca_obj_t s,int v,ca_obj_t b,int w,ca_obj_args args)
{
    *c = [*c _multiplySelf:s:v add:b:w];
}

static void ca_obj_oomuladdmul(ca_obj_c *c,ca_obj_t a,ca_obj_t s,int v,ca_obj_t b,ca_obj_t t,int w,ca_obj_args args)
{
    *c = [a _multiply:s:v add:b multiply:t:w];
}

static void ca_obj_inmuladdmul(ca_obj_c *c,ca_obj_t s,int v,ca_obj_t b,ca_obj_t t,int w,ca_obj_args args)
{
    *c = [*c _multiplySelf:s:v add:b multiply:t:w];
}

static void ca_obj_ooaddsqr(ca_obj_c *c,ca_obj_t a,int v,ca_obj_t b,int w,ca_obj_args args)
{
    *c = [a _addSquare:v:b:w];
}

static void ca_obj_inaddsqr(ca_obj_c *c,int v,ca_obj_t b,int w,ca_obj_args args)
{
    *c = [*c _addSelfSquare:v:b:w];
}

static void ca_obj_ooinv(ca_obj_c *c,ca_obj_t a,ca_obj_args args)
{
    *c = [a inverse];
}

static void ca_obj_ininv(ca_obj_c *c,ca_obj_args args)
{
    *c = [*c inverseSelf];
}

static BOOL ca_obj_oodiv(ca_obj_c *c,ca_obj_t a,ca_obj_t b,ca_obj_args args)
{
    id Q = [a divide:b];
    if (Q) {
	*c = Q;return SUCCESS;
    } else {
	return FAILURE;
    }
}

static void ca_obj_indiv(ca_obj_c *c,ca_obj_t b,ca_obj_args args)
{
    id Q = [*c divideSelf:b];
    if (Q) {
	*c = Q;
    } else {
	fprintf(stderr,"-exact division failed\n");abort();
    }
}

static void ca_obj_args_fileOut(id aFiler,ca_obj_args *args) {}
static void ca_obj_args_fileIn(id aFiler,ca_obj_args *args) {}

static void ca_obj_fileOut(id aFiler,ca_obj_c *a,ca_obj_args args)
{
    [aFiler fileOut:a type:'@'];
}

static void ca_obj_fileIn(id aFiler,ca_obj_c *c,ca_obj_args args)
{
    [aFiler fileIn:c type:'@'];
}


/*
 * Computer Algebra Kit (c) 1993,97 by Comp.Alg.Objects.  All Rights Reserved.
 */

static int ca_vardnsmonom_size(ca_vardnsmonom_args args)
{
    return args.nvars; /* size to add to int pointer */
}

static int ca_vardnsmonom_bsize(ca_vardnsmonom_args args)
{
    return args.nvars * sizeof(int); /* byte size exponent array */
}

static int ca_vardnsmonom_check(ca_vardnsmonom_t self,ca_vardnsmonom_args args)
{
    int nvars = args.nvars;
    while (nvars--) assert(*self++ >= 0);
    return 1;
}

static ca_vardnsmonom_t ca_vardnsmonom_id2t(id object)
{
    return [object ca_vardnsmonom_value];
}

static id ca_vardnsmonom_t2id(id proto,ca_vardnsmonom_t f)
{
    return [proto ca_vardnsmonom_value:f];
}

static ca_vardnsmonom_args ca_vardnsmonom_getargs(id self)
{
    ca_vardnsmonom_args res;
    res.nvars = [[self symbols] numMembers];
    return res; 
}

static ca_vardnsmonom_t ca_vardnsmonom_alloc(ca_vardnsmonom_args args)
{
    return (ca_vardnsmonom_t)OC_Malloc(ca_vardnsmonom_bsize(args));
}

static void ca_vardnsmonom_init(ca_vardnsmonom_c *c,ca_vardnsmonom_args args)
{
    int nvars = args.nvars;while (nvars--) *c++ = 0;
}

static void ca_vardnsmonom_copy(ca_vardnsmonom_c *c,ca_vardnsmonom_t a,ca_vardnsmonom_args args)
{
    int nvars = args.nvars;while (nvars--) *c++ = *a++;
}

static void ca_vardnsmonom_clear(ca_vardnsmonom_c *c,ca_vardnsmonom_args args)
{
    /* nothing to clear... */
}

static void ca_vardnsmonom_free(ca_vardnsmonom_c *c,ca_vardnsmonom_args args)
{
    OC_Free(c);
}

static void ca_vardnsmonom_args_fileOut(id aFiler,ca_vardnsmonom_args *args)
{
    [aFiler fileOut:&args->nvars type:'i'];
}

static void ca_vardnsmonom_args_fileIn(id aFiler,ca_vardnsmonom_args *args)
{
    [aFiler fileIn:&args->nvars type:'i'];
}

static void ca_vardnsmonom_fileOut(id aFiler,ca_vardnsmonom_c *c,ca_vardnsmonom_args args)
{
    int n = args.nvars;
    while (n--) [aFiler fileOut:c++ type:'i'];
}

static void ca_vardnsmonom_fileIn(id aFiler,ca_vardnsmonom_c *c,ca_vardnsmonom_args args)
{
    int n = args.nvars;
    while (n--) [aFiler fileIn:c++ type:'i'];
}

static unsigned ca_vardnsmonom_hash(ca_vardnsmonom_t self,ca_vardnsmonom_args args)
{
    assert(args.nvars>0);return self[0];
}

static int ca_vardnsmonom_deg(ca_vardnsmonom_t self ,ca_vardnsmonom_args args)
{
    int sum = 0;
    int nvars = args.nvars;
    while (nvars--) sum += *self++;
    return sum;
}

static int ca_vardnsmonom_numterms(ca_vardnsmonom_t self ,ca_vardnsmonom_args args)
{
    int numterms = 0;
    int nvars = args.nvars;
    while (nvars--) if (*self++) numterms++;
    return numterms;
}

static int ca_vardnsmonom_isone(ca_vardnsmonom_t self ,ca_vardnsmonom_args args)
{
    int nvars = args.nvars;
    while (nvars--) { if (*self) return 0; self++; }
    return 1;
}

static int ca_vardnsmonom_iseq(ca_vardnsmonom_t a,ca_vardnsmonom_t b ,ca_vardnsmonom_args args)
{
    int nvars = args.nvars;
    while (nvars--) { if ((*a) != (*b)) return 0; a++;b++; }
    return 1;
}

static int ca_vardnsmonom_iseqmul(ca_vardnsmonom_t a,ca_vardnsmonom_t x,ca_vardnsmonom_t b ,ca_vardnsmonom_args args)
{
    int nvars = args.nvars;
    while (nvars--) { if ((*a) != (*x) + (*b)) return 0; a++;x++;b++; }
    return 1;
}

static int ca_vardnsmonom_cmp(ca_vardnsmonom_t a,ca_vardnsmonom_t b ,ca_vardnsmonom_args args)
{
    int nvars = args.nvars;

    /* lexicographic cmp *MUST* work from right to left
     * because last symbol is largest for vardns order
     */

    while (nvars--) {
	if ((*a) < (*b)) return -1;
	if ((*a) > (*b)) return +1;
	a++;b++;
    }
    
    return 0;
}

static int ca_vardnsmonom_cmpmul(ca_vardnsmonom_t a,ca_vardnsmonom_t x,ca_vardnsmonom_t b ,ca_vardnsmonom_args args)
{
    int nvars = args.nvars;

    /* lexicographic cmp *MUST* work from right to left
     * because last symbol is largest for vardns order
     */

    while (nvars--) {
	int sum = *x + *b;
	if ((*a) < sum) return -1;
	if ((*a) > sum) return +1;
	a++;x++;b++;
    }
    
    return 0;
}

static void ca_vardnsmonom_oomul(ca_vardnsmonom_c *c,ca_vardnsmonom_t a,ca_vardnsmonom_t b,ca_vardnsmonom_args args)
{
    int nvars = args.nvars;
    while (nvars--) { (*c) = (*a) + (*b); c++; a++; b++; }
}

static void ca_vardnsmonom_inmul(ca_vardnsmonom_c *c,ca_vardnsmonom_t b,ca_vardnsmonom_args args)
{
    int nvars = args.nvars;
    while (nvars--) { (*c) += (*b); c++; b++; }
}

static BOOL ca_vardnsmonom_oodiv(ca_vardnsmonom_c *c,ca_vardnsmonom_t a,ca_vardnsmonom_t b,ca_vardnsmonom_args args)
{
    int nvars = args.nvars;
    while (nvars--) {
    	int q = *a - *b;
	if (q<0) return FAILURE;
	*c = q; c++; a++; b++;
    }
    
    return SUCCESS;
}

static void ca_vardnsmonom_indiv(ca_vardnsmonom_c *c,ca_vardnsmonom_t b,ca_vardnsmonom_args args)
{
    int nvars = args.nvars;
    while (nvars--) {
    	int q = *c - *b;
	if (q<0) { fprintf(stderr,"Division not Exact\n");abort(); } /* should stay */
	*c = q; c++; b++;
    }
}
/*
 * scalar is accessed by the C "->" operator since having variable sized
 * scalars _and_ monomials gets difficult on machines like the DEC alpha
 * (where we'd have to manually pad to get pointer aligned structures).
 * 
 * the monomial (exponent) is however not accessed by the C "->" operator
 * but rather by functions that can take offsets as arguments
 * this is important the monomials in variable dense representation
 * (fixarray of exp)
 *
 * stes - mar31, 1997 - CHANGES: for DEC alpha coefficient needs to be aligned
 * properly, put it before the monomial and drop the idea of variable sized
 * coefficients.
 */

static ca_vardnsmonom_c *ca_obj_vardnsexpdegspsterm_monom_cval(ca_obj_vardnsexpdegspsterm_t self)
{
    return &self->data;
}

static ca_vardnsmonom_t ca_obj_vardnsexpdegspsterm_monom(ca_obj_vardnsexpdegspsterm_t self)
{
#if ca_vardnsmonom_pervalue
    return self->data;
#else
    return  ca_obj_vardnsexpdegspsterm_monom_cval(self);
#endif
}

/* stes - mar31,1997
 * change for DEC alpha to exclude varsized scalars
 */

static ca_obj_c *ca_obj_vardnsexpdegspsterm_scal_cval(ca_obj_vardnsexpdegspsterm_t self,ca_obj_vardnsexpdegspsterm_args args)
{
	return &self->scal;
}

static ca_obj_t ca_obj_vardnsexpdegspsterm_scal(ca_obj_vardnsexpdegspsterm_t self,ca_obj_vardnsexpdegspsterm_args args)
{
#if ca_obj_pervalue
	return self->scal;
#else
    return  ca_obj_vardnsexpdegspsterm_scal_cval(self,args);
#endif
}

static int ca_obj_vardnsexpdegspsterm_check(ca_obj_vardnsexpdegspsterm_t self,ca_obj_vardnsexpdegspsterm_args args)
{
    assert(ca_obj_check(ca_obj_vardnsexpdegspsterm_scal(self,args),args.sargs));
    assert(!ca_obj_iszero(ca_obj_vardnsexpdegspsterm_scal(self,args),args.sargs));
    assert(ca_vardnsmonom_check(ca_obj_vardnsexpdegspsterm_monom(self),args.margs));
    return 1;
}

static int ca_obj_vardnsexpdegspsterm_bsize(ca_obj_vardnsexpdegspsterm_args args)
{
	/* this is sizeof(ca_vardnsmonom_c) too much but why bother ? */
    return sizeof(struct ca_obj_vardnsexpdegspsterm) + ca_vardnsmonom_bsize(args.margs);
}

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspsterm_alloc(ca_obj_vardnsexpdegspsterm_args args)
{
    return (ca_obj_vardnsexpdegspsterm_t)OC_Malloc(ca_obj_vardnsexpdegspsterm_bsize(args));
}

static void ca_obj_vardnsexpdegspsterm_clear(ca_obj_vardnsexpdegspsterm_t self,ca_obj_vardnsexpdegspsterm_args args)
{
    ca_vardnsmonom_clear(ca_obj_vardnsexpdegspsterm_monom_cval(self),args.margs);
    ca_obj_clear(ca_obj_vardnsexpdegspsterm_scal_cval(self,args),args.sargs);
}

static void ca_obj_vardnsexpdegspsterm_free(ca_obj_vardnsexpdegspsterm_t self,ca_obj_vardnsexpdegspsterm_args args)
{
    /* invalidating links not always helps : buggy code might work because
     * links were cleared...        self->nlink = NULL;self->plink = NULL;
     */
    OC_Free(self);
}

static int ca_obj_vardnsexpdegspsterm_cmp(ca_obj_vardnsexpdegspsterm_t a,ca_obj_vardnsexpdegspsterm_t b,ca_obj_vardnsexpdegspsterm_args args)
{
    assert(ca_obj_vardnsexpdegspsterm_check(a,args) && ca_obj_vardnsexpdegspsterm_check(b,args));
    return ca_vardnsmonom_cmp(ca_obj_vardnsexpdegspsterm_monom(a),ca_obj_vardnsexpdegspsterm_monom(b),args.margs);
}

static int ca_obj_vardnsexpdegspsterm_cmpmonom(ca_obj_vardnsexpdegspsterm_t a,ca_vardnsmonom_t b,ca_obj_vardnsexpdegspsterm_args args)
{
    assert(ca_obj_vardnsexpdegspsterm_check(a,args) && ca_vardnsmonom_check(b,args.margs));
    return ca_vardnsmonom_cmp(ca_obj_vardnsexpdegspsterm_monom(a),b,args.margs);
}

static int ca_obj_vardnsexpdegspsterm_cmpmul(ca_obj_vardnsexpdegspsterm_t a,ca_obj_vardnsexpdegspsterm_t b,ca_vardnsmonom_t m ,ca_obj_vardnsexpdegspsterm_args args)
{
    assert(ca_obj_vardnsexpdegspsterm_check(a,args) && ca_obj_vardnsexpdegspsterm_check(b,args));
    assert(ca_vardnsmonom_check(m,args.margs));
    return ca_vardnsmonom_cmpmul(ca_obj_vardnsexpdegspsterm_monom(a),ca_obj_vardnsexpdegspsterm_monom(b),m,args.margs);
}

static int ca_obj_vardnsexpdegspsterm_deg(ca_obj_vardnsexpdegspsterm_t a,ca_obj_vardnsexpdegspsterm_args args)
{
    return ca_vardnsmonom_deg(ca_obj_vardnsexpdegspsterm_monom(a),args.margs);
}

static int ca_obj_vardnsexpdegspsterm_iszero(ca_obj_vardnsexpdegspsterm_t self,ca_obj_vardnsexpdegspsterm_args args)
{
    return ca_obj_iszero(ca_obj_vardnsexpdegspsterm_scal(self,args),args.sargs);
}

static int ca_obj_vardnsexpdegspsterm_isone(ca_obj_vardnsexpdegspsterm_t self,ca_obj_vardnsexpdegspsterm_args args)
{
    return ca_obj_isone(ca_obj_vardnsexpdegspsterm_scal(self,args),args.sargs) && ca_vardnsmonom_isone(ca_obj_vardnsexpdegspsterm_monom(self),args.margs);
}

static int ca_obj_vardnsexpdegspsterm_isminusone(ca_obj_vardnsexpdegspsterm_t self,ca_obj_vardnsexpdegspsterm_args args)
{
    return ca_obj_isminusone(ca_obj_vardnsexpdegspsterm_scal(self,args),args.sargs) && ca_vardnsmonom_isone(ca_obj_vardnsexpdegspsterm_monom(self),args.margs);
}

static int ca_obj_vardnsexpdegspsterm_iseq(ca_obj_vardnsexpdegspsterm_t a,ca_obj_vardnsexpdegspsterm_t b,ca_obj_vardnsexpdegspsterm_args args)
{
    assert(ca_obj_vardnsexpdegspsterm_check(a,args) && ca_obj_vardnsexpdegspsterm_check(b,args));
    return ca_vardnsmonom_iseq(ca_obj_vardnsexpdegspsterm_monom(a),ca_obj_vardnsexpdegspsterm_monom(b),args.margs) && ca_obj_iseq(ca_obj_vardnsexpdegspsterm_scal(a,args),ca_obj_vardnsexpdegspsterm_scal(b,args),args.sargs);
}

static int ca_obj_vardnsexpdegspsterm_isop(ca_obj_vardnsexpdegspsterm_t a,ca_obj_vardnsexpdegspsterm_t b,ca_obj_vardnsexpdegspsterm_args args)
{
    assert(ca_obj_vardnsexpdegspsterm_check(a,args) && ca_obj_vardnsexpdegspsterm_check(b,args));
    return ca_vardnsmonom_iseq(ca_obj_vardnsexpdegspsterm_monom(a),ca_obj_vardnsexpdegspsterm_monom(b),args.margs) && ca_obj_isop(ca_obj_vardnsexpdegspsterm_scal(a,args),ca_obj_vardnsexpdegspsterm_scal(b,args),args.sargs);
}

static void ca_obj_vardnsexpdegspsterm_glue(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A)
{
    C->nlink = A;A->plink = C;
}

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspsterm_cns(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A)
{
    ca_obj_vardnsexpdegspsterm_glue(C,A);return A;
}

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspsterm_delete(ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_args args)
{
    ca_obj_vardnsexpdegspsterm_t C = A->nlink;
    ca_obj_vardnsexpdegspsterm_glue(A->plink,C);
    ca_obj_vardnsexpdegspsterm_clear(A,args);
    ca_obj_vardnsexpdegspsterm_free(A,args);
    return C;
}

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspsterm_condcns(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t new,ca_obj_vardnsexpdegspsterm_args args)
{
    if (ca_obj_vardnsexpdegspsterm_iszero(new,args)) {
	ca_obj_vardnsexpdegspsterm_clear(new,args);ca_obj_vardnsexpdegspsterm_free(new,args);return C;
    } else {
	assert(ca_obj_vardnsexpdegspsterm_check(new,args));return ca_obj_vardnsexpdegspsterm_cns(C,new);
    }
}

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspsterm_conddelete(ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_args args)
{
    if (ca_obj_vardnsexpdegspsterm_iszero(A,args)) {
	return ca_obj_vardnsexpdegspsterm_delete(A,args);
    } else {
	return A->nlink;
    }
}

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspsterm_copymonomsc_cns(ca_obj_vardnsexpdegspsterm_t C,ca_vardnsmonom_t m,ca_obj_t s,ca_obj_vardnsexpdegspsterm_args args)
{
    ca_obj_vardnsexpdegspsterm_t new = ca_obj_vardnsexpdegspsterm_alloc(args);
    
    ca_obj_copy(ca_obj_vardnsexpdegspsterm_scal_cval(new,args),s,args.sargs);
    ca_vardnsmonom_copy(ca_obj_vardnsexpdegspsterm_monom_cval(new),m,args.margs);
    
    assert(ca_obj_vardnsexpdegspsterm_check(new,args));return ca_obj_vardnsexpdegspsterm_cns(C,new);
}

static void ca_obj_vardnsexpdegspsterm_copymonomsc(ca_obj_vardnsexpdegspsterm_t C,ca_vardnsmonom_t m,ca_obj_t s,ca_obj_vardnsexpdegspsterm_t CT,ca_obj_vardnsexpdegspsterm_args args)
{
    ca_obj_vardnsexpdegspsterm_glue(ca_obj_vardnsexpdegspsterm_copymonomsc_cns(C,m,s,args),CT);
}

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspsterm_deepcopymonomsc_cns(ca_obj_vardnsexpdegspsterm_t C,ca_vardnsmonom_t m,ca_obj_t s,ca_obj_vardnsexpdegspsterm_args args)
{
    ca_obj_vardnsexpdegspsterm_t new = ca_obj_vardnsexpdegspsterm_alloc(args);
    
    ca_obj_deepcopy(ca_obj_vardnsexpdegspsterm_scal_cval(new,args),s,args.sargs);
    ca_vardnsmonom_copy(ca_obj_vardnsexpdegspsterm_monom_cval(new),m,args.margs);
    
    assert(ca_obj_vardnsexpdegspsterm_check(new,args));return ca_obj_vardnsexpdegspsterm_cns(C,new);
}

static void ca_obj_vardnsexpdegspsterm_deepcopymonomsc(ca_obj_vardnsexpdegspsterm_t C,ca_vardnsmonom_t m,ca_obj_t s,ca_obj_vardnsexpdegspsterm_t CT,ca_obj_vardnsexpdegspsterm_args args)
{
    ca_obj_vardnsexpdegspsterm_glue(ca_obj_vardnsexpdegspsterm_deepcopymonomsc_cns(C,m,s,args),CT);
}

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspsterm_copy_cns(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_args args)
{
    return ca_obj_vardnsexpdegspsterm_copymonomsc_cns(C,ca_obj_vardnsexpdegspsterm_monom(A),ca_obj_vardnsexpdegspsterm_scal(A,args),args);
}

static void ca_obj_vardnsexpdegspsterm_copy(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_t CT,ca_obj_vardnsexpdegspsterm_args args)
{
    ca_obj_vardnsexpdegspsterm_glue(ca_obj_vardnsexpdegspsterm_copy_cns(C,A,args),CT);
}

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspsterm_deepcopy_cns(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_args args)
{
    return ca_obj_vardnsexpdegspsterm_deepcopymonomsc_cns(C,ca_obj_vardnsexpdegspsterm_monom(A),ca_obj_vardnsexpdegspsterm_scal(A,args),args);
}

static void ca_obj_vardnsexpdegspsterm_deepcopy(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_t CT,ca_obj_vardnsexpdegspsterm_args args)
{
    ca_obj_vardnsexpdegspsterm_glue(ca_obj_vardnsexpdegspsterm_deepcopy_cns(C,A,args),CT);
}

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspsterm_ooneg_cns(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_args args)
{
    ca_obj_vardnsexpdegspsterm_t new = ca_obj_vardnsexpdegspsterm_alloc(args);
    assert(ca_obj_vardnsexpdegspsterm_iszero(A,args) == NO);

    ca_obj_ooneg(ca_obj_vardnsexpdegspsterm_scal_cval(new,args),ca_obj_vardnsexpdegspsterm_scal(A,args),args.sargs);
    ca_vardnsmonom_copy(ca_obj_vardnsexpdegspsterm_monom_cval(new),ca_obj_vardnsexpdegspsterm_monom(A),args.margs);
    
    return ca_obj_vardnsexpdegspsterm_cns(C,new);
}

static void ca_obj_vardnsexpdegspsterm_ooneg(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_t CT,ca_obj_vardnsexpdegspsterm_args args)
{
    ca_obj_vardnsexpdegspsterm_glue(ca_obj_vardnsexpdegspsterm_ooneg_cns(C,A,args),CT);
}

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspsterm_inneg(ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_args args)
{
    assert(ca_obj_vardnsexpdegspsterm_iszero(A,args) == NO);
    ca_obj_inneg(ca_obj_vardnsexpdegspsterm_scal_cval(A,args),args.sargs);
    assert(ca_obj_vardnsexpdegspsterm_iszero(A,args) == NO);
    return A->nlink;
}

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspsterm_oonegv_cns(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,int v,ca_obj_vardnsexpdegspsterm_args args)
{
    return (v == -1)?ca_obj_vardnsexpdegspsterm_ooneg_cns(C,A,args):ca_obj_vardnsexpdegspsterm_copy_cns(C,A,args);
}

static void ca_obj_vardnsexpdegspsterm_oonegv(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,int v,ca_obj_vardnsexpdegspsterm_t CT,ca_obj_vardnsexpdegspsterm_args args)
{
    ca_obj_vardnsexpdegspsterm_glue(ca_obj_vardnsexpdegspsterm_oonegv_cns(C,A,v,args),CT);
}

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspsterm_innegv(ca_obj_vardnsexpdegspsterm_t A,int v,ca_obj_vardnsexpdegspsterm_args args)
{
    return (v == -1)?ca_obj_vardnsexpdegspsterm_inneg(A,args):A->nlink;
}

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspsterm_oodbl_cns(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,int v,ca_obj_vardnsexpdegspsterm_args args)
{
    ca_obj_vardnsexpdegspsterm_t new = ca_obj_vardnsexpdegspsterm_alloc(args);
    assert(ca_obj_vardnsexpdegspsterm_iszero(A,args) == NO);

    ca_obj_oodbl(ca_obj_vardnsexpdegspsterm_scal_cval(new,args),ca_obj_vardnsexpdegspsterm_scal(A,args),v,args.sargs);
    ca_vardnsmonom_copy(ca_obj_vardnsexpdegspsterm_monom_cval(new),ca_obj_vardnsexpdegspsterm_monom(A),args.margs);
    
    return ca_obj_vardnsexpdegspsterm_condcns(C,new,args);
}

static void ca_obj_vardnsexpdegspsterm_oodbl(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,int v,ca_obj_vardnsexpdegspsterm_t CT,ca_obj_vardnsexpdegspsterm_args args)
{
    ca_obj_vardnsexpdegspsterm_glue(ca_obj_vardnsexpdegspsterm_oodbl_cns(C,A,v,args),CT);
}

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspsterm_indbl(ca_obj_vardnsexpdegspsterm_t A,int v,ca_obj_vardnsexpdegspsterm_args args)
{
    assert(ca_obj_vardnsexpdegspsterm_iszero(A,args) == NO);
    ca_obj_indbl(ca_obj_vardnsexpdegspsterm_scal_cval(A,args),v,args.sargs);
    return ca_obj_vardnsexpdegspsterm_conddelete(A,args);
}

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspsterm_ooaddsc_cns(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,int v,ca_obj_t B,int w,ca_obj_vardnsexpdegspsterm_args args)
{
    ca_obj_vardnsexpdegspsterm_t new = ca_obj_vardnsexpdegspsterm_alloc(args);
    ca_obj_ooadd(ca_obj_vardnsexpdegspsterm_scal_cval(new,args),ca_obj_vardnsexpdegspsterm_scal(A,args),v,B,w,args.sargs);
    ca_vardnsmonom_copy(ca_obj_vardnsexpdegspsterm_monom_cval(new),ca_obj_vardnsexpdegspsterm_monom(A),args.margs);
    return ca_obj_vardnsexpdegspsterm_condcns(C,new,args);
}

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspsterm_inaddsc(ca_obj_vardnsexpdegspsterm_t A,int v,ca_obj_t B,int w,ca_obj_vardnsexpdegspsterm_args args)
{
    ca_obj_inadd(ca_obj_vardnsexpdegspsterm_scal_cval(A,args),v,B,w,args.sargs);
    return ca_obj_vardnsexpdegspsterm_conddelete(A,args);
}

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspsterm_ooadd_cns(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,int v,ca_obj_vardnsexpdegspsterm_t B,int w,ca_obj_vardnsexpdegspsterm_args args)
{
    assert(0 == ca_obj_vardnsexpdegspsterm_cmp(A,B,args));
    assert(ca_obj_vardnsexpdegspsterm_iszero(A,args) == NO && ca_obj_vardnsexpdegspsterm_iszero(B,args) == NO);
    return ca_obj_vardnsexpdegspsterm_ooaddsc_cns(C,A,v,ca_obj_vardnsexpdegspsterm_scal(B,args),w,args);
}

static void ca_obj_vardnsexpdegspsterm_ooadd(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,int v,ca_obj_vardnsexpdegspsterm_t B,int w,ca_obj_vardnsexpdegspsterm_t CT,ca_obj_vardnsexpdegspsterm_args args)
{
    ca_obj_vardnsexpdegspsterm_glue(ca_obj_vardnsexpdegspsterm_ooadd_cns(C,A,v,B,w,args),CT);
}

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspsterm_inadd(ca_obj_vardnsexpdegspsterm_t A,int v,ca_obj_vardnsexpdegspsterm_t B,int w,ca_obj_vardnsexpdegspsterm_args args)
{
    assert(0 == ca_obj_vardnsexpdegspsterm_cmp(A,B,args));
    assert(ca_obj_vardnsexpdegspsterm_iszero(A,args) == NO && ca_obj_vardnsexpdegspsterm_iszero(B,args) == NO);
    return ca_obj_vardnsexpdegspsterm_inaddsc(A,v,ca_obj_vardnsexpdegspsterm_scal(B,args),w,args);
}

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspsterm_oomulsc_cns(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,ca_obj_t s,int v,ca_obj_vardnsexpdegspsterm_args args)
{
    ca_obj_vardnsexpdegspsterm_t new = ca_obj_vardnsexpdegspsterm_alloc(args);

    ca_obj_oomulv(ca_obj_vardnsexpdegspsterm_scal_cval(new,args),ca_obj_vardnsexpdegspsterm_scal(A,args),s,v,args.sargs);
    ca_vardnsmonom_copy(ca_obj_vardnsexpdegspsterm_monom_cval(new),ca_obj_vardnsexpdegspsterm_monom(A),args.margs);
    
    return ca_obj_vardnsexpdegspsterm_condcns(C,new,args);
}

static void ca_obj_vardnsexpdegspsterm_oomulsc(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A, ca_obj_t s,int v,ca_obj_vardnsexpdegspsterm_t CT,ca_obj_vardnsexpdegspsterm_args args)
{
    ca_obj_vardnsexpdegspsterm_glue(ca_obj_vardnsexpdegspsterm_oomulsc_cns(C,A,s,v,args),CT);
}

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspsterm_inmulsc(ca_obj_vardnsexpdegspsterm_t A, ca_obj_t s,int v,ca_obj_vardnsexpdegspsterm_args args)
{
    ca_obj_inmulv(ca_obj_vardnsexpdegspsterm_scal_cval(A,args),s,v,args.sargs);
    return ca_obj_vardnsexpdegspsterm_conddelete(A,args);
}

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspsterm_oomulmonomsc_cns(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,ca_vardnsmonom_t m,ca_obj_t s,int v,ca_obj_vardnsexpdegspsterm_args args)
{
    ca_obj_vardnsexpdegspsterm_t new = ca_obj_vardnsexpdegspsterm_alloc(args);

    ca_obj_oomulv(ca_obj_vardnsexpdegspsterm_scal_cval(new,args),ca_obj_vardnsexpdegspsterm_scal(A,args),s,v,args.sargs);
    ca_vardnsmonom_oomul(ca_obj_vardnsexpdegspsterm_monom_cval(new),ca_obj_vardnsexpdegspsterm_monom(A),m,args.margs);
    
    return ca_obj_vardnsexpdegspsterm_condcns(C,new,args);
}

static void ca_obj_vardnsexpdegspsterm_oomulmonomsc(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,ca_vardnsmonom_t m, ca_obj_t s,int v,ca_obj_vardnsexpdegspsterm_t CT,ca_obj_vardnsexpdegspsterm_args args)
{
    ca_obj_vardnsexpdegspsterm_glue(ca_obj_vardnsexpdegspsterm_oomulmonomsc_cns(C,A,m,s,v,args),CT);
}

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspsterm_inmulmonomsc(ca_obj_vardnsexpdegspsterm_t A,ca_vardnsmonom_t m, ca_obj_t s,int v,ca_obj_vardnsexpdegspsterm_args args)
{
    ca_obj_inmulv(ca_obj_vardnsexpdegspsterm_scal_cval(A,args),s,v,args.sargs);
    ca_vardnsmonom_inmul(ca_obj_vardnsexpdegspsterm_monom_cval(A),m,args.margs);

    return ca_obj_vardnsexpdegspsterm_conddelete(A,args);
}

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspsterm_ooaddscmulsc_cns(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,int v,ca_obj_t B,ca_obj_t t,int w,ca_obj_vardnsexpdegspsterm_args args)
{
    ca_obj_vardnsexpdegspsterm_t new = ca_obj_vardnsexpdegspsterm_alloc(args);

    ca_obj_ooaddmul(ca_obj_vardnsexpdegspsterm_scal_cval(new,args),ca_obj_vardnsexpdegspsterm_scal(A,args),v,B,t,w,args.sargs);
    ca_vardnsmonom_copy(ca_obj_vardnsexpdegspsterm_monom_cval(new),ca_obj_vardnsexpdegspsterm_monom(A),args.margs);
    
    return ca_obj_vardnsexpdegspsterm_condcns(C,new,args);
}

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspsterm_inaddscmulsc(ca_obj_vardnsexpdegspsterm_t A,int v,ca_obj_t B,ca_obj_t t,int w,ca_obj_vardnsexpdegspsterm_args args)
{
    ca_obj_inaddmul(ca_obj_vardnsexpdegspsterm_scal_cval(A,args),v,B,t,w,args.sargs);
    return ca_obj_vardnsexpdegspsterm_conddelete(A,args);
}

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspsterm_ooaddmulsc_cns(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,int v,ca_obj_vardnsexpdegspsterm_t B,ca_obj_t t,int w,ca_obj_vardnsexpdegspsterm_args args)
{
    assert(0 == (ca_obj_vardnsexpdegspsterm_cmp(A,B,args)));
    return ca_obj_vardnsexpdegspsterm_ooaddscmulsc_cns(C,A,v,ca_obj_vardnsexpdegspsterm_scal(B,args),t,w,args);
}

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspsterm_ooaddmulmonomsc_cns(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,int v,ca_obj_vardnsexpdegspsterm_t B,ca_vardnsmonom_t m,ca_obj_t t,int w,ca_obj_vardnsexpdegspsterm_args args)
{
    assert(0 == (ca_obj_vardnsexpdegspsterm_cmpmul(A,B,m,args)));
    return ca_obj_vardnsexpdegspsterm_ooaddmulsc_cns(C,A,v,B,t,w,args);
}

static void ca_obj_vardnsexpdegspsterm_ooaddmulsc(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,int v,ca_obj_vardnsexpdegspsterm_t B,ca_obj_t t,int w,ca_obj_vardnsexpdegspsterm_t CT,ca_obj_vardnsexpdegspsterm_args args)
{
    ca_obj_vardnsexpdegspsterm_glue(ca_obj_vardnsexpdegspsterm_ooaddmulsc_cns(C,A,v,B,t,w,args),CT);
}

static void ca_obj_vardnsexpdegspsterm_ooaddmulmonomsc(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,int v,ca_obj_vardnsexpdegspsterm_t B,ca_vardnsmonom_t m, ca_obj_t t,int w,ca_obj_vardnsexpdegspsterm_t CT,ca_obj_vardnsexpdegspsterm_args args)
{
    ca_obj_vardnsexpdegspsterm_glue(ca_obj_vardnsexpdegspsterm_ooaddmulmonomsc_cns(C,A,v,B,m,t,w,args),CT);
}

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspsterm_inaddmulsc(ca_obj_vardnsexpdegspsterm_t A,int v,ca_obj_vardnsexpdegspsterm_t B,ca_obj_t t,int w,ca_obj_vardnsexpdegspsterm_args args)
{
    assert(0 == (ca_obj_vardnsexpdegspsterm_cmp(A,B,args)));
    return ca_obj_vardnsexpdegspsterm_inaddscmulsc(A,v,ca_obj_vardnsexpdegspsterm_scal(B,args),t,w,args);
}

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspsterm_inaddmulmonomsc(ca_obj_vardnsexpdegspsterm_t A,int v,ca_obj_vardnsexpdegspsterm_t B,ca_vardnsmonom_t m, ca_obj_t t,int w,ca_obj_vardnsexpdegspsterm_args args)
{
    assert(0 == (ca_obj_vardnsexpdegspsterm_cmpmul(A,B,m,args)));
    return ca_obj_vardnsexpdegspsterm_inaddscmulsc(A,v,ca_obj_vardnsexpdegspsterm_scal(B,args),t,w,args);
}

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspsterm_oomulscaddsc_cns(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,ca_obj_t s,int v,ca_obj_t B,int w,ca_obj_vardnsexpdegspsterm_args args)
{
    ca_obj_vardnsexpdegspsterm_t new = ca_obj_vardnsexpdegspsterm_alloc(args);

    ca_obj_oomuladd(ca_obj_vardnsexpdegspsterm_scal_cval(new,args),ca_obj_vardnsexpdegspsterm_scal(A,args),s,v,B,w,args.sargs);
    ca_vardnsmonom_copy(ca_obj_vardnsexpdegspsterm_monom_cval(new),ca_obj_vardnsexpdegspsterm_monom(A),args.margs);
    
    return ca_obj_vardnsexpdegspsterm_condcns(C,new,args);
}

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspsterm_inmulscaddsc(ca_obj_vardnsexpdegspsterm_t A,ca_obj_t s,int v,ca_obj_t B,int w,ca_obj_vardnsexpdegspsterm_args args)
{
    ca_obj_inmuladd(ca_obj_vardnsexpdegspsterm_scal_cval(A,args),s,v,B,w,args.sargs);
    return ca_obj_vardnsexpdegspsterm_conddelete(A,args);
}

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspsterm_oomulscadd_cns(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,ca_obj_t s,int v,ca_obj_vardnsexpdegspsterm_t B,int w,ca_obj_vardnsexpdegspsterm_args args)
{
    assert(0 == (ca_obj_vardnsexpdegspsterm_cmp(A,B,args)));
    return ca_obj_vardnsexpdegspsterm_oomulscaddsc_cns(C,A,s,v,ca_obj_vardnsexpdegspsterm_scal(B,args),w,args);
}

static void ca_obj_vardnsexpdegspsterm_oomulscadd(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,ca_obj_t s,int v,ca_obj_vardnsexpdegspsterm_t B,int w,ca_obj_vardnsexpdegspsterm_t CT,ca_obj_vardnsexpdegspsterm_args args)
{
    ca_obj_vardnsexpdegspsterm_glue(ca_obj_vardnsexpdegspsterm_oomulscadd_cns(C,A,s,v,B,w,args),CT);
}

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspsterm_inmulscadd(ca_obj_vardnsexpdegspsterm_t A,ca_obj_t s,int v,ca_obj_vardnsexpdegspsterm_t B,int w,ca_obj_vardnsexpdegspsterm_args args)
{
    assert(0 == (ca_obj_vardnsexpdegspsterm_cmp(A,B,args)));
    return ca_obj_vardnsexpdegspsterm_inmulscaddsc(A,s,v,ca_obj_vardnsexpdegspsterm_scal(B,args),w,args);
}

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspsterm_oomulscaddscmulsc_cns(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,ca_obj_t s,int v,ca_obj_t B,ca_obj_t t,int w,ca_obj_vardnsexpdegspsterm_args args)
{
    ca_obj_vardnsexpdegspsterm_t new = ca_obj_vardnsexpdegspsterm_alloc(args);
    ca_obj_oomuladdmul(ca_obj_vardnsexpdegspsterm_scal_cval(new,args),ca_obj_vardnsexpdegspsterm_scal(A,args),s,v,B,t,w,args.sargs);
    ca_vardnsmonom_copy(ca_obj_vardnsexpdegspsterm_monom_cval(new),ca_obj_vardnsexpdegspsterm_monom(A),args.margs);
    
    return ca_obj_vardnsexpdegspsterm_condcns(C,new,args);
}

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspsterm_inmulscaddscmulsc(ca_obj_vardnsexpdegspsterm_t A,ca_obj_t s,int v,ca_obj_t B,ca_obj_t t,int w,ca_obj_vardnsexpdegspsterm_args args)
{
    ca_obj_inmuladdmul(ca_obj_vardnsexpdegspsterm_scal_cval(A,args),s,v,B,t,w,args.sargs);
    return ca_obj_vardnsexpdegspsterm_conddelete(A,args);
}

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspsterm_oomulscaddmulsc_cns(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,ca_obj_t s,int v,ca_obj_vardnsexpdegspsterm_t B,ca_obj_t t,int w,ca_obj_vardnsexpdegspsterm_args args)
{
    assert(0 == (ca_obj_vardnsexpdegspsterm_cmp(A,B,args)));
    return ca_obj_vardnsexpdegspsterm_oomulscaddscmulsc_cns(C,A,s,v,ca_obj_vardnsexpdegspsterm_scal(B,args),t,w,args);
}

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspsterm_oomulscaddmulmonomsc_cns(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,ca_obj_t s,int v,ca_obj_vardnsexpdegspsterm_t B,ca_vardnsmonom_t m,ca_obj_t t,int w,ca_obj_vardnsexpdegspsterm_args args)
{
    assert(0 == (ca_obj_vardnsexpdegspsterm_cmpmul(A,B,m,args)));
    return ca_obj_vardnsexpdegspsterm_oomulscaddscmulsc_cns(C,A,s,v,ca_obj_vardnsexpdegspsterm_scal(B,args),t,w,args);
}

static void ca_obj_vardnsexpdegspsterm_oomulscaddmulsc(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,ca_obj_t s,int v,ca_obj_vardnsexpdegspsterm_t B,ca_obj_t t,int w,ca_obj_vardnsexpdegspsterm_t CT,ca_obj_vardnsexpdegspsterm_args args)
{
    ca_obj_vardnsexpdegspsterm_glue(ca_obj_vardnsexpdegspsterm_oomulscaddmulsc_cns(C,A,s,v,B,t,w,args),CT);
}

static void ca_obj_vardnsexpdegspsterm_oomulscaddmulmonomsc(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,ca_obj_t s,int v,ca_obj_vardnsexpdegspsterm_t B,ca_vardnsmonom_t m, ca_obj_t t,int w,ca_obj_vardnsexpdegspsterm_t CT,ca_obj_vardnsexpdegspsterm_args args)
{
    ca_obj_vardnsexpdegspsterm_glue(ca_obj_vardnsexpdegspsterm_oomulscaddmulmonomsc_cns(C,A,s,v,B,m,t,w,args),CT);
}

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspsterm_inmulscaddmulsc(ca_obj_vardnsexpdegspsterm_t A,ca_obj_t s,int v,ca_obj_vardnsexpdegspsterm_t B,ca_obj_t t,int w,ca_obj_vardnsexpdegspsterm_args args)
{
    assert(0 == (ca_obj_vardnsexpdegspsterm_cmp(A,B,args)));
    return ca_obj_vardnsexpdegspsterm_inmulscaddscmulsc(A,s,v,ca_obj_vardnsexpdegspsterm_scal(B,args),t,w,args);
}

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspsterm_inmulscaddmulmonomsc(ca_obj_vardnsexpdegspsterm_t A,ca_obj_t s,int v,ca_obj_vardnsexpdegspsterm_t B,ca_vardnsmonom_t m, ca_obj_t t,int w,ca_obj_vardnsexpdegspsterm_args args)
{
    assert(0 == (ca_obj_vardnsexpdegspsterm_cmpmul(A,B,m,args)));
    return ca_obj_vardnsexpdegspsterm_inmulscaddscmulsc(A,s,v,ca_obj_vardnsexpdegspsterm_scal(B,args),t,w,args);
}

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspsterm_oodivsc_cns(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,ca_obj_t s,ca_obj_vardnsexpdegspsterm_args args)
{
    BOOL failed;
    ca_obj_vardnsexpdegspsterm_t new = ca_obj_vardnsexpdegspsterm_alloc(args);

    failed = ca_obj_oodiv(ca_obj_vardnsexpdegspsterm_scal_cval(new,args),ca_obj_vardnsexpdegspsterm_scal(A,args),s,args.sargs);
    if (failed) {
	ca_obj_vardnsexpdegspsterm_free(new,args);return NULL;
    }
    
    ca_vardnsmonom_copy(ca_obj_vardnsexpdegspsterm_monom_cval(new),ca_obj_vardnsexpdegspsterm_monom(A),args.margs);
    
    return ca_obj_vardnsexpdegspsterm_condcns(C,new,args);
}

#if 0 /* unused ! why did I write this ? */
static BOOL ca_obj_vardnsexpdegspsterm_oodivsc(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A, ca_obj_t s,ca_obj_vardnsexpdegspsterm_t CT,ca_obj_vardnsexpdegspsterm_args args)
{
    if ((C = ca_obj_vardnsexpdegspsterm_oodivsc_cns(C,A,s,args))) {
	ca_obj_vardnsexpdegspsterm_glue(C,CT);return SUCCESS;
    } else {
	return FAILURE;
    }
}
#endif

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspsterm_indivsc(ca_obj_vardnsexpdegspsterm_t A, ca_obj_t s,ca_obj_vardnsexpdegspsterm_args args)
{
    ca_obj_indiv(ca_obj_vardnsexpdegspsterm_scal_cval(A,args),s,args.sargs);
    return ca_obj_vardnsexpdegspsterm_conddelete(A,args);
}

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspsterm_oodivmonomsc_cns(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,ca_vardnsmonom_t m,ca_obj_t s,ca_obj_vardnsexpdegspsterm_args args)
{
    BOOL sfailed,mfailed;
    ca_obj_vardnsexpdegspsterm_t new = ca_obj_vardnsexpdegspsterm_alloc(args);

    sfailed = ca_obj_oodiv(ca_obj_vardnsexpdegspsterm_scal_cval(new,args),ca_obj_vardnsexpdegspsterm_scal(A,args),s,args.sargs);
    mfailed = ca_vardnsmonom_oodiv(ca_obj_vardnsexpdegspsterm_monom_cval(new),ca_obj_vardnsexpdegspsterm_monom(A),m,args.margs);
    
    if (sfailed || mfailed) {
	/* both failures are possible in the multivariate case */
	ca_obj_vardnsexpdegspsterm_free(new,args);return NULL;
    }
    
    return ca_obj_vardnsexpdegspsterm_condcns(C,new,args);
}

#if 0 /* unused ! why did I write this ? */
static BOOL ca_obj_vardnsexpdegspsterm_oodivmonomsc(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,ca_vardnsmonom_t m, ca_obj_t s,ca_obj_vardnsexpdegspsterm_t CT,ca_obj_vardnsexpdegspsterm_args args)
{
    if ((C = ca_obj_vardnsexpdegspsterm_oodivmonomsc_cns(C,A,m,s,args))) {
	ca_obj_vardnsexpdegspsterm_glue(C,CT);return SUCCESS;
    } else {
	return FAILURE;
    }
}
#endif

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspsterm_indivmonomsc(ca_obj_vardnsexpdegspsterm_t A,ca_vardnsmonom_t m, ca_obj_t s,ca_obj_vardnsexpdegspsterm_args args)
{
    ca_obj_indiv(ca_obj_vardnsexpdegspsterm_scal_cval(A,args),s,args.sargs);
    ca_vardnsmonom_indiv(ca_obj_vardnsexpdegspsterm_monom_cval(A),m,args.margs);

    return ca_obj_vardnsexpdegspsterm_conddelete(A,args);
}

static void ca_obj_vardnsexpdegspsterm_args_fileOut(id aFiler,ca_obj_vardnsexpdegspsterm_args *args)
{
    ca_obj_args_fileOut(aFiler,&args->sargs);
    ca_vardnsmonom_args_fileOut(aFiler,&args->margs);
}
static void ca_obj_vardnsexpdegspsterm_args_fileIn(id aFiler,ca_obj_vardnsexpdegspsterm_args *args)
{
    ca_obj_args_fileIn(aFiler,&args->sargs);
    ca_vardnsmonom_args_fileIn(aFiler,&args->margs);
}

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspsterm_fileOut(id aFiler,ca_obj_vardnsexpdegspsterm_t self ,ca_obj_vardnsexpdegspsterm_args args)
{
    assert(ca_obj_vardnsexpdegspsterm_check(self,args));
    
    ca_obj_fileOut(aFiler,ca_obj_vardnsexpdegspsterm_scal_cval(self,args),args.sargs);
    ca_vardnsmonom_fileOut(aFiler,ca_obj_vardnsexpdegspsterm_monom_cval(self),args.margs);
    
    return self->nlink;
}

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspsterm_fileIn_cns(id aFiler,ca_obj_vardnsexpdegspsterm_t C ,ca_obj_vardnsexpdegspsterm_args args)
{
    ca_obj_vardnsexpdegspsterm_t self = ca_obj_vardnsexpdegspsterm_alloc(args);
    
    ca_obj_fileIn(aFiler,ca_obj_vardnsexpdegspsterm_scal_cval(self,args),args.sargs);
    ca_vardnsmonom_fileIn(aFiler,ca_obj_vardnsexpdegspsterm_monom_cval(self),args.margs);
    
    return ca_obj_vardnsexpdegspsterm_cns(C,self);
}

static int ca_obj_vardnsexpdegspslist_check(ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_t AT,ca_obj_vardnsexpdegspsterm_args args)
{
    ca_obj_vardnsexpdegspsterm_t prev;
    
    for(prev = NULL;A!=AT;prev = A,A = A->nlink) {
	if (ca_obj_vardnsexpdegspsterm_check(A,args) == 0) return 0;
	if (prev && ca_obj_vardnsexpdegspsterm_cmp(prev,A,args) <= 0) return 0;
    }
    
    return 1;
}

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspslist_copy_cns(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_t AT,ca_obj_vardnsexpdegspsterm_args args)
{
    while (A != AT) { C = ca_obj_vardnsexpdegspsterm_copy_cns(C,A,args);A = A->nlink; }
    return C;
}

static void ca_obj_vardnsexpdegspslist_copy(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_t AT,ca_obj_vardnsexpdegspsterm_t CT,ca_obj_vardnsexpdegspsterm_args args)
{
    ca_obj_vardnsexpdegspsterm_glue(ca_obj_vardnsexpdegspslist_copy_cns(C,A,AT,args),CT);
}

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspslist_deepcopy_cns(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_t AT,ca_obj_vardnsexpdegspsterm_args args)
{
    while (A != AT) { C = ca_obj_vardnsexpdegspsterm_deepcopy_cns(C,A,args);A = A->nlink; }
    return C;
}

static void ca_obj_vardnsexpdegspslist_deepcopy(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_t AT,ca_obj_vardnsexpdegspsterm_t CT,ca_obj_vardnsexpdegspsterm_args args)
{
    ca_obj_vardnsexpdegspsterm_glue(ca_obj_vardnsexpdegspslist_deepcopy_cns(C,A,AT,args),CT);
}

static void ca_obj_vardnsexpdegspslist_clear(ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_t AT,ca_obj_vardnsexpdegspsterm_args args)
{
    while (A != AT) { ca_obj_vardnsexpdegspsterm_clear(A,args);A = A->nlink; }
}

static void ca_obj_vardnsexpdegspslist_free(ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_t AT,ca_obj_vardnsexpdegspsterm_args args)
{
    ca_obj_vardnsexpdegspsterm_t t;for(;A!=AT;A=t) { t = A->nlink;ca_obj_vardnsexpdegspsterm_free(A,args); }
}

static int ca_obj_vardnsexpdegspslist_count(ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_t AT)
{
    int c = 0;for(;A!=AT;A=A->nlink) c++;return c;
}

static unsigned ca_obj_vardnsexpdegspslist_hash(ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_t AT,ca_obj_vardnsexpdegspsterm_args args)
{
    return ca_obj_vardnsexpdegspslist_count(A,AT);
}

static int ca_obj_vardnsexpdegspslist_iseq(ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_t AT,ca_obj_vardnsexpdegspsterm_t B, ca_obj_vardnsexpdegspsterm_t BT,ca_obj_vardnsexpdegspsterm_args args)
{
    for(;A!=AT&&B!=BT;A=A->nlink,B=B->nlink) {
	if (!ca_obj_vardnsexpdegspsterm_iseq(A,B,args)) return 0;
    }
    return (A==AT && B==BT);
}

static int ca_obj_vardnsexpdegspslist_isop(ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_t AT,ca_obj_vardnsexpdegspsterm_t B,ca_obj_vardnsexpdegspsterm_t BT,ca_obj_vardnsexpdegspsterm_args args)
{
    for(;A!=AT&&B!=BT;A=A->nlink,B=B->nlink) {
	if (!ca_obj_vardnsexpdegspsterm_isop(A,B,args)) return 0;
    }
    return (A==AT && B==BT);
}

static int ca_obj_vardnsexpdegspslist_deg(ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_t AT,ca_obj_vardnsexpdegspsterm_args args)
{
    return (A==AT)?-1:ca_obj_vardnsexpdegspsterm_deg(A,args);
}

static int ca_obj_vardnsexpdegspslist_maxdeg(ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_t AT,ca_obj_vardnsexpdegspsterm_args args)
{
    int max = (A==AT)?-1:ca_obj_vardnsexpdegspsterm_deg(A,args);
    for(A=A->nlink;A != AT;A = A->nlink) {
	int d = ca_obj_vardnsexpdegspsterm_deg(A,args);if (max < d) max = d;
    }
    return max;
}

static int ca_obj_vardnsexpdegspslist_ord(ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_t AT,ca_obj_vardnsexpdegspsterm_args args)
{
    return (A==AT)?-1:ca_obj_vardnsexpdegspsterm_deg(AT->plink,args);
}

static int ca_obj_vardnsexpdegspslist_mindeg(ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_t AT,ca_obj_vardnsexpdegspsterm_args args)
{
    int min = (A==AT)?-1:ca_obj_vardnsexpdegspsterm_deg(A,args);
    for(A=A->nlink;A != AT;A = A->nlink) {
	int d = ca_obj_vardnsexpdegspsterm_deg(A,args);if (min > d) min = d;
    }
    return min;
}

static void ca_obj_vardnsexpdegspslist_insert(ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_t AT,ca_vardnsmonom_t m,ca_obj_t s,ca_obj_vardnsexpdegspsterm_args args)
{
    assert(ca_obj_iszero(s,args.sargs) == NO);
    
    /* adding to zero */
    if (A == AT) {
	ca_obj_vardnsexpdegspsterm_copymonomsc(A,m,s,A,args);return;
    }
    
    /* tail append */
    if (ca_obj_vardnsexpdegspsterm_cmpmonom(AT->plink,m,args) > 0) {
	ca_obj_vardnsexpdegspsterm_copymonomsc(AT->plink,m,s,AT,args);return;
    }
    
    /* insertion */
    while (A != AT) {
	int cmp = ca_obj_vardnsexpdegspsterm_cmpmonom(A,m,args);
	if (cmp == 0) {
	    ca_obj_vardnsexpdegspsterm_inaddsc(A,+1,s,+1,args);return;
	}
	if (cmp < 0) {
	    ca_obj_vardnsexpdegspsterm_copymonomsc(A->plink,m,s,A,args);return;
	}
	A = A->nlink;
    }
 
    fprintf(stderr,"Shouldn't happen\n");
}

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspslist_ooneg_cns(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_t AT,ca_obj_vardnsexpdegspsterm_args args)
{
    while (A != AT) {
	C = ca_obj_vardnsexpdegspsterm_ooneg_cns(C,A,args);
	A = A->nlink;
    }
    return C;
}

static void ca_obj_vardnsexpdegspslist_ooneg(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_t AT,ca_obj_vardnsexpdegspsterm_t CT,ca_obj_vardnsexpdegspsterm_args args)
{
    ca_obj_vardnsexpdegspsterm_glue(ca_obj_vardnsexpdegspslist_ooneg_cns(C,A,AT,args),CT);
}

static void ca_obj_vardnsexpdegspslist_inneg(ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_t AT,ca_obj_vardnsexpdegspsterm_args args)
{
    while (A != AT) A = ca_obj_vardnsexpdegspsterm_inneg(A,args);
}

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspslist_oonegv_cns(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_t AT,int v,ca_obj_vardnsexpdegspsterm_args args)
{
    if (v == -1) {
	return ca_obj_vardnsexpdegspslist_ooneg_cns(C,A,AT,args);
    } else {
	return ca_obj_vardnsexpdegspslist_copy_cns(C,A,AT,args);
    }
}

static void ca_obj_vardnsexpdegspslist_oonegv(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_t AT,int v,ca_obj_vardnsexpdegspsterm_t CT,ca_obj_vardnsexpdegspsterm_args args)
{
    ca_obj_vardnsexpdegspsterm_glue(ca_obj_vardnsexpdegspslist_oonegv_cns(C,A,AT,v,args),CT);
}

static void ca_obj_vardnsexpdegspslist_innegv(ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_t AT,int v,ca_obj_vardnsexpdegspsterm_args args)
{
    if (v == -1) ca_obj_vardnsexpdegspslist_inneg(A,AT,args);
}

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspslist_oodbl_cns(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_t AT,int v,ca_obj_vardnsexpdegspsterm_args args)
{
    while (A != AT) {
	C = ca_obj_vardnsexpdegspsterm_oodbl_cns(C,A,v,args);
	A = A->nlink;
    }
    return C;
}

static void ca_obj_vardnsexpdegspslist_oodbl(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_t AT,int v,ca_obj_vardnsexpdegspsterm_t CT,ca_obj_vardnsexpdegspsterm_args args)
{
    ca_obj_vardnsexpdegspsterm_glue(ca_obj_vardnsexpdegspslist_oodbl_cns(C,A,AT,v,args),CT);
}

static void ca_obj_vardnsexpdegspslist_indbl(ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_t AT,int v,ca_obj_vardnsexpdegspsterm_args args)
{
    while (A != AT) A = ca_obj_vardnsexpdegspsterm_indbl(A,v,args);
}

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspslist_ooadd_cns(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_t AT,int v,ca_obj_vardnsexpdegspsterm_t B,ca_obj_vardnsexpdegspsterm_t BT,int w,ca_obj_vardnsexpdegspsterm_args args)
{
    assert(A != B);
    
    while (A != AT && B != BT) {
	int cmp = ca_obj_vardnsexpdegspsterm_cmp(A,B,args);
	if (cmp == 0) {
	    C = ca_obj_vardnsexpdegspsterm_ooadd_cns(C,A,v,B,w,args);
	    A = A->nlink;B = B->nlink;continue;
	}
	if (cmp < 0) {
	    C = ca_obj_vardnsexpdegspsterm_oonegv_cns(C,B,w,args);
	    B = B->nlink;
	} else {
	    C = ca_obj_vardnsexpdegspsterm_oonegv_cns(C,A,v,args);
	    A = A->nlink;
	}
    }
 
    if (A != AT) return ca_obj_vardnsexpdegspslist_oonegv_cns(C,A,AT,v,args);
    if (B != BT) return ca_obj_vardnsexpdegspslist_oonegv_cns(C,B,BT,w,args);
    return C;
}

static void ca_obj_vardnsexpdegspslist_ooadd(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_t AT,int v,ca_obj_vardnsexpdegspsterm_t B,ca_obj_vardnsexpdegspsterm_t BT,int w,ca_obj_vardnsexpdegspsterm_t CT,ca_obj_vardnsexpdegspsterm_args args)
{
    ca_obj_vardnsexpdegspsterm_glue(ca_obj_vardnsexpdegspslist_ooadd_cns(C,A,AT,v,B,BT,w,args),CT);
}

static void ca_obj_vardnsexpdegspslist_inadd(ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_t AT,int v,ca_obj_vardnsexpdegspsterm_t B,ca_obj_vardnsexpdegspsterm_t BT,int w,ca_obj_vardnsexpdegspsterm_args args)
{
    assert(A != B);
    
    while (A != AT && B != BT) {
	int cmp = ca_obj_vardnsexpdegspsterm_cmp(A,B,args);
	if (cmp == 0) {
	    A = ca_obj_vardnsexpdegspsterm_inadd(A,v,B,w,args);
	    B = B->nlink;continue;
	}
	if (cmp < 0) {
	    ca_obj_vardnsexpdegspsterm_oonegv(A->plink,B,w,A,args);
	    B = B->nlink;
	} else {
	    A = ca_obj_vardnsexpdegspsterm_innegv(A,v,args);
	}
    }
 
    if (A != AT) ca_obj_vardnsexpdegspslist_innegv(A,AT,v,args);
    if (B != BT) ca_obj_vardnsexpdegspslist_oonegv(A->plink,B,BT,w,A,args);
}

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspslist_oomulsc_cns(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_t AT,ca_obj_t s,int v,ca_obj_vardnsexpdegspsterm_args args)
{
    while (A != AT) {
	C = ca_obj_vardnsexpdegspsterm_oomulsc_cns(C,A,s,v,args);
	A = A->nlink;
    }
    return C;
}

static void ca_obj_vardnsexpdegspslist_oomulsc(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_t AT,ca_obj_t s,int v,ca_obj_vardnsexpdegspsterm_t CT,ca_obj_vardnsexpdegspsterm_args args)
{
    ca_obj_vardnsexpdegspsterm_glue(ca_obj_vardnsexpdegspslist_oomulsc_cns(C,A,AT,s,v,args),CT);
}

static void ca_obj_vardnsexpdegspslist_inmulsc(ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_t AT,ca_obj_t s,int v,ca_obj_vardnsexpdegspsterm_args args)
{
    while (A != AT) A = ca_obj_vardnsexpdegspsterm_inmulsc(A,s,v,args);
}

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspslist_oomulmonomsc_cns(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_t AT,ca_vardnsmonom_t m,ca_obj_t s,int v,ca_obj_vardnsexpdegspsterm_args args)
{
    while (A != AT) {
	C = ca_obj_vardnsexpdegspsterm_oomulmonomsc_cns(C,A,m,s,v,args);
	A = A->nlink;
    }
    return C;
}

static void ca_obj_vardnsexpdegspslist_oomulmonomsc(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_t AT,ca_vardnsmonom_t m, ca_obj_t s,int v,ca_obj_vardnsexpdegspsterm_t CT,ca_obj_vardnsexpdegspsterm_args args)
{
    ca_obj_vardnsexpdegspsterm_glue(ca_obj_vardnsexpdegspslist_oomulmonomsc_cns(C,A,AT,m,s,v,args),CT);
}

static void ca_obj_vardnsexpdegspslist_inmulmonomsc(ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_t AT,ca_vardnsmonom_t m,ca_obj_t s,int v,ca_obj_vardnsexpdegspsterm_args args)
{
    while (A != AT) A = ca_obj_vardnsexpdegspsterm_inmulmonomsc(A,m,s,v,args);
}

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspslist_ooaddmulsc_cns(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_t AT,int v,ca_obj_vardnsexpdegspsterm_t B,ca_obj_vardnsexpdegspsterm_t BT,ca_obj_t t,int w,ca_obj_vardnsexpdegspsterm_args args)
{
    assert(A != B);
    
    while (A != AT && B != BT) {
	int cmp = ca_obj_vardnsexpdegspsterm_cmp(A,B,args);
	if (cmp == 0) {
	    C = ca_obj_vardnsexpdegspsterm_ooaddmulsc_cns(C,A,v,B,t,w,args);
	    A = A->nlink;B = B->nlink;continue;
	}
	if (cmp < 0) {
	    C = ca_obj_vardnsexpdegspsterm_oomulsc_cns(C,B,t,w,args);
	    B = B->nlink;
	} else {
	    C = ca_obj_vardnsexpdegspsterm_oonegv_cns(C,A,v,args);
	    A = A->nlink;
	}
    }
 
    if (A != AT) return ca_obj_vardnsexpdegspslist_oonegv_cns(C,A,AT,v,args);
    if (B != BT) return ca_obj_vardnsexpdegspslist_oomulsc_cns(C,B,BT,t,w,args);
    return C;
}

static void ca_obj_vardnsexpdegspslist_ooaddmulsc(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_t AT,int v,ca_obj_vardnsexpdegspsterm_t B,ca_obj_vardnsexpdegspsterm_t BT,ca_obj_t t,int w,ca_obj_vardnsexpdegspsterm_t CT,ca_obj_vardnsexpdegspsterm_args args)
{
    ca_obj_vardnsexpdegspsterm_glue(ca_obj_vardnsexpdegspslist_ooaddmulsc_cns(C,A,AT,v,B,BT,t,w,args),CT);
}

static void ca_obj_vardnsexpdegspslist_inaddmulsc(ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_t AT,int v,ca_obj_vardnsexpdegspsterm_t B,ca_obj_vardnsexpdegspsterm_t BT,ca_obj_t t,int w,ca_obj_vardnsexpdegspsterm_args args)
{
    assert(A != B);
    
    while (A != AT && B != BT) {
	int cmp = ca_obj_vardnsexpdegspsterm_cmp(A,B,args);
	if (cmp == 0) {
	    A = ca_obj_vardnsexpdegspsterm_inaddmulsc(A,v,B,t,w,args);
	    B = B->nlink;continue;
	}
	if (cmp < 0) {
	    ca_obj_vardnsexpdegspsterm_oomulsc(A->plink,B,t,w,A,args);
	    B = B->nlink;
	} else {
	    A = ca_obj_vardnsexpdegspsterm_innegv(A,v,args);
	}
    }
 
    if (A != AT) ca_obj_vardnsexpdegspslist_innegv(A,AT,v,args);
    if (B != BT) ca_obj_vardnsexpdegspslist_oomulsc(A->plink,B,BT,t,w,A,args);
}

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspslist_ooaddmulmonomsc_cns(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_t AT,int v,ca_obj_vardnsexpdegspsterm_t B,ca_obj_vardnsexpdegspsterm_t BT,ca_vardnsmonom_t m,ca_obj_t t,int w,ca_obj_vardnsexpdegspsterm_args args)
{
    assert(A != B);
    
    while (A != AT && B != BT) {
	int cmp = ca_obj_vardnsexpdegspsterm_cmpmul(A,B,m,args);
	if (cmp == 0) {
	    C = ca_obj_vardnsexpdegspsterm_ooaddmulmonomsc_cns(C,A,v,B,m,t,w,args);
	    A = A->nlink;B = B->nlink;continue;
	}
	if (cmp < 0) {
	    C = ca_obj_vardnsexpdegspsterm_oomulmonomsc_cns(C,B,m,t,w,args);
	    B = B->nlink;
	} else {
	    C = ca_obj_vardnsexpdegspsterm_oonegv_cns(C,A,v,args);
	    A = A->nlink;
	}
    }
 
    if (A != AT) return ca_obj_vardnsexpdegspslist_oonegv_cns(C,A,AT,v,args);
    if (B != BT) return ca_obj_vardnsexpdegspslist_oomulmonomsc_cns(C,B,BT,m,t,w,args);
    return C;
}

static void ca_obj_vardnsexpdegspslist_ooaddmulmonomsc(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_t AT,int v,ca_obj_vardnsexpdegspsterm_t B,ca_obj_vardnsexpdegspsterm_t BT,ca_vardnsmonom_t m, ca_obj_t t,int w,ca_obj_vardnsexpdegspsterm_t CT,ca_obj_vardnsexpdegspsterm_args args)
{
    ca_obj_vardnsexpdegspsterm_glue(ca_obj_vardnsexpdegspslist_ooaddmulmonomsc_cns(C,A,AT,v,B,BT,m,t,w,args),CT);
}

static void ca_obj_vardnsexpdegspslist_inaddmulmonomsc(ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_t AT,int v,ca_obj_vardnsexpdegspsterm_t B,ca_obj_vardnsexpdegspsterm_t BT,ca_vardnsmonom_t m,ca_obj_t t,int w,ca_obj_vardnsexpdegspsterm_args args)
{
    assert(A != B);
    
    while (A != AT && B != BT) {
	int cmp = ca_obj_vardnsexpdegspsterm_cmpmul(A,B,m,args);
	if (cmp == 0) {
	    A = ca_obj_vardnsexpdegspsterm_inaddmulmonomsc(A,v,B,m,t,w,args);
	    B = B->nlink;continue;
	}
	if (cmp < 0) {
	    ca_obj_vardnsexpdegspsterm_oomulmonomsc(A->plink,B,m,t,w,A,args);
	    B = B->nlink;
	} else {
	    A = ca_obj_vardnsexpdegspsterm_innegv(A,v,args);
	}
    }
 
    if (A != AT) ca_obj_vardnsexpdegspslist_innegv(A,AT,v,args);
    if (B != BT) ca_obj_vardnsexpdegspslist_oomulmonomsc(A->plink,B,BT,m,t,w,A,args);
}

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspslist_oomulscadd_cns(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_t AT,ca_obj_t s,int v,ca_obj_vardnsexpdegspsterm_t B,ca_obj_vardnsexpdegspsterm_t BT,int w,ca_obj_vardnsexpdegspsterm_args args)
{
    assert(A != B);
    
    while (A != AT && B != BT) {
	int cmp = ca_obj_vardnsexpdegspsterm_cmp(A,B,args);
	if (cmp == 0) {
	    C = ca_obj_vardnsexpdegspsterm_oomulscadd_cns(C,A,s,v,B,w,args);
	    A = A->nlink;B = B->nlink;continue;
	}
	if (cmp < 0) {
	    C = ca_obj_vardnsexpdegspsterm_oonegv_cns(C,B,w,args);
	    B = B->nlink;
	} else {
	    C = ca_obj_vardnsexpdegspsterm_oomulsc_cns(C,A,s,v,args);
	    A = A->nlink;
	}
    }
 
    if (A != AT) return ca_obj_vardnsexpdegspslist_oomulsc_cns(C,A,AT,s,v,args);
    if (B != BT) return ca_obj_vardnsexpdegspslist_oonegv_cns(C,B,BT,w,args);
    return C;
}

static void ca_obj_vardnsexpdegspslist_oomulscadd(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_t AT,ca_obj_t s,int v,ca_obj_vardnsexpdegspsterm_t B,ca_obj_vardnsexpdegspsterm_t BT, int w,ca_obj_vardnsexpdegspsterm_t CT,ca_obj_vardnsexpdegspsterm_args args)
{
    ca_obj_vardnsexpdegspsterm_glue(ca_obj_vardnsexpdegspslist_oomulscadd_cns(C,A,AT,s,v,B,BT,w,args),CT);
}

static void ca_obj_vardnsexpdegspslist_inmulscadd(ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_t AT,ca_obj_t s,int v,ca_obj_vardnsexpdegspsterm_t B,ca_obj_vardnsexpdegspsterm_t BT,int w,ca_obj_vardnsexpdegspsterm_args args)
{
    assert(A != B);
    
    while (A != AT && B != BT) {
	int cmp = ca_obj_vardnsexpdegspsterm_cmp(A,B,args);
	if (cmp == 0) {
	    A = ca_obj_vardnsexpdegspsterm_inmulscadd(A,s,v,B,w,args);
	    B = B->nlink;continue;
	}
	if (cmp < 0) {
	    ca_obj_vardnsexpdegspsterm_oonegv(A->plink,B,w,A,args);
	    B = B->nlink;
	} else {
	    A = ca_obj_vardnsexpdegspsterm_inmulsc(A,s,v,args);
	}
    }
 
    if (A != AT) ca_obj_vardnsexpdegspslist_inmulsc(A,AT,s,v,args);
    if (B != BT) ca_obj_vardnsexpdegspslist_oonegv(A->plink,B,BT,w,A,args);
}

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspslist_oomulscaddmulsc_cns(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_t AT,ca_obj_t s,int v,ca_obj_vardnsexpdegspsterm_t B,ca_obj_vardnsexpdegspsterm_t BT,ca_obj_t t,int w,ca_obj_vardnsexpdegspsterm_args args)
{
    assert(A != B);
    
    while (A != AT && B != BT) {
	int cmp = ca_obj_vardnsexpdegspsterm_cmp(A,B,args);
	if (cmp == 0) {
	    C = ca_obj_vardnsexpdegspsterm_oomulscaddmulsc_cns(C,A,s,v,B,t,w,args);
	    A = A->nlink;B = B->nlink;continue;
	}
	if (cmp < 0) {
	    C = ca_obj_vardnsexpdegspsterm_oomulsc_cns(C,B,t,w,args);
	    B = B->nlink;
	} else {
	    C = ca_obj_vardnsexpdegspsterm_oomulsc_cns(C,A,s,v,args);
	    A = A->nlink;
	}
    }
 
    if (A != AT) return ca_obj_vardnsexpdegspslist_oomulsc_cns(C,A,AT,s,v,args);
    if (B != BT) return ca_obj_vardnsexpdegspslist_oomulsc_cns(C,B,BT,t,w,args);
    return C;
}

static void ca_obj_vardnsexpdegspslist_oomulscaddmulsc(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_t AT,ca_obj_t s,int v,ca_obj_vardnsexpdegspsterm_t B,ca_obj_vardnsexpdegspsterm_t BT, ca_obj_t t,int w,ca_obj_vardnsexpdegspsterm_t CT,ca_obj_vardnsexpdegspsterm_args args)
{
    ca_obj_vardnsexpdegspsterm_glue(ca_obj_vardnsexpdegspslist_oomulscaddmulsc_cns(C,A,AT,s,v,B,BT,t,w,args),CT);
}

static void ca_obj_vardnsexpdegspslist_inmulscaddmulsc(ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_t AT,ca_obj_t s,int v,ca_obj_vardnsexpdegspsterm_t B,ca_obj_vardnsexpdegspsterm_t BT,ca_obj_t t,int w,ca_obj_vardnsexpdegspsterm_args args)
{
    assert(A != B);
    
    while (A != AT && B != BT) {
	int cmp = ca_obj_vardnsexpdegspsterm_cmp(A,B,args);
	if (cmp == 0) {
	    A = ca_obj_vardnsexpdegspsterm_inmulscaddmulsc(A,s,v,B,t,w,args);
	    B = B->nlink;continue;
	}
	if (cmp < 0) {
	    ca_obj_vardnsexpdegspsterm_oomulsc(A->plink,B,t,w,A,args);
	    B = B->nlink;
	} else {
	    A = ca_obj_vardnsexpdegspsterm_inmulsc(A,s,v,args);
	}
    }
 
    if (A != AT) ca_obj_vardnsexpdegspslist_inmulsc(A,AT,s,v,args);
    if (B != BT) ca_obj_vardnsexpdegspslist_oomulsc(A->plink,B,BT,t,w,A,args);
}

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspslist_oomulscaddmulmonomsc_cns(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_t AT,ca_obj_t s,int v,ca_obj_vardnsexpdegspsterm_t B,ca_obj_vardnsexpdegspsterm_t BT,ca_vardnsmonom_t m,ca_obj_t t,int w,ca_obj_vardnsexpdegspsterm_args args)
{
    assert(A != B);
    
    while (A != AT && B != BT) {
	int cmp = ca_obj_vardnsexpdegspsterm_cmpmul(A,B,m,args);
	if (cmp == 0) {
	    C = ca_obj_vardnsexpdegspsterm_oomulscaddmulmonomsc_cns(C,A,s,v,B,m,t,w,args);
	    A = A->nlink;B = B->nlink;continue;
	}
	if (cmp < 0) {
	    C = ca_obj_vardnsexpdegspsterm_oomulmonomsc_cns(C,B,m,t,w,args);
	    B = B->nlink;
	} else {
	    C = ca_obj_vardnsexpdegspsterm_oomulsc_cns(C,A,s,v,args);
	    A = A->nlink;
	}
    }
 
    if (A != AT) return ca_obj_vardnsexpdegspslist_oomulsc_cns(C,A,AT,s,v,args);
    if (B != BT) return ca_obj_vardnsexpdegspslist_oomulmonomsc_cns(C,B,BT,m,t,w,args);
    return C;
}

static void ca_obj_vardnsexpdegspslist_oomulscaddmulmonomsc(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_t AT,ca_obj_t s,int v,ca_obj_vardnsexpdegspsterm_t B,ca_obj_vardnsexpdegspsterm_t BT,ca_vardnsmonom_t m, ca_obj_t t,int w,ca_obj_vardnsexpdegspsterm_t CT,ca_obj_vardnsexpdegspsterm_args args)
{
    ca_obj_vardnsexpdegspsterm_glue(ca_obj_vardnsexpdegspslist_oomulscaddmulmonomsc_cns(C,A,AT,s,v,B,BT,m,t,w,args),CT);
}

static void ca_obj_vardnsexpdegspslist_inmulscaddmulmonomsc(ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_t AT,ca_obj_t s,int v,ca_obj_vardnsexpdegspsterm_t B,ca_obj_vardnsexpdegspsterm_t BT,ca_vardnsmonom_t m,ca_obj_t t,int w,ca_obj_vardnsexpdegspsterm_args args)
{
    assert(A != B);
    
    while (A != AT && B != BT) {
	int cmp = ca_obj_vardnsexpdegspsterm_cmpmul(A,B,m,args);
	if (cmp == 0) {
	    A = ca_obj_vardnsexpdegspsterm_inmulscaddmulmonomsc(A,s,v,B,m,t,w,args);
	    B = B->nlink;continue;
	}
	if (cmp < 0) {
	    ca_obj_vardnsexpdegspsterm_oomulmonomsc(A->plink,B,m,t,w,A,args);
	    B = B->nlink;
	} else {
	    A = ca_obj_vardnsexpdegspsterm_inmulsc(A,s,v,args);
	}
    }
 
    if (A != AT) ca_obj_vardnsexpdegspslist_inmulsc(A,AT,s,v,args);
    if (B != BT) ca_obj_vardnsexpdegspslist_oomulmonomsc(A->plink,B,BT,m,t,w,A,args);
}

static BOOL ca_obj_vardnsexpdegspslist_oodivsc(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_t AT,ca_obj_t s,ca_obj_vardnsexpdegspsterm_t CT,ca_obj_vardnsexpdegspsterm_args args)
{
    BOOL failed = NO;
    
    while (A != AT) {
	ca_obj_vardnsexpdegspsterm_t nextC = ca_obj_vardnsexpdegspsterm_oodivsc_cns(C,A,s,args);
	if (nextC) {
	    C = nextC;
	    A = A->nlink;
	} else {
	    failed = YES;break;
	}
    }
    
    /* in any case, success or failure, have to keep list circular */
    ca_obj_vardnsexpdegspsterm_glue(C,CT);return failed;
}

static void ca_obj_vardnsexpdegspslist_indivsc(ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_t AT,ca_obj_t s,ca_obj_vardnsexpdegspsterm_args args)
{
    while (A != AT) A = ca_obj_vardnsexpdegspsterm_indivsc(A,s,args);
}

static BOOL ca_obj_vardnsexpdegspslist_oodivmonomsc(ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_t AT,ca_vardnsmonom_t m, ca_obj_t s,ca_obj_vardnsexpdegspsterm_t CT,ca_obj_vardnsexpdegspsterm_args args)
{
    BOOL failed = NO;
    
    while (A != AT) {
	ca_obj_vardnsexpdegspsterm_t nextC = ca_obj_vardnsexpdegspsterm_oodivmonomsc_cns(C,A,m,s,args);
	if (nextC) {
	    C = nextC;
	    A = A->nlink;
	} else {
	    failed = YES;break;
	}
    }
    
    /* in any case, success or failure, have to keep list circular */
    ca_obj_vardnsexpdegspsterm_glue(C,CT);return failed;
}

static void ca_obj_vardnsexpdegspslist_indivmonomsc(ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_t AT,ca_vardnsmonom_t m,ca_obj_t s,ca_obj_vardnsexpdegspsterm_args args)
{
    while (A != AT) A = ca_obj_vardnsexpdegspsterm_indivmonomsc(A,m,s,args);
}

static void ca_obj_vardnsexpdegspslist_fileOut(id aFiler,ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_t AT,ca_obj_vardnsexpdegspsterm_args args)
{
    int n;
    n = ca_obj_vardnsexpdegspslist_count(A,AT);
    [aFiler fileOut:&n type:'i'];
    while (A != AT) A = ca_obj_vardnsexpdegspsterm_fileOut(aFiler,A,args);
}

static ca_obj_vardnsexpdegspsterm_t ca_obj_vardnsexpdegspslist_fileIn_cns(id aFiler,ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_args args)
{
    int n;
    [aFiler fileIn:&n type:'i'];
    while (n--) C = ca_obj_vardnsexpdegspsterm_fileIn_cns(aFiler,C,args);
    return C;
}

static void ca_obj_vardnsexpdegspslist_fileIn(id aFiler,ca_obj_vardnsexpdegspsterm_t C,ca_obj_vardnsexpdegspsterm_t CT,ca_obj_vardnsexpdegspsterm_args args)
{
    ca_obj_vardnsexpdegspsterm_glue(ca_obj_vardnsexpdegspslist_fileIn_cns(aFiler,C,args),CT);
}

static void ca_obj_vardnsexpdegspspol_ix_init(ca_obj_vardnsexpdegspspol_ixt ix,id self)
{
    ca_obj_vardnsexpdegspspol_t v = [self ca_obj_vardnsexpdegspspol_value];
    ix->head = v;ix->ix = v;
}

static void ca_obj_vardnsexpdegspspol_ix_clear(ca_obj_vardnsexpdegspspol_ixt ix)
{
    /* nothing to clear */
}

static int ca_obj_vardnsexpdegspspol_ix_count_aux_aux(ca_obj_vardnsexpdegspsterm_t A,ca_obj_vardnsexpdegspsterm_t AT)
{
    int c = 0;for(;A!=AT;A=A->nlink) c++;return c;
}

static int ca_obj_vardnsexpdegspspol_ix_count_aux(ca_obj_vardnsexpdegspspol_t self)
{
    return ca_obj_vardnsexpdegspspol_ix_count_aux_aux(self->nlink,self);
}

static int ca_obj_vardnsexpdegspspol_ix_count(ca_obj_vardnsexpdegspspol_ixt ix)
{
    /* merde ! can't include entire genlist for ca_obj_vardnsexpdegspslist_count */
    return ca_obj_vardnsexpdegspspol_ix_count_aux(ix->head); 
}

static int ca_obj_vardnsexpdegspspol_ix_isempty_aux(ca_obj_vardnsexpdegspspol_t self)
{
    if (self->nlink == self) {
	assert(self->plink == self);return YES;
    } else {
	assert(self->plink != self);return NO;
    }
}

static int ca_obj_vardnsexpdegspspol_ix_isempty(ca_obj_vardnsexpdegspspol_ixt ix)
{
    /* can't include entire genpol for ca_obj_vardnsexpdegspspol_isempty */
    return ca_obj_vardnsexpdegspspol_ix_isempty_aux(ix->head); 
}

static int ca_obj_vardnsexpdegspspol_ix_ismatch(ca_obj_vardnsexpdegspspol_ixt ix)
{
    return (ix->ix != NULL && ix->ix != ix->head);
}

static void ca_obj_vardnsexpdegspspol_ix_tofirst(ca_obj_vardnsexpdegspspol_ixt ix)
{
    ix->ix = ix->head;
}

static void ca_obj_vardnsexpdegspspol_ix_tolast(ca_obj_vardnsexpdegspspol_ixt ix)
{
    ix->ix = NULL;
}

static void ca_obj_vardnsexpdegspspol_ix_to(ca_obj_vardnsexpdegspspol_ixt ix,int i)
{
    fprintf(stderr,"memberAt: notImplemented\n");
}

static void ca_obj_vardnsexpdegspspol_ix_next(ca_obj_vardnsexpdegspspol_ixt ix)
{
    if (ix->ix == NULL) {
	/* remain on position just after last term */
    } else {
	ix->ix = ix->ix->nlink; /* next term or head = position after last */
	if (ix->ix == ix->head) ix->ix = NULL;
    }
}

static void ca_obj_vardnsexpdegspspol_ix_prev(ca_obj_vardnsexpdegspspol_ixt ix)
{
    if (ix->ix == ix->head) {
	/* remain on position just before first term */
    } else {
	if (ix->ix == NULL) {
	    ix->ix = ix->head->plink; /* last term or head = position before first */
	} else {
	    ix->ix = ix->ix->plink; /* previous term or head = position before first */
	}
    }
}
static int ca_obj_vardnsexpdegspspol_check(ca_obj_vardnsexpdegspspol_t self,ca_obj_vardnsexpdegspspol_args args)
{
    assert (self->data == 0xcafebabe);
    return ca_obj_vardnsexpdegspslist_check(self->nlink,self,args);
}

static ca_obj_vardnsexpdegspspol_t ca_obj_vardnsexpdegspspol_id2t(id object)
{
    return [object ca_obj_vardnsexpdegspspol_value];
}

static ca_obj_vardnsexpdegspspol_c *ca_obj_vardnsexpdegspspol_id2c(id object)
{
    return [object ca_obj_vardnsexpdegspspol_reference];
}

static id ca_obj_vardnsexpdegspspol_t2id(id proto,ca_obj_vardnsexpdegspspol_t f)
{
    return [proto ca_obj_vardnsexpdegspspol_value:f];
}

static id ca_obj_vardnsexpdegspspol_c2id(id proto,ca_obj_vardnsexpdegspspol_c *r)
{
    return [proto ca_obj_vardnsexpdegspspol_reference:r];
}

static int ca_obj_vardnsexpdegspspol_isempty(ca_obj_vardnsexpdegspspol_t self)
{
    if (self->nlink == self) {
	assert(self->plink == self);return YES;
    } else {
	assert(self->plink != self);return NO;
    }
}

static void ca_obj_vardnsexpdegspspol_init(ca_obj_vardnsexpdegspspol_t self,ca_obj_vardnsexpdegspspol_args args)
{
    self->data = 0xcafebabe;self->nlink = self;self->plink = self;
    assert(ca_obj_vardnsexpdegspspol_check(self,args));
}

static void ca_obj_vardnsexpdegspspol_copy(ca_obj_vardnsexpdegspspol_t c,ca_obj_vardnsexpdegspspol_t a,ca_obj_vardnsexpdegspspol_args args)
{
    assert(ca_obj_vardnsexpdegspspol_check(a,args));
    ca_obj_vardnsexpdegspspol_init(c,args);ca_obj_vardnsexpdegspslist_copy(c,a->nlink,a,c,args);
}

static void ca_obj_vardnsexpdegspspol_deepcopy(ca_obj_vardnsexpdegspspol_t c,ca_obj_vardnsexpdegspspol_t a,ca_obj_vardnsexpdegspspol_args args)
{
    assert(ca_obj_vardnsexpdegspspol_check(a,args));
    ca_obj_vardnsexpdegspspol_init(c,args);ca_obj_vardnsexpdegspslist_deepcopy(c,a->nlink,a,c,args);
}

static void ca_obj_vardnsexpdegspspol_move(ca_obj_vardnsexpdegspspol_t c,ca_obj_vardnsexpdegspspol_t a,ca_obj_vardnsexpdegspspol_args args)
{
    if (ca_obj_vardnsexpdegspspol_isempty(a)) {
	ca_obj_vardnsexpdegspspol_init(c,args);
    } else {
	ca_obj_vardnsexpdegspspol_init(c,args);
	ca_obj_vardnsexpdegspsterm_glue(c,a->nlink);ca_obj_vardnsexpdegspsterm_glue(a->plink,c);
    }
    
    a->data = 0;assert(ca_obj_vardnsexpdegspspol_check(c,args));
}

static void ca_obj_vardnsexpdegspspol_clear(ca_obj_vardnsexpdegspspol_t self,ca_obj_vardnsexpdegspspol_args args)
{
    ca_obj_vardnsexpdegspslist_clear(self->nlink,self,args);
    self->data = 0;ca_obj_vardnsexpdegspslist_free(self->nlink,self,args);
}

static int ca_obj_vardnsexpdegspspol_count(ca_obj_vardnsexpdegspspol_t self)
{
    return ca_obj_vardnsexpdegspslist_count(self->nlink,self);
}

static unsigned ca_obj_vardnsexpdegspspol_hash(ca_obj_vardnsexpdegspspol_t a,ca_obj_vardnsexpdegspspol_args args)
{
    return ca_obj_vardnsexpdegspslist_hash(a->nlink,a,args);
}

static int ca_obj_vardnsexpdegspspol_iseq(ca_obj_vardnsexpdegspspol_t a,ca_obj_vardnsexpdegspspol_t b,ca_obj_vardnsexpdegspspol_args args)
{
    return (a==b)?YES:ca_obj_vardnsexpdegspslist_iseq(a->nlink,a,b->nlink,b,args);
}

static int ca_obj_vardnsexpdegspspol_isone(ca_obj_vardnsexpdegspspol_t a,ca_obj_vardnsexpdegspspol_args args)
{
    /* if the leading term is one, then it is one */
    return (ca_obj_vardnsexpdegspspol_isempty(a))?0:ca_obj_vardnsexpdegspsterm_isone(a->nlink,args);
}

static int ca_obj_vardnsexpdegspspol_isminusone(ca_obj_vardnsexpdegspspol_t a,ca_obj_vardnsexpdegspspol_args args)
{
    /* if the leading term is minus one, then it is minus one */
    return (ca_obj_vardnsexpdegspspol_isempty(a))?0:ca_obj_vardnsexpdegspsterm_isminusone(a->nlink,args);
}

static int ca_obj_vardnsexpdegspspol_deg(ca_obj_vardnsexpdegspspol_t self ,ca_obj_vardnsexpdegspspol_args args)
{
    return ca_obj_vardnsexpdegspslist_deg(self->nlink,self,args);
}

static int ca_obj_vardnsexpdegspspol_ord(ca_obj_vardnsexpdegspspol_t self ,ca_obj_vardnsexpdegspspol_args args)
{
    return ca_obj_vardnsexpdegspslist_ord(self->nlink,self,args);
}

static int ca_obj_vardnsexpdegspspol_maxdeg(ca_obj_vardnsexpdegspspol_t self ,ca_obj_vardnsexpdegspspol_args args)
{
    return ca_obj_vardnsexpdegspslist_maxdeg(self->nlink,self,args);
}

static int ca_obj_vardnsexpdegspspol_mindeg(ca_obj_vardnsexpdegspspol_t self ,ca_obj_vardnsexpdegspspol_args args)
{
    return ca_obj_vardnsexpdegspslist_mindeg(self->nlink,self,args);
}

static ca_obj_t ca_obj_vardnsexpdegspspol_scalat(ca_obj_vardnsexpdegspspol_t self,ca_obj_vardnsexpdegspspol_ixt ix,ca_obj_vardnsexpdegspspol_args args)
{
    assert(ca_obj_vardnsexpdegspspol_ix_ismatch(ix) && ix->head == self);
    return ca_obj_vardnsexpdegspsterm_scal(ix->ix,args);
}

static ca_vardnsmonom_t ca_obj_vardnsexpdegspspol_monomat(ca_obj_vardnsexpdegspspol_t self,ca_obj_vardnsexpdegspspol_ixt ix,ca_obj_vardnsexpdegspspol_args args)
{
    assert(ca_obj_vardnsexpdegspspol_ix_ismatch(ix) && ix->head == self);
    return ca_obj_vardnsexpdegspsterm_monom(ix->ix);
}

static ca_obj_t ca_obj_vardnsexpdegspspol_scalfirst(ca_obj_vardnsexpdegspspol_t self,ca_obj_vardnsexpdegspspol_args args)
{
    assert(ca_obj_vardnsexpdegspspol_isempty(self) == NO);
    return ca_obj_vardnsexpdegspsterm_scal(self->nlink,args);
}

static ca_vardnsmonom_t ca_obj_vardnsexpdegspspol_monomfirst(ca_obj_vardnsexpdegspspol_t self,ca_obj_vardnsexpdegspspol_args args)
{
    assert(ca_obj_vardnsexpdegspspol_isempty(self) == NO);
    return ca_obj_vardnsexpdegspsterm_monom(self->nlink);
}

static void ca_obj_vardnsexpdegspspol_remove(ca_obj_vardnsexpdegspspol_t self,ca_obj_vardnsexpdegspspol_args args)
{
    assert(ca_obj_vardnsexpdegspspol_check(self,args) && ca_obj_vardnsexpdegspspol_isempty(self) == NO);
    ca_obj_vardnsexpdegspsterm_delete(self->nlink,args);
    assert(ca_obj_vardnsexpdegspspol_check(self,args));
}

static void ca_obj_vardnsexpdegspspol_insert(ca_obj_vardnsexpdegspspol_t self,ca_vardnsmonom_t m,ca_obj_t s,ca_obj_vardnsexpdegspspol_args args)
{
    assert(ca_obj_vardnsexpdegspspol_check(self,args));
    ca_obj_vardnsexpdegspslist_insert(self->nlink,self,m,s,args);
    assert(ca_obj_vardnsexpdegspspol_check(self,args));
}

static int ca_obj_vardnsexpdegspspol_iszero(ca_obj_vardnsexpdegspspol_t self,ca_obj_vardnsexpdegspspol_args args)
{
    return ca_obj_vardnsexpdegspspol_isempty(self);
}

static int ca_obj_vardnsexpdegspspol_isop(ca_obj_vardnsexpdegspspol_t a,ca_obj_vardnsexpdegspspol_t b,ca_obj_vardnsexpdegspspol_args args)
{
    assert(a != b);return ca_obj_vardnsexpdegspslist_isop(a->nlink,a,b->nlink,b,args);
}

static void ca_obj_vardnsexpdegspspol_ooneg(ca_obj_vardnsexpdegspspol_t c,ca_obj_vardnsexpdegspspol_t a,ca_obj_vardnsexpdegspspol_args args)
{
    ca_obj_vardnsexpdegspspol_init(c,args);ca_obj_vardnsexpdegspslist_ooneg(c,a->nlink,a,c,args);
    assert(ca_obj_vardnsexpdegspspol_check(c,args));
}

static void ca_obj_vardnsexpdegspspol_inneg(ca_obj_vardnsexpdegspspol_t a,ca_obj_vardnsexpdegspspol_args args)
{
    ca_obj_vardnsexpdegspslist_inneg(a->nlink,a,args);
    assert(ca_obj_vardnsexpdegspspol_check(a,args));
}

static void ca_obj_vardnsexpdegspspol_oodbl(ca_obj_vardnsexpdegspspol_t c,ca_obj_vardnsexpdegspspol_t a,int v,ca_obj_vardnsexpdegspspol_args args)
{
    ca_obj_vardnsexpdegspspol_init(c,args);ca_obj_vardnsexpdegspslist_oodbl(c,a->nlink,a,v,c,args);
    assert(ca_obj_vardnsexpdegspspol_check(c,args));
}

static void ca_obj_vardnsexpdegspspol_indbl(ca_obj_vardnsexpdegspspol_t a,int v,ca_obj_vardnsexpdegspspol_args args)
{
    ca_obj_vardnsexpdegspslist_indbl(a->nlink,a,v,args);
    assert(ca_obj_vardnsexpdegspspol_check(a,args));
}

static void ca_obj_vardnsexpdegspspol_ooadd(ca_obj_vardnsexpdegspspol_t c,ca_obj_vardnsexpdegspspol_t a,int v,ca_obj_vardnsexpdegspspol_t b,int w,ca_obj_vardnsexpdegspspol_args args)
{
    assert(a!=b);
    ca_obj_vardnsexpdegspspol_init(c,args);ca_obj_vardnsexpdegspslist_ooadd(c,a->nlink,a,v,b->nlink,b,w,c,args);
    assert(ca_obj_vardnsexpdegspspol_check(c,args));
}

static void ca_obj_vardnsexpdegspspol_inadd(ca_obj_vardnsexpdegspspol_t a,int v,ca_obj_vardnsexpdegspspol_t b,int w,ca_obj_vardnsexpdegspspol_args args)
{
    assert(a!=b);
    ca_obj_vardnsexpdegspslist_inadd(a->nlink,a,v,b->nlink,b,w,args);
    assert(ca_obj_vardnsexpdegspspol_check(a,args));
}

static void ca_obj_vardnsexpdegspspol_oomulsc(ca_obj_vardnsexpdegspspol_t c,ca_obj_vardnsexpdegspspol_t a,ca_obj_t s,ca_obj_vardnsexpdegspspol_args args)
{
    ca_obj_vardnsexpdegspspol_init(c,args);ca_obj_vardnsexpdegspslist_oomulsc(c,a->nlink,a,s,+1,c,args);
    assert(ca_obj_vardnsexpdegspspol_check(c,args));
}

static void ca_obj_vardnsexpdegspspol_inmulsc(ca_obj_vardnsexpdegspspol_t a,ca_obj_t s,ca_obj_vardnsexpdegspspol_args args)
{
    ca_obj_vardnsexpdegspslist_inmulsc(a->nlink,a,s,+1,args);
    assert(ca_obj_vardnsexpdegspspol_check(a,args));
}

static void ca_obj_vardnsexpdegspspol_ooaddmulsc(ca_obj_vardnsexpdegspspol_t c,ca_obj_vardnsexpdegspspol_t a,int v,ca_obj_vardnsexpdegspspol_t b,ca_obj_t t,int w, ca_obj_vardnsexpdegspspol_args args)
{
    ca_obj_vardnsexpdegspspol_init(c,args);ca_obj_vardnsexpdegspslist_ooaddmulsc(c,a->nlink,a,v,b->nlink,b,t,w,c,args);
    assert(ca_obj_vardnsexpdegspspol_check(c,args));
}

static void ca_obj_vardnsexpdegspspol_inaddmulsc(ca_obj_vardnsexpdegspspol_t a,int v,ca_obj_vardnsexpdegspspol_t b,ca_obj_t t,int w,ca_obj_vardnsexpdegspspol_args args)
{
    ca_obj_vardnsexpdegspslist_inaddmulsc(a->nlink,a,v,b->nlink,b,t,w,args);
    assert(ca_obj_vardnsexpdegspspol_check(a,args));
}

static void ca_obj_vardnsexpdegspspol_oomulscadd(ca_obj_vardnsexpdegspspol_t c,ca_obj_vardnsexpdegspspol_t a,ca_obj_t s,int v,ca_obj_vardnsexpdegspspol_t b,int w, ca_obj_vardnsexpdegspspol_args args)
{
    ca_obj_vardnsexpdegspspol_init(c,args);ca_obj_vardnsexpdegspslist_oomulscadd(c,a->nlink,a,s,v,b->nlink,b,w,c,args);
    assert(ca_obj_vardnsexpdegspspol_check(c,args));
}

static void ca_obj_vardnsexpdegspspol_inmulscadd(ca_obj_vardnsexpdegspspol_t a,ca_obj_t s,int v,ca_obj_vardnsexpdegspspol_t b,int w,ca_obj_vardnsexpdegspspol_args args)
{
    ca_obj_vardnsexpdegspslist_inmulscadd(a->nlink,a,s,v,b->nlink,b,w,args);
    assert(ca_obj_vardnsexpdegspspol_check(a,args));
}

static void ca_obj_vardnsexpdegspspol_oomulscaddmulsc(ca_obj_vardnsexpdegspspol_t c,ca_obj_vardnsexpdegspspol_t a,ca_obj_t s,int v,ca_obj_vardnsexpdegspspol_t b,ca_obj_t t,int w, ca_obj_vardnsexpdegspspol_args args)
{
    ca_obj_vardnsexpdegspspol_init(c,args);ca_obj_vardnsexpdegspslist_oomulscaddmulsc(c,a->nlink,a,s,v,b->nlink,b,t,w,c,args);
    assert(ca_obj_vardnsexpdegspspol_check(c,args));
}

static void ca_obj_vardnsexpdegspspol_inmulscaddmulsc(ca_obj_vardnsexpdegspspol_t a,ca_obj_t s,int v,ca_obj_vardnsexpdegspspol_t b,ca_obj_t t,int w,ca_obj_vardnsexpdegspspol_args args)
{
    ca_obj_vardnsexpdegspslist_inmulscaddmulsc(a->nlink,a,s,v,b->nlink,b,t,w,args);
    assert(ca_obj_vardnsexpdegspspol_check(a,args));
}

static BOOL ca_obj_vardnsexpdegspspol_oodivsc(ca_obj_vardnsexpdegspspol_t c,ca_obj_vardnsexpdegspspol_t a,ca_obj_t s,ca_obj_vardnsexpdegspspol_args args)
{
    BOOL failed;
    ca_obj_vardnsexpdegspspol_init(c,args);
    failed = ca_obj_vardnsexpdegspslist_oodivsc(c,a->nlink,a,s,c,args);
    assert(ca_obj_vardnsexpdegspspol_check(c,args));
    if (failed) ca_obj_vardnsexpdegspspol_clear(c,args);
    return failed;
}

static void ca_obj_vardnsexpdegspspol_indivsc(ca_obj_vardnsexpdegspspol_t a,ca_obj_t s,ca_obj_vardnsexpdegspspol_args args)
{
    ca_obj_vardnsexpdegspslist_indivsc(a->nlink,a,s,args);
    assert(ca_obj_vardnsexpdegspspol_check(a,args));
}

static void ca_obj_vardnsexpdegspspol_oomulmonomsc(ca_obj_vardnsexpdegspspol_t c,ca_obj_vardnsexpdegspspol_t b,ca_vardnsmonom_t m,ca_obj_t t,int w,ca_obj_vardnsexpdegspspol_args args)
{
    ca_obj_vardnsexpdegspspol_init(c,args);ca_obj_vardnsexpdegspslist_oomulmonomsc(c,b->nlink,b,m,t,w,c,args);
    assert(ca_obj_vardnsexpdegspspol_check(c,args));
}

static void ca_obj_vardnsexpdegspspol_inmulmonomsc(ca_obj_vardnsexpdegspspol_t b,ca_vardnsmonom_t m,ca_obj_t t,int w,ca_obj_vardnsexpdegspspol_args args)
{
    ca_obj_vardnsexpdegspslist_inmulmonomsc(b->nlink,b,m,t,w,args);
    assert(ca_obj_vardnsexpdegspspol_check(b,args));
}

static void ca_obj_vardnsexpdegspspol_ooaddmulmonomsc(ca_obj_vardnsexpdegspspol_t c,ca_obj_vardnsexpdegspspol_t a,int v,ca_obj_vardnsexpdegspspol_t b,ca_vardnsmonom_t m,ca_obj_t t,int w, ca_obj_vardnsexpdegspspol_args args)
{
    ca_obj_vardnsexpdegspspol_init(c,args);ca_obj_vardnsexpdegspslist_ooaddmulmonomsc(c,a->nlink,a,v,b->nlink,b,m,t,w,c,args);
    assert(ca_obj_vardnsexpdegspspol_check(c,args));
}

static void ca_obj_vardnsexpdegspspol_inaddmulmonomsc(ca_obj_vardnsexpdegspspol_t a,int v,ca_obj_vardnsexpdegspspol_t b,ca_vardnsmonom_t m,ca_obj_t t,int w,ca_obj_vardnsexpdegspspol_args args)
{
    ca_obj_vardnsexpdegspslist_inaddmulmonomsc(a->nlink,a,v,b->nlink,b,m,t,w,args);
    assert(ca_obj_vardnsexpdegspspol_check(a,args));
}

static void ca_obj_vardnsexpdegspspol_oomulscaddmulmonomsc(ca_obj_vardnsexpdegspspol_t c,ca_obj_vardnsexpdegspspol_t a,ca_obj_t s,int v,ca_obj_vardnsexpdegspspol_t b,ca_vardnsmonom_t m,ca_obj_t t,int w, ca_obj_vardnsexpdegspspol_args args)
{
    ca_obj_vardnsexpdegspspol_init(c,args);ca_obj_vardnsexpdegspslist_oomulscaddmulmonomsc(c,a->nlink,a,s,v,b->nlink,b,m,t,w,c,args);
    assert(ca_obj_vardnsexpdegspspol_check(c,args));
}

static void ca_obj_vardnsexpdegspspol_inmulscaddmulmonomsc(ca_obj_vardnsexpdegspspol_t a,ca_obj_t s,int v,ca_obj_vardnsexpdegspspol_t b,ca_vardnsmonom_t m,ca_obj_t t,int w,ca_obj_vardnsexpdegspspol_args args)
{
    ca_obj_vardnsexpdegspslist_inmulscaddmulmonomsc(a->nlink,a,s,v,b->nlink,b,m,t,w,args);
    assert(ca_obj_vardnsexpdegspspol_check(a,args));
}

static BOOL ca_obj_vardnsexpdegspspol_oodivmonomsc(ca_obj_vardnsexpdegspspol_t c,ca_obj_vardnsexpdegspspol_t b,ca_vardnsmonom_t m,ca_obj_t t, ca_obj_vardnsexpdegspspol_args args)
{
    BOOL failed;
    ca_obj_vardnsexpdegspspol_init(c,args);
    failed = ca_obj_vardnsexpdegspslist_oodivmonomsc(c,b->nlink,b,m,t,c,args);
    assert(ca_obj_vardnsexpdegspspol_check(c,args));
    if (failed) ca_obj_vardnsexpdegspspol_clear(c,args);
    return failed;
}

static void ca_obj_vardnsexpdegspspol_indivmonomsc(ca_obj_vardnsexpdegspspol_t b,ca_vardnsmonom_t m,ca_obj_t t,ca_obj_vardnsexpdegspspol_args args)
{
    ca_obj_vardnsexpdegspslist_indivmonomsc(b->nlink,b,m,t,args);
    assert(ca_obj_vardnsexpdegspspol_check(b,args));
}

static void ca_obj_vardnsexpdegspspol_args_fileOut(id aFiler,ca_obj_vardnsexpdegspspol_args *args)
{
    ca_obj_vardnsexpdegspsterm_args_fileOut(aFiler,args);
}
static void ca_obj_vardnsexpdegspspol_args_fileIn(id aFiler,ca_obj_vardnsexpdegspspol_args *args)
{
    ca_obj_vardnsexpdegspsterm_args_fileIn(aFiler,args);
}

static void ca_obj_vardnsexpdegspspol_fileOut(id aFiler,ca_obj_vardnsexpdegspspol_t self,ca_obj_vardnsexpdegspspol_args args)
{
    assert(ca_obj_vardnsexpdegspspol_check(self,args));
    ca_obj_vardnsexpdegspslist_fileOut(aFiler,self->nlink,self,args);
}

static void ca_obj_vardnsexpdegspspol_fileIn(id aFiler,ca_obj_vardnsexpdegspspol_t self,ca_obj_vardnsexpdegspspol_args args)
{
    ca_obj_vardnsexpdegspspol_init(self,args);ca_obj_vardnsexpdegspslist_fileIn(aFiler,self,self,args);
    assert(ca_obj_vardnsexpdegspspol_check(self,args));
}

static ca_obj_vardnsexpdegspspol_args ca_obj_vardnsexpdegspspol_getargs(id self)
{
    ca_obj_vardnsexpdegspspol_args res;id monomialZero = [self monomialZero];
    res.sargs = ca_obj_getargs([monomialZero scalar]);
    res.margs = ca_vardnsmonom_getargs([monomialZero terms]);
    return res; 
}
@implementation ca_obj_vardnsexpdegsps_polynomial : ca_vardnsexpdegsps_polynomial

- (ca_obj_vardnsexpdegspspol_t)ca_obj_vardnsexpdegspspol_value
{
    return &value;
}

- ca_obj_vardnsexpdegspspol_value:(ca_obj_vardnsexpdegspspol_t)aValue
{
    self = [self clone];
    ca_obj_vardnsexpdegspspol_copy(&value,aValue,ca_obj_vardnsexpdegspspol_getargs(self));
    assert([self check]);return self;
}

- (ca_obj_vardnsexpdegspspol_t)ca_obj_vardnsexpdegspspol_reference
{
    return &value;
}

- ca_obj_vardnsexpdegspspol_reference:(ca_obj_vardnsexpdegspspol_c *)aReference
{
    self = [self clone];
    ca_obj_vardnsexpdegspspol_move(&value,aReference,ca_obj_vardnsexpdegspspol_getargs(self));
    assert([self check]);return self;
}

- copy
{
    ca_obj_vardnsexpdegspspol_c c;assert([self check]);
    ca_obj_vardnsexpdegspspol_copy(&c,&value,ca_obj_vardnsexpdegspspol_getargs(self));
    return ca_obj_vardnsexpdegspspol_c2id(self,&c);
}

- deepCopy
{
    ca_obj_vardnsexpdegspspol_c c;assert([self check]);
    ca_obj_vardnsexpdegspspol_deepcopy(&c,&value,ca_obj_vardnsexpdegspspol_getargs(self));
    return ca_obj_vardnsexpdegspspol_c2id(self,&c);
}

- (BOOL) isEmpty
{
    return ca_obj_vardnsexpdegspspol_isempty(&value);
}

- (BOOL) isOne
{
    return ca_obj_vardnsexpdegspspol_isone(&value,ca_obj_vardnsexpdegspspol_getargs(self));
}

- (BOOL) isMinusOne
{
    return ca_obj_vardnsexpdegspspol_isminusone(&value,ca_obj_vardnsexpdegspspol_getargs(self));
}

- (unsigned) hash
{
    return ca_obj_vardnsexpdegspspol_hash(ca_obj_vardnsexpdegspspol_id2t(self),ca_obj_vardnsexpdegspspol_getargs(self));
}

- (BOOL) isEqual:b
{
    [self checkSameClass:b];
    if (self==b) {
    return YES;
    } else {
    return ca_obj_vardnsexpdegspspol_iseq(ca_obj_vardnsexpdegspspol_id2t(self),ca_obj_vardnsexpdegspspol_id2t(b),ca_obj_vardnsexpdegspspol_getargs(self));
    }
}

- (BOOL) notEqual:b
{
    [self checkSameClass:b];
    if (self==b) {
    return NO;
    } else {
    return !ca_obj_vardnsexpdegspspol_iseq(ca_obj_vardnsexpdegspspol_id2t(self),ca_obj_vardnsexpdegspspol_id2t(b),ca_obj_vardnsexpdegspspol_getargs(self));
    }
}

- (BOOL) isZero
{
    assert([self check]);
    return ca_obj_vardnsexpdegspspol_iszero(ca_obj_vardnsexpdegspspol_id2t(self),ca_obj_vardnsexpdegspspol_getargs(self));
}

- (BOOL) notZero
{
    assert([self check]);
    return !ca_obj_vardnsexpdegspspol_iszero(ca_obj_vardnsexpdegspspol_id2t(self),ca_obj_vardnsexpdegspspol_getargs(self));
}

- (BOOL) isOpposite:b
{
    assert([self checkSameClass:b] && self != b);
    return ca_obj_vardnsexpdegspspol_isop(ca_obj_vardnsexpdegspspol_id2t(self),ca_obj_vardnsexpdegspspol_id2t(b),ca_obj_vardnsexpdegspspol_getargs(self));
}

- (BOOL) notOpposite:b
{
    assert([self checkSameClass:b] && self != b);
    return !ca_obj_vardnsexpdegspspol_isop(ca_obj_vardnsexpdegspspol_id2t(self),ca_obj_vardnsexpdegspspol_id2t(b),ca_obj_vardnsexpdegspspol_getargs(self));
}

- negate
{
    ca_obj_vardnsexpdegspspol_c c;assert([self check]);
    ca_obj_vardnsexpdegspspol_ooneg(&c,ca_obj_vardnsexpdegspspol_id2t(self),ca_obj_vardnsexpdegspspol_getargs(self));
    return ca_obj_vardnsexpdegspspol_c2id(self,&c);
}

- negateSelf
{
    if (refCount>1) return idReplace(self,[self negate]);
    assert([self check]);
    ca_obj_vardnsexpdegspspol_inneg(ca_obj_vardnsexpdegspspol_id2c(self),ca_obj_vardnsexpdegspspol_getargs(self));
    return [self invalidate];
}

- _double:(int)v
{
    ca_obj_vardnsexpdegspspol_c c;assert([self check]);
    ca_obj_vardnsexpdegspspol_oodbl(&c,ca_obj_vardnsexpdegspspol_id2t(self),v,ca_obj_vardnsexpdegspspol_getargs(self));
    return ca_obj_vardnsexpdegspspol_c2id(self,&c);
}

- _doubleSelf:(int)v
{
    if (refCount>1) return idReplace(self,[self _double:v]);
    assert([self check]);
    ca_obj_vardnsexpdegspspol_indbl(ca_obj_vardnsexpdegspspol_id2c(self),v,ca_obj_vardnsexpdegspspol_getargs(self));
    return [self invalidate];
}

- double
{
    ca_obj_vardnsexpdegspspol_c c;assert([self check]);
    ca_obj_vardnsexpdegspspol_oodbl(&c,ca_obj_vardnsexpdegspspol_id2t(self),+1,ca_obj_vardnsexpdegspspol_getargs(self));
    return ca_obj_vardnsexpdegspspol_c2id(self,&c);
}

- doubleSelf
{
    if (refCount>1) return idReplace(self,[self double]);
    assert([self check]);
    ca_obj_vardnsexpdegspspol_indbl(ca_obj_vardnsexpdegspspol_id2c(self),+1,ca_obj_vardnsexpdegspspol_getargs(self));
    return [self invalidate];
}

- _add:(int)v:b:(int)w
{
    ca_obj_vardnsexpdegspspol_c c;
    assert([self sameClass:b] && v*v == 1 && w*w == 1 && self != b);
    ca_obj_vardnsexpdegspspol_ooadd(&c,ca_obj_vardnsexpdegspspol_id2t(self),v,ca_obj_vardnsexpdegspspol_id2t(b),w,ca_obj_vardnsexpdegspspol_getargs(self));
    return ca_obj_vardnsexpdegspspol_c2id(self,&c);
}

- _addSelf:(int)v:b:(int)w
{
    assert([self sameClass:b] && v*v == 1 && w*w == 1 && self != b);
    if (refCount>1) return idReplace(self,[self _add:v:b:w]);
    ca_obj_vardnsexpdegspspol_inadd(ca_obj_vardnsexpdegspspol_id2c(self),v,ca_obj_vardnsexpdegspspol_id2t(b),w,ca_obj_vardnsexpdegspspol_getargs(self));
    return [self invalidate];
}

- add:b
{
    ca_obj_vardnsexpdegspspol_c c;
    assert([self checkSameClass:b] && self != b);
    ca_obj_vardnsexpdegspspol_ooadd(&c,ca_obj_vardnsexpdegspspol_id2t(self),+1,ca_obj_vardnsexpdegspspol_id2t(b),+1,ca_obj_vardnsexpdegspspol_getargs(self));
    return ca_obj_vardnsexpdegspspol_c2id(self,&c);
}

- addSelf:b
{
    assert([self sameClass:b] && self != b);
    if (refCount>1) return idReplace(self,[self add:b]);
    ca_obj_vardnsexpdegspspol_inadd(ca_obj_vardnsexpdegspspol_id2c(self),+1,ca_obj_vardnsexpdegspspol_id2t(b),+1,ca_obj_vardnsexpdegspspol_getargs(self));
    return [self invalidate];
}

- subtract:b
{
    ca_obj_vardnsexpdegspspol_c c;
    assert([self checkSameClass:b] && self != b);
    ca_obj_vardnsexpdegspspol_ooadd(&c,ca_obj_vardnsexpdegspspol_id2t(self),+1,ca_obj_vardnsexpdegspspol_id2t(b),-1,ca_obj_vardnsexpdegspspol_getargs(self));
    return ca_obj_vardnsexpdegspspol_c2id(self,&c);
}

- subtractSelf:b
{
    assert([self sameClass:b] && self != b);
    if (refCount>1) return idReplace(self,[self subtract:b]);
    ca_obj_vardnsexpdegspspol_inadd(ca_obj_vardnsexpdegspspol_id2c(self),+1,ca_obj_vardnsexpdegspspol_id2t(b),-1,ca_obj_vardnsexpdegspspol_getargs(self));
    return [self invalidate];
}

- (int) leadingDegree
{
    return ca_obj_vardnsexpdegspspol_deg(&value,ca_obj_vardnsexpdegspspol_getargs(self));
}

- (int) lastDegree
{
    return ca_obj_vardnsexpdegspspol_ord(&value,ca_obj_vardnsexpdegspspol_getargs(self));
}

- (int) maxDegree
{
    return ca_obj_vardnsexpdegspspol_maxdeg(&value,ca_obj_vardnsexpdegspspol_getargs(self));
}

- (int) minDegree
{
    return ca_obj_vardnsexpdegspspol_mindeg(&value,ca_obj_vardnsexpdegspspol_getargs(self));
}

- asScalar
{
    if ([self numMembers] == 1) {
	id asScalar,lastTerm,aSequence = [self eachMember];
	asScalar = (lastTerm = [aSequence lastMember])?[lastTerm asScalar]:nil;
	[aSequence free];return asScalar;
    } else {
	return nil;
    }
}

- asSymbol
{
    if ([self numMembers] == 1) {
	id asSymbol,lastTerm,aSequence = [self eachMember];
	asSymbol = (lastTerm = [aSequence lastMember])?[lastTerm asSymbol]:nil;
	[aSequence free];return asSymbol;
    } else {
	return nil;
    }
}

- check
{
    [super check];
    assert(scalarZero && termZero && monomialZero && symbols);
    [scalarZero check];[termZero check];[monomialZero check];
    [symbols check];assert([symbols numMembers] >= 1);
    assert([scalarZero isEqual:[monomialZero scalar]]);
    assert([symbols isEqual:[monomialZero symbols]]);

    ca_obj_vardnsexpdegspspol_check(&value,ca_obj_vardnsexpdegspspol_getargs(self));
    return self;
}

- _setUpScalarZero:aScalar symbols:aCltn
{
    assert([aScalar isZero] && [aCltn notEmpty]);
    assert([aScalar class_vardnsexpdegsps_polynomial] == [self class]);

    aScalar  = [aScalar cheapCopy];
    termZero = [CATermClass newScalar:aScalar symbol:nil exponent:0];
    aScalar  = [aScalar cheapCopy];aCltn = [aCltn cheapCopy];
    monomialZero = [CAMonomialClass newScalar:aScalar symbols:aCltn];

    scalarZero = aScalar;
    symbols    = aCltn;

    ca_obj_vardnsexpdegspspol_init(&value,ca_obj_vardnsexpdegspspol_getargs(self));
    assert([self check]);return self;
}

+ newScalarZero:aScalar symbols:aCltn
{
    return [[super new] _setUpScalarZero:aScalar symbols:aCltn];
}

- clear
{
    ca_obj_vardnsexpdegspspol_clear(&value,ca_obj_vardnsexpdegspspol_getargs(self));
    /* free args after clearing polynomial value */
    scalarZero = [scalarZero free];
    termZero = [termZero free];monomialZero = [monomialZero free];
    symbols = [symbols free];return [super clear];
}

- clone
{
    self = [super clone];
    scalarZero   = [scalarZero cheapCopy];
    termZero     = [termZero cheapCopy];
    monomialZero = [monomialZero cheapCopy];
    symbols      = [symbols cheapCopy];
    return self;
}

- empty
{
    ca_obj_vardnsexpdegspspol_c c;assert([self check]);
    ca_obj_vardnsexpdegspspol_init(&c,ca_obj_vardnsexpdegspspol_getargs(self));
    return ca_obj_vardnsexpdegspspol_c2id(self,&c);
}

- scalarZero   { return scalarZero;   }
- termZero     { return termZero;     }
- monomialZero { return monomialZero; }
- symbols      { return symbols;      }

- (int) numMonomials
{
    assert([self check]);return ca_obj_vardnsexpdegspspol_count(&value);
}

- eachMonomial
{
    id aSequence = [ca_obj_vardnsexpdegspspol_sequence newContent:[self cheapCopy]];
    return [CASequenceClass newCarrier:aSequence];
}

- elt_ca_obj_vardnsexpdegspspol_ix:(ca_obj_vardnsexpdegspspol_ixt)ix
{
    if (ca_obj_vardnsexpdegspspol_ix_ismatch(ix)) {
	id s,m;ca_obj_t sc;ca_vardnsmonom_t mc;
	sc = ca_obj_vardnsexpdegspspol_scalat(&value,ix,ca_obj_vardnsexpdegspspol_getargs(self));
	mc = ca_obj_vardnsexpdegspspol_monomat(&value,ix,ca_obj_vardnsexpdegspspol_getargs(self));
	s  = ca_obj_t2id([monomialZero scalar],sc);
	m  = ca_vardnsmonom_t2id([monomialZero terms],mc);
	return [monomialZero scalar:s terms:m];
    } else {
	return nil;
    }
}

- removeMonomial
{
    if ([self isEmpty]) {
	return nil;
    } else {
	id lt;
	id m,s;ca_obj_t sc;ca_vardnsmonom_t mc;
	[self checkRefCountOne];assert([self check]);
	
	sc = ca_obj_vardnsexpdegspspol_scalfirst(&value,ca_obj_vardnsexpdegspspol_getargs(self));
	mc = ca_obj_vardnsexpdegspspol_monomfirst(&value,ca_obj_vardnsexpdegspspol_getargs(self));
	s  = ca_obj_t2id([monomialZero scalar],sc);
	m  = ca_vardnsmonom_t2id([monomialZero terms],mc);
	lt = [monomialZero scalar:s terms:m];
	
	ca_obj_vardnsexpdegspspol_remove(&value,ca_obj_vardnsexpdegspspol_getargs(self));
	[self invalidate];assert([self check]);return lt;
    }
}

- insertMonomial:aMonomial
{
    if ([aMonomial isZero])  {
	[aMonomial free];return self;
    } else {
	ca_obj_c c;ca_obj_t r;ca_vardnsmonom_t m;
	assert([aMonomial check]);[self checkRefCountOne];assert([self check]);
	r = ca_obj_id2ref([aMonomial scalar],&c);
	m = ca_vardnsmonom_id2t([aMonomial terms]);
	ca_obj_vardnsexpdegspspol_insert(&value,m,r,ca_obj_vardnsexpdegspspol_getargs(self));
	assert([aMonomial check]);[aMonomial free];
	[self invalidate];assert([self check]);return self;
    }
}

- multiplyScalar:s
{
    ca_obj_vardnsexpdegspspol_c c;
    ca_obj_c sc;
    ca_obj_vardnsexpdegspspol_oomulsc(&c,ca_obj_vardnsexpdegspspol_id2t(self),ca_obj_id2ref(s,&sc),ca_obj_vardnsexpdegspspol_getargs(self));
    return ca_obj_vardnsexpdegspspol_c2id(self,&c);
}

- multiplySelfScalar:s
{
    ca_obj_c sc;
    if (refCount>1) return idReplace(self,[self multiplyScalar:s]);
    ca_obj_vardnsexpdegspspol_inmulsc(ca_obj_vardnsexpdegspspol_id2c(self),ca_obj_id2ref(s,&sc),ca_obj_vardnsexpdegspspol_getargs(self));
    return [self invalidate];
}

- divideScalar:s
{
    ca_obj_vardnsexpdegspspol_c c;
    ca_obj_c sc;
    BOOL failed = ca_obj_vardnsexpdegspspol_oodivsc(&c,ca_obj_vardnsexpdegspspol_id2t(self),ca_obj_id2ref(s,&sc),ca_obj_vardnsexpdegspspol_getargs(self));
    return (failed)?nil:ca_obj_vardnsexpdegspspol_c2id(self,&c);
}

- divideSelfScalar:s
{
    ca_obj_c sc;
    if (refCount>1) return idReplace(self,[self divideScalar:s]);
    ca_obj_vardnsexpdegspspol_indivsc(ca_obj_vardnsexpdegspspol_id2c(self),ca_obj_id2ref(s,&sc),ca_obj_vardnsexpdegspspol_getargs(self));
    return [self invalidate];
}

- _add:(int)v:B multiplyScalar:b:(int)w
{
    ca_obj_vardnsexpdegspspol_c c;
    ca_obj_c bc;
    assert([self sameClass:B] && [scalarZero sameClass:b] && v*v == 1 && w*w == 1);
    ca_obj_vardnsexpdegspspol_ooaddmulsc(&c,ca_obj_vardnsexpdegspspol_id2t(self),v,ca_obj_vardnsexpdegspspol_id2t(B),ca_obj_id2ref(b,&bc),w,ca_obj_vardnsexpdegspspol_getargs(self));
    return ca_obj_vardnsexpdegspspol_c2id(self,&c);
}

- _addSelf:(int)v:B multiplyScalar:b:(int)w
{
    ca_obj_c bc;
    if (refCount>1) return idReplace(self,[self _add:v:B multiplyScalar:b:w]);
    assert([self sameClass:B] && [scalarZero sameClass:b] && v*v == 1 && w*w == 1);
    ca_obj_vardnsexpdegspspol_inaddmulsc(ca_obj_vardnsexpdegspspol_id2c(self),v,ca_obj_vardnsexpdegspspol_id2t(B),ca_obj_id2ref(b,&bc),w,ca_obj_vardnsexpdegspspol_getargs(self));
    return [self invalidate];
}

- _multiplyScalar:a:(int)v add:B:(int)w
{
    ca_obj_vardnsexpdegspspol_c c;
    ca_obj_c ac;
    assert([scalarZero sameClass:a] && [self sameClass:B] && v*v == 1 && w*w == 1);
    ca_obj_vardnsexpdegspspol_oomulscadd(&c,ca_obj_vardnsexpdegspspol_id2t(self),ca_obj_id2ref(a,&ac),v,ca_obj_vardnsexpdegspspol_id2t(B),w,ca_obj_vardnsexpdegspspol_getargs(self));
    return ca_obj_vardnsexpdegspspol_c2id(self,&c);
}

- _multiplySelfScalar:a:(int)v add:B:(int)w
{
    ca_obj_c ac;
    if (refCount>1) return idReplace(self,[self _multiplyScalar:a:v add:B:w]);
    assert([scalarZero sameClass:a] && [self sameClass:B] && v*v == 1 && w*w == 1);
    ca_obj_vardnsexpdegspspol_inmulscadd(ca_obj_vardnsexpdegspspol_id2c(self),ca_obj_id2ref(a,&ac),v,ca_obj_vardnsexpdegspspol_id2t(B),w,ca_obj_vardnsexpdegspspol_getargs(self));
    return [self invalidate];
}

- _multiplyScalar:a:(int)v add:B multiplyScalar:b:(int)w
{
    ca_obj_vardnsexpdegspspol_c c;
    ca_obj_c ac,bc;
    assert([scalarZero sameClass:a] && [self sameClass:B] && [scalarZero sameClass:b] && v*v == 1 && w*w == 1);
    ca_obj_vardnsexpdegspspol_oomulscaddmulsc(&c,ca_obj_vardnsexpdegspspol_id2t(self),ca_obj_id2ref(a,&ac),v,ca_obj_vardnsexpdegspspol_id2t(B),ca_obj_id2ref(b,&bc),w,ca_obj_vardnsexpdegspspol_getargs(self));
    return ca_obj_vardnsexpdegspspol_c2id(self,&c);
}

- _multiplySelfScalar:a:(int)v add:B multiplyScalar:b:(int)w
{
    ca_obj_c ac,bc;
    if (refCount>1) return idReplace(self,[self _multiplyScalar:a:v add:B multiplyScalar:b:w]);
    assert([scalarZero sameClass:a] && [self sameClass:B] && [scalarZero sameClass:b] && v*v == 1 && w*w == 1);
    ca_obj_vardnsexpdegspspol_inmulscaddmulsc(ca_obj_vardnsexpdegspspol_id2c(self),ca_obj_id2ref(a,&ac),v,ca_obj_vardnsexpdegspspol_id2t(B),ca_obj_id2ref(b,&bc),w,ca_obj_vardnsexpdegspspol_getargs(self));
    return [self invalidate];
}
- multiplyMonomial:aMonomial
{
    ca_obj_vardnsexpdegspspol_c c;
    ca_obj_t s;
    ca_obj_c sc;
    ca_vardnsmonom_t m;
    
    m = ca_vardnsmonom_id2t([aMonomial terms]);
    s = ca_obj_id2ref([aMonomial scalar],&sc);
    ca_obj_vardnsexpdegspspol_oomulmonomsc(&c,ca_obj_vardnsexpdegspspol_id2t(self),m,s,+1,ca_obj_vardnsexpdegspspol_getargs(self));
    return ca_obj_vardnsexpdegspspol_c2id(self,&c);
}

- multiplySelfMonomial:aMonomial
{
    ca_obj_t s;
    ca_obj_c sc;
    ca_vardnsmonom_t m;
    if (refCount>1) return idReplace(self,[self multiplyMonomial:aMonomial]);

    m = ca_vardnsmonom_id2t([aMonomial terms]);
    s = ca_obj_id2ref([aMonomial scalar],&sc);
    ca_obj_vardnsexpdegspspol_inmulmonomsc(ca_obj_vardnsexpdegspspol_id2c(self),m,s,+1,ca_obj_vardnsexpdegspspol_getargs(self));
    return [self invalidate];
}

- _multiplyMonomial:aMonomial:(int)v
{
    ca_obj_vardnsexpdegspspol_c c;
    ca_obj_t s;
    ca_obj_c sc;
    ca_vardnsmonom_t m;

    m = ca_vardnsmonom_id2t([aMonomial terms]);
    s = ca_obj_id2ref([aMonomial scalar],&sc);
    ca_obj_vardnsexpdegspspol_oomulmonomsc(&c,ca_obj_vardnsexpdegspspol_id2t(self),m,s,v,ca_obj_vardnsexpdegspspol_getargs(self));
    return ca_obj_vardnsexpdegspspol_c2id(self,&c);
}

- _multiplySelfMonomial:aMonomial:(int)v
{
    ca_obj_t s;
    ca_obj_c sc;
    ca_vardnsmonom_t m;
    if (refCount>1) return idReplace(self,[self _multiplyMonomial:aMonomial:v]);

    m = ca_vardnsmonom_id2t([aMonomial terms]);
    s = ca_obj_id2ref([aMonomial scalar],&sc);
    ca_obj_vardnsexpdegspspol_inmulmonomsc(ca_obj_vardnsexpdegspspol_id2c(self),m,s,v,ca_obj_vardnsexpdegspspol_getargs(self));
    return [self invalidate];
}

- divideMonomial:aMonomial
{
    BOOL failed;
    ca_obj_vardnsexpdegspspol_c c;
    ca_obj_t s;
    ca_obj_c sc;
    ca_vardnsmonom_t m;

    m = ca_vardnsmonom_id2t([aMonomial terms]);
    s = ca_obj_id2ref([aMonomial scalar],&sc);
    failed = ca_obj_vardnsexpdegspspol_oodivmonomsc(&c,ca_obj_vardnsexpdegspspol_id2t(self),m,s,ca_obj_vardnsexpdegspspol_getargs(self));
    return (failed)?nil:ca_obj_vardnsexpdegspspol_c2id(self,&c);
}

- divideSelfMonomial:aMonomial
{
    ca_obj_t s;
    ca_obj_c sc;
    ca_vardnsmonom_t m;
    if (refCount>1) return idReplace(self,[self divideMonomial:aMonomial]);
    
    m = ca_vardnsmonom_id2t([aMonomial terms]);
    s = ca_obj_id2ref([aMonomial scalar],&sc);
    ca_obj_vardnsexpdegspspol_indivmonomsc(ca_obj_vardnsexpdegspspol_id2c(self),m,s,ca_obj_vardnsexpdegspspol_getargs(self));
    return [self invalidate];
}

- _add:(int)v:B multiplyMonomial:b:(int)w
{
    ca_obj_vardnsexpdegspspol_c c;
    ca_obj_c bc;
    ca_obj_t bs;
    ca_vardnsmonom_t bm;

    bm = ca_vardnsmonom_id2t([b terms]);
    bs = ca_obj_id2ref([b scalar],&bc);
    ca_obj_vardnsexpdegspspol_ooaddmulmonomsc(&c,ca_obj_vardnsexpdegspspol_id2c(self),v,ca_obj_vardnsexpdegspspol_id2t(B),bm,bs,w,ca_obj_vardnsexpdegspspol_getargs(self));
    return ca_obj_vardnsexpdegspspol_c2id(self,&c);
}

- _addSelf:(int)v:B multiplyMonomial:b:(int)w
{
    ca_obj_c bc;
    ca_obj_t bs;
    ca_vardnsmonom_t bm;
    if (refCount>1) return idReplace(self,[self _add:v:B multiplyMonomial:b:w]);
    
    bm = ca_vardnsmonom_id2t([b terms]);
    bs = ca_obj_id2ref([b scalar],&bc);
    ca_obj_vardnsexpdegspspol_inaddmulmonomsc(ca_obj_vardnsexpdegspspol_id2c(self),v,ca_obj_vardnsexpdegspspol_id2t(B),bm,bs,w,ca_obj_vardnsexpdegspspol_getargs(self));
    return [self invalidate];
}

- _multiplyScalar:a:(int)v add:B multiplyMonomial:b:(int)w
{
    ca_obj_vardnsexpdegspspol_c c;
    ca_obj_c ac,bc;
    ca_obj_t as,bs;
    ca_vardnsmonom_t bm;
    
    as = ca_obj_id2ref(a,&ac);
    bm = ca_vardnsmonom_id2t([b terms]);
    bs = ca_obj_id2ref([b scalar],&bc);
    ca_obj_vardnsexpdegspspol_oomulscaddmulmonomsc(&c,ca_obj_vardnsexpdegspspol_id2c(self),as,v,ca_obj_vardnsexpdegspspol_id2t(B),bm,bs,w,ca_obj_vardnsexpdegspspol_getargs(self));
    return ca_obj_vardnsexpdegspspol_c2id(self,&c);
}

- _multiplySelfScalar:a:(int)v add:B multiplyMonomial:b:(int)w
{
    ca_obj_c ac,bc;
    ca_obj_t as,bs;
    ca_vardnsmonom_t bm;
    if (refCount>1) return idReplace(self,[self _multiplyScalar:a:v add:B multiplyMonomial:b:w]);
    
    as = ca_obj_id2ref(a,&ac);
    bm = ca_vardnsmonom_id2t([b terms]);
    bs = ca_obj_id2ref([b scalar],&bc);
    ca_obj_vardnsexpdegspspol_inmulscaddmulmonomsc(ca_obj_vardnsexpdegspspol_id2c(self),as,v,ca_obj_vardnsexpdegspspol_id2t(B),bm,bs,w,ca_obj_vardnsexpdegspspol_getargs(self));
    return [self invalidate];
}

- fileOutOn:aFiler
{
    ca_obj_vardnsexpdegspspol_args args;
    assert([self check]);
    [super fileOutOn:aFiler];
    args = ca_obj_vardnsexpdegspspol_getargs(self);
    ca_obj_vardnsexpdegspspol_args_fileOut(aFiler,&args);
    ca_obj_vardnsexpdegspspol_fileOut(aFiler,&value,args);
    return self;
}

- fileInFrom:aFiler
{
    ca_obj_vardnsexpdegspspol_args args;
    [super fileInFrom:aFiler];
    ca_obj_vardnsexpdegspspol_args_fileIn(aFiler,&args);
    ca_obj_vardnsexpdegspspol_fileIn(aFiler,&value,args);
    return self;
}

@end

