#include "cakit.h"

static ca_obj_args ca_obj_getargs(id object)
{
    ca_obj_args args;args.proto = object;return args;
}

static int ca_obj_size(ca_obj_args args)
{
    return 1;			/* pointer increment */
}

static int ca_obj_bsize(ca_obj_args args)
{
    return sizeof(ca_obj_c);	/* byte size carrier */
}

#if 0
static ca_obj_t  ca_obj_id2t(id object) { /* not needed */ }
static ca_obj_c *ca_obj_id2t(id object) { /* not needed */ }
#endif

static ca_obj_t ca_obj_id2ref(id object,ca_obj_c *ref)
{
    return object;			/* read-only, scratch space "ref" */
}

static id ca_obj_t2id(id proto,ca_obj_t t)
{
    return [t cheapCopy];		/* new object, contains copy of "t" */
}

static id ca_obj_c2id(id proto,ca_obj_c *c)
{
    return *c;				/* new object, contains "c" */
}

static int ca_obj_check(ca_obj_t self,ca_obj_args args)
{
    assert(args.proto && self);[args.proto check];[self check];return 1;
}

static void ca_obj_oozero(ca_obj_c *c,ca_obj_args args)
{
    *c = [args.proto zero];
}

static void ca_obj_copy(ca_obj_c *c,ca_obj_t a,ca_obj_args args)
{
    *c = [a cheapCopy];
}

static void ca_obj_deepcopy(ca_obj_c *c,ca_obj_t a,ca_obj_args args)
{
    *c = [a deepCopy];
}

static void ca_obj_move(ca_obj_c *c,ca_obj_c *a,ca_obj_args args)
{
    *c = *a;*a = nil;
}

static void ca_obj_clear(ca_obj_c *c,ca_obj_args args)
{
    *c = [*c free];
}

static unsigned ca_obj_hash(ca_obj_t a,ca_obj_args args)
{
    return [a hash];
}

static int ca_obj_iseq(ca_obj_t a,ca_obj_t b,ca_obj_args args)
{
    return (a==b)?YES:[a isEqual:b];
}

static int ca_obj_sgn(ca_obj_t a,ca_obj_args args)
{
    return [a sign];
}

static int ca_obj_cmp(ca_obj_t a,ca_obj_t b,ca_obj_args args)
{
    return (a==b)?0:[a compare:b];
}

static int ca_obj_iszero(ca_obj_t a,ca_obj_args args)
{
    return [a isZero];
}

static int ca_obj_isop(ca_obj_t a,ca_obj_t b,ca_obj_args args)
{
    return [a isOpposite:b];
}

static void ca_obj_ooneg(ca_obj_c *c,ca_obj_t a,ca_obj_args args)
{
    *c = [a negate];
}

static void ca_obj_inneg(ca_obj_c *c,ca_obj_args args)
{
    *c = [*c negateSelf];
}

static void ca_obj_oodbl(ca_obj_c *c,ca_obj_t a,int v,ca_obj_args args)
{
    *c = [a _double:v];
}

static void ca_obj_indbl(ca_obj_c *c,int v,ca_obj_args args)
{
    *c = [*c _doubleSelf:v];
}

static void ca_obj_ooadd(ca_obj_c *c,ca_obj_t a,int v,ca_obj_t b,int w,ca_obj_args args)
{
    *c = [a _add:v:b:w];
}

static void ca_obj_inadd(ca_obj_c *c,int v,ca_obj_t b,int w,ca_obj_args args)
{
    *c = [*c _addSelf:v:b:w];
}

static int ca_obj_isone(ca_obj_t a,ca_obj_args args)
{
    return [a isOne];
}

static int ca_obj_isminusone(ca_obj_t a,ca_obj_args args)
{
    return [a isMinusOne];
}

static void ca_obj_oosqr(ca_obj_c *c,ca_obj_t a,ca_obj_args args)
{
    *c = [a square];
}

static void ca_obj_insqr(ca_obj_c *c,ca_obj_args args)
{
    *c = [*c squareSelf];
}

static void ca_obj_oomul(ca_obj_c *c,ca_obj_t a,ca_obj_t b,ca_obj_args args)
{
    *c = [a multiply:b];
}

static void ca_obj_inmul(ca_obj_c *c,ca_obj_t b,ca_obj_args args)
{
    *c = [*c multiplySelf:b];
}

static void ca_obj_oomulv(ca_obj_c *c,ca_obj_t a,ca_obj_t b,int v,ca_obj_args args)
{
    *c = [a _multiply:b:v];
}

static void ca_obj_inmulv(ca_obj_c *c,ca_obj_t b,int v,ca_obj_args args)
{
    *c = [*c _multiplySelf:b:v];
}

static void ca_obj_ooaddmul(ca_obj_c *c,ca_obj_t a,int v,ca_obj_t b,ca_obj_t t,int w,ca_obj_args args)
{
    *c = [a _add:v:b multiply:t:w];
}

static void ca_obj_inaddmul(ca_obj_c *c,int v,ca_obj_t b,ca_obj_t t,int w,ca_obj_args args)
{
    *c = [*c _addSelf:v:b multiply:t:w];
}

static void ca_obj_oomuladd(ca_obj_c *c,ca_obj_t a,ca_obj_t s,int v,ca_obj_t b,int w,ca_obj_args args)
{
    *c = [a _multiply:s:v add:b:w];
}

static void ca_obj_inmuladd(ca_obj_c *c,ca_obj_t s,int v,ca_obj_t b,int w,ca_obj_args args)
{
    *c = [*c _multiplySelf:s:v add:b:w];
}

static void ca_obj_oomuladdmul(ca_obj_c *c,ca_obj_t a,ca_obj_t s,int v,ca_obj_t b,ca_obj_t t,int w,ca_obj_args args)
{
    *c = [a _multiply:s:v add:b multiply:t:w];
}

static void ca_obj_inmuladdmul(ca_obj_c *c,ca_obj_t s,int v,ca_obj_t b,ca_obj_t t,int w,ca_obj_args args)
{
    *c = [*c _multiplySelf:s:v add:b multiply:t:w];
}

static void ca_obj_ooaddsqr(ca_obj_c *c,ca_obj_t a,int v,ca_obj_t b,int w,ca_obj_args args)
{
    *c = [a _addSquare:v:b:w];
}

static void ca_obj_inaddsqr(ca_obj_c *c,int v,ca_obj_t b,int w,ca_obj_args args)
{
    *c = [*c _addSelfSquare:v:b:w];
}

static void ca_obj_ooinv(ca_obj_c *c,ca_obj_t a,ca_obj_args args)
{
    *c = [a inverse];
}

static void ca_obj_ininv(ca_obj_c *c,ca_obj_args args)
{
    *c = [*c inverseSelf];
}

static BOOL ca_obj_oodiv(ca_obj_c *c,ca_obj_t a,ca_obj_t b,ca_obj_args args)
{
    id Q = [a divide:b];
    if (Q) {
	*c = Q;return SUCCESS;
    } else {
	return FAILURE;
    }
}

static void ca_obj_indiv(ca_obj_c *c,ca_obj_t b,ca_obj_args args)
{
    id Q = [*c divideSelf:b];
    if (Q) {
	*c = Q;
    } else {
	fprintf(stderr,"-exact division failed\n");abort();
    }
}

static void ca_obj_args_fileOut(id aFiler,ca_obj_args *args) {}
static void ca_obj_args_fileIn(id aFiler,ca_obj_args *args) {}

static void ca_obj_fileOut(id aFiler,ca_obj_c *a,ca_obj_args args)
{
    [aFiler fileOut:a type:'@'];
}

static void ca_obj_fileIn(id aFiler,ca_obj_c *c,ca_obj_args args)
{
    [aFiler fileIn:c type:'@'];
}


/*
 * Computer Algebra Kit (c) 1993,95 by Comp.Alg.Objects.  All Rights Reserved.
 */

static int ca_unimonom_size(ca_unimonom_args args)
{
    return 1;
}

static int ca_unimonom_bsize(ca_unimonom_args args)
{
    return sizeof(ca_unimonom_t);
}

static int ca_unimonom_check(ca_unimonom_t self,ca_unimonom_args args)
{
    assert(self >= 0);return 1;
}

static void ca_unimonom_clear(ca_unimonom_c *c,ca_unimonom_args args)
{
    /* nothing to clear, but the following might help... */
    #ifndef DEBUG
    *c = (ca_unimonom_t)0xcafebabe;
    #endif
}

static void ca_unimonom_copy(ca_unimonom_c *c,ca_unimonom_t a,ca_unimonom_args args)
{
    *c = a;
}

static void ca_unimonom_move(ca_unimonom_c *c,ca_unimonom_c *a,ca_unimonom_args args)
{
    *c = *a;
    #ifndef DEBUG
    *a = (ca_unimonom_t)0xcafebabe;
    #endif
}

static void ca_unimonom_args_fileOut(id aFiler,ca_unimonom_args *args) {}
static void ca_unimonom_args_fileIn(id aFiler,ca_unimonom_args *args) {}

static void ca_unimonom_fileOut(id aFiler,ca_unimonom_c *c,ca_unimonom_args args)
{
    [aFiler fileOut:c type:'i'];
}

static void ca_unimonom_fileIn(id aFiler,ca_unimonom_c *c,ca_unimonom_args args)
{
    [aFiler fileIn:c type:'i'];
}

static unsigned ca_unimonom_hash(ca_unimonom_t self,ca_unimonom_args args)
{
    return self;
}

static int ca_unimonom_deg(ca_unimonom_t self ,ca_unimonom_args args)
{
    return self;
}

static int ca_unimonom_isone(ca_unimonom_t self ,ca_unimonom_args args)
{
    return self == 0;
}

static int ca_unimonom_iseq(ca_unimonom_t a,ca_unimonom_t b ,ca_unimonom_args args)
{
    return a == b;
}

static int ca_unimonom_iseqmul(ca_unimonom_t a,ca_unimonom_t x,ca_unimonom_t b ,ca_unimonom_args args)
{
    return a == x+b;
}

static int ca_unimonom_cmp(ca_unimonom_t a,ca_unimonom_t b ,ca_unimonom_args args)
{
    return a-b;
}

static int ca_unimonom_cmpmul(ca_unimonom_t a,ca_unimonom_t x,ca_unimonom_t b ,ca_unimonom_args args)
{
    return a-x-b;
}

static void ca_unimonom_oomul(ca_unimonom_c *c,ca_unimonom_t a,ca_unimonom_t b,ca_unimonom_args args)
{
    *c = a + b;
}

static void ca_unimonom_inmul(ca_unimonom_c *c,ca_unimonom_t b,ca_unimonom_args args)
{
    *c += b;
}

static BOOL ca_unimonom_oodiv(ca_unimonom_c *c,ca_unimonom_t a,ca_unimonom_t b,ca_unimonom_args args)
{
    if (a < b) {
	return FAILURE;
    } else {
	*c = a - b;
	return SUCCESS;
    }
}

static void ca_unimonom_indiv(ca_unimonom_c *c,ca_unimonom_t b,ca_unimonom_args args)
{
    if (*c < b) { fprintf(stderr,"Division not Exact\n");abort(); } /* should stay */
    *c -= b;
}

#if ca_obj_pervalue
static ca_obj_t ca_objseq_tval(ca_objseq_t self)
{
    return *self;
}
static ca_obj_c *ca_objseq_cval(ca_objseq_t self)
{
    return self;
}
#else
static ca_obj_t ca_objseq_tval(ca_objseq_t self)
{
    return self;
}
static ca_obj_c *ca_objseq_cval(ca_objseq_t self)
{
    return self;
}
#endif

static int ca_objseq_check(ca_objseq_t self,int n,ca_obj_args args)
{
    while (n--) {
	ca_obj_check(ca_objseq_tval(self),args);
	self += ca_obj_size(args);
    }
    return 1;
}

static ca_objseq_t ca_objseq_alloc(int n,ca_obj_args args)
{
    return (ca_objseq_t)OC_Malloc(n * ca_obj_bsize(args));
}

static ca_objseq_t ca_objseq_realloc(ca_objseq_t self,int n,ca_obj_args args)
{
    return (ca_objseq_t)OC_Realloc(self,n * ca_obj_bsize(args));
}

static ca_objseq_t ca_objseq_free(ca_objseq_t self,ca_obj_args args)
{
    OC_Free(self);return NULL;
}

static void ca_objseq_oozero(ca_objseq_t c,int n,ca_obj_args args)
{
    while (n--) {
	ca_obj_oozero(ca_objseq_cval(c),args);
	c += ca_obj_size(args);
    }
}

static void ca_objseq_copy(ca_objseq_t c,ca_objseq_t a,int n,ca_obj_args args)
{
    assert(n >= 0);
    while (n--) {
	ca_obj_copy(ca_objseq_cval(c),ca_objseq_tval(a),args);
	c+=ca_obj_size(args);a+=ca_obj_size(args);
    }
}

static void ca_objseq_deepcopy(ca_objseq_t c,ca_objseq_t a,int n,ca_obj_args args)
{
    assert(n >= 0);
    while (n--) {
	ca_obj_deepcopy(ca_objseq_cval(c),ca_objseq_tval(a),args);
	c+=ca_obj_size(args);a+=ca_obj_size(args);
    }
}

#if ca_obj_isvalue
static void ca_objseq_clear(ca_objseq_t self,int n,ca_obj_args args)
{
    /* nothing to clear */
}
#else
static void ca_objseq_clear(ca_objseq_t self,int n,ca_obj_args args)
{
    while (n--) {
	ca_obj_clear(self,args);
	self+=ca_obj_size(args);
    }
}
#endif /* ca_obj_isvalue */

static int ca_objseq_iseq(ca_objseq_t a,ca_objseq_t b,int n,ca_obj_args args)
{
    assert(n >= 0 && a != b);
    while (n--) {
	if (!ca_obj_iseq(ca_objseq_tval(a),ca_objseq_tval(b),args)) {
	    return 0;
	} else {
	    a+=ca_obj_size(args);b+=ca_obj_size(args);
	}
    }
    return 1;
}

static unsigned ca_objseq_hash(ca_objseq_t a,int n,ca_obj_args args)
{
    assert(n >= 0);
    return (n)?ca_obj_hash(ca_objseq_tval(a),args):0;
}

static void ca_objseq_place(ca_objseq_t self,ca_obj_t a,int i,ca_obj_args args)
{
    ca_obj_c *c = ca_objseq_cval(self + i * ca_obj_size(args));
    ca_obj_clear(c,args);ca_obj_copy(c,a,args);
}

static int ca_objseq_insertlast(ca_objseq_t self,ca_obj_t a,int n,ca_obj_args args)
{
    ca_obj_c *c;
    assert(n >= 0);
    c = ca_objseq_cval(self + n * ca_obj_size(args));
    ca_obj_copy(c,a,args);return ++n;
}

static int ca_objseq_insertfirst(ca_objseq_t self,ca_obj_t a,int n,ca_obj_args args)
{
    int j;
    assert(n > 0);
    self += n * ca_obj_size(args);
    j=n;while(j--) {
	ca_objseq_t t;
	t = self - ca_obj_size(args);
	ca_obj_move(ca_objseq_cval(self),ca_objseq_cval(t),args);
	self = t;
    }
    ca_obj_copy(ca_objseq_cval(self),a,args);
    return ++n;
}

static int ca_objseq_insertat(ca_objseq_t self,ca_obj_t a,int i,int n,ca_obj_args args)
{
    assert(0 <= i && i < n);
    self += i*ca_obj_size(args);
    return i + ca_objseq_insertfirst(self,a,n-i,args);
}

static int ca_objseq_freelast(ca_objseq_t self,int n,ca_obj_args args)
{
    ca_obj_c *c;assert(0 < n);
    --n;c = ca_objseq_cval(self + n * ca_obj_size(args));
    ca_obj_clear(c,args);return n;
}

static int ca_objseq_freefirst(ca_objseq_t self,int n,ca_obj_args args)
{
    int j;
    assert(0 < n);
    ca_obj_clear(ca_objseq_cval(self),args);
    --n;j=n;while(j--) {
	ca_objseq_t t;
	t = self+ca_obj_size(args);
	ca_obj_move(ca_objseq_cval(self),ca_objseq_cval(t),args);
	self = t;
    }
    return n;
}

static int ca_objseq_freeat(ca_objseq_t self,int i,int n,ca_obj_args args)
{
    assert(0 <= i && i < n);
    self += i*ca_obj_size(args);
    return i + ca_objseq_freefirst(self,n-i,args);
}

static ca_obj_t ca_objseq_at(ca_objseq_t self,int i,ca_obj_args args)
{
    ca_obj_t res;assert(0 <= i);
    res = ca_objseq_tval(self + i * ca_obj_size(args));
    assert(ca_obj_check(res,args));
    return res;
}

static ca_obj_t ca_objseq_last(ca_objseq_t self,int n,ca_obj_args args)
{
    return ca_objseq_at(self,n-1,args);
}

static ca_obj_c *ca_objseq_cvalat(ca_objseq_t self,int i,ca_obj_args args)
{
    assert(0 <= i);return ca_objseq_cval(self + i * ca_obj_size(args));
}

static int ca_objseq_iszero(ca_objseq_t a,int n,ca_obj_args args)
{
    assert(n >= 0);
    while (n--) {
	if (ca_obj_iszero(ca_objseq_tval(a),args)) {
	    a+=ca_obj_size(args);
	} else {
	    return 0;
	}
    }
    return 1;
}

static int ca_objseq_isop(ca_objseq_t a,ca_objseq_t b,int n,ca_obj_args args)
{
    assert(n >= 0 && a != b);
    while (n--) {
	if (!ca_obj_isop(ca_objseq_tval(a),ca_objseq_tval(b),args)) {
	    return 0;
	} else {
	    a+=ca_obj_size(args);b+=ca_obj_size(args);
	}
    }
    return 1;
}

static void ca_objseq_ooneg(ca_objseq_t c,ca_objseq_t a,int n,ca_obj_args args)
{
    assert(n >= 0);
    while (n--) {
	ca_obj_ooneg(ca_objseq_cval(c),ca_objseq_tval(a),args);
	c+=ca_obj_size(args);a+=ca_obj_size(args);
    }
}

static void ca_objseq_inneg(ca_objseq_t a,int n,ca_obj_args args)
{
    assert(n >= 0);
    while (n--) {
	ca_obj_inneg(ca_objseq_cval(a),args);
	a += ca_obj_size(args);
    }
}

static void ca_objseq_oonegv(ca_objseq_t c,ca_objseq_t a,int v,int n,ca_obj_args args)
{
    assert(v*v == 1);if (v == -1) ca_objseq_ooneg(c,a,n,args);
    else ca_objseq_copy(c,a,n,args);
}

static void ca_objseq_innegv(ca_objseq_t a,int v,int n,ca_obj_args args)
{
    assert(v*v == 1);if (v == -1) ca_objseq_inneg(a,n,args);
}

static void ca_objseq_oodbl(ca_objseq_t c,ca_objseq_t a,int v,int n,ca_obj_args args)
{
    assert(n >= 0 && v*v == 1);
    while (n--) {
	ca_obj_oodbl(ca_objseq_cval(c),ca_objseq_tval(a),v,args);
	c+=ca_obj_size(args);a+=ca_obj_size(args);
    }
}

static void ca_objseq_indbl(ca_objseq_t a,int v,int n,ca_obj_args args)
{
    assert(n >= 0 && v*v == 1);
    while (n--) {
	ca_obj_indbl(ca_objseq_cval(a),v,args);
	a += ca_obj_size(args);
    }
}

static void ca_objseq_ooadd(ca_objseq_t c,ca_objseq_t a,int v,ca_objseq_t b,int w,int n,ca_obj_args args)
{
    assert(n >= 0 && a != b && v*v == 1 && w*w == 1);
    while (n--) {
	ca_obj_ooadd(ca_objseq_cval(c),ca_objseq_tval(a),v,ca_objseq_tval(b),w,args);
	c+=ca_obj_size(args);a+=ca_obj_size(args);b+=ca_obj_size(args);
    }
}

static void ca_objseq_inadd(ca_objseq_t a,int v,ca_objseq_t b,int w,int n,ca_obj_args args)
{
    assert(n >= 0 && a != b && v*v == 1 && w*w == 1);
    while (n--) {
	ca_obj_inadd(ca_objseq_cval(a),v,ca_objseq_tval(b),w,args);
	a+=ca_obj_size(args);b+=ca_obj_size(args);
    }
}

static void ca_objseq_oomulsc(ca_objseq_t c,ca_objseq_t a,ca_obj_t s,int n,ca_obj_args args)
{
    assert(n >= 0);
    while (n--) {
	ca_obj_oomul(ca_objseq_cval(c),ca_objseq_tval(a),s,args);
	c+=ca_obj_size(args);a+=ca_obj_size(args);
    }
}

static void ca_objseq_inmulsc(ca_objseq_t a,ca_obj_t s,int n,ca_obj_args args)
{
    assert(n >= 0);
    while (n--) {
	ca_obj_inmul(ca_objseq_cval(a),s,args);
	a+=ca_obj_size(args);
    }
}

static void ca_objseq_oomulscv(ca_objseq_t c,ca_objseq_t a,ca_obj_t s,int v,int n,ca_obj_args args)
{
    assert(n >= 0 && v*v == 1);
    while (n--) {
	ca_obj_oomulv(ca_objseq_cval(c),ca_objseq_tval(a),s,v,args);
	c+=ca_obj_size(args);a+=ca_obj_size(args);
    }
}

static void ca_objseq_inmulscv(ca_objseq_t a,ca_obj_t s,int v,int n,ca_obj_args args)
{
    assert(n >= 0 && v*v == 1);
    while (n--) {
	ca_obj_inmulv(ca_objseq_cval(a),s,v,args);
	a+=ca_obj_size(args);
    }
}

static void ca_objseq_ooaddmulsc(ca_objseq_t c,ca_objseq_t a,int v,ca_objseq_t b,ca_obj_t t,int w,int n,ca_obj_args args)
{
    assert(n >= 0 && v*v == 1 && w*w == 1);
    while (n--) {
	ca_obj_ooaddmul(ca_objseq_cval(c),ca_objseq_tval(a),v,ca_objseq_tval(b),t,w,args);
	a+=ca_obj_size(args);b+=ca_obj_size(args);c+=ca_obj_size(args);
    }
}

static void ca_objseq_oomulscadd(ca_objseq_t c,ca_objseq_t a,ca_obj_t s,int v,ca_objseq_t b,int w,int n,ca_obj_args args)
{
    assert(n >= 0 && v*v == 1 && w*w == 1);
    while (n--) {
	ca_obj_oomuladd(ca_objseq_cval(c),ca_objseq_tval(a),s,v,ca_objseq_tval(b),w,args);
	a+=ca_obj_size(args);b+=ca_obj_size(args);c+=ca_obj_size(args);
    }
}

static void ca_objseq_oomulscaddmulsc(ca_objseq_t c,ca_objseq_t a,ca_obj_t s,int v,ca_objseq_t b,ca_obj_t t,int w,int n,ca_obj_args args)
{
    assert(n >= 0 && v*v == 1 && w*w == 1);
    while (n--) {
	ca_obj_oomuladdmul(ca_objseq_cval(c),ca_objseq_tval(a),s,v,ca_objseq_tval(b),t,w,args);
	a+=ca_obj_size(args);b+=ca_obj_size(args);c+=ca_obj_size(args);
    }
}

static void ca_objseq_inaddmulsc(ca_objseq_t a,int v,ca_objseq_t b,ca_obj_t t,int w,int n,ca_obj_args args)
{
    assert(n >= 0 && v*v == 1 && w*w == 1);
    while (n--) {
	ca_obj_inaddmul(ca_objseq_cval(a),v,ca_objseq_tval(b),t,w,args);
	a+=ca_obj_size(args);b+=ca_obj_size(args);
    }
}

static void ca_objseq_inmulscadd(ca_objseq_t a,ca_obj_t s,int v,ca_objseq_t b,int w,int n,ca_obj_args args)
{
    assert(n >= 0 && v*v == 1 && w*w == 1);
    while (n--) {
	ca_obj_inmuladd(ca_objseq_cval(a),s,v,ca_objseq_tval(b),w,args);
	a+=ca_obj_size(args);b+=ca_obj_size(args);
    }
}

static void ca_objseq_inmulscaddmulsc(ca_objseq_t a,ca_obj_t s,int v,ca_objseq_t b,ca_obj_t t,int w,int n,ca_obj_args args)
{
    assert(n >= 0 && v*v == 1 && w*w == 1);
    while (n--) {
	ca_obj_inmuladdmul(ca_objseq_cval(a),s,v,ca_objseq_tval(b),t,w,args);
	a+=ca_obj_size(args);b+=ca_obj_size(args);
    }
}

static BOOL ca_objseq_oodivsc(ca_objseq_t c,ca_objseq_t a,ca_obj_t s,int n,ca_obj_args args)
{
    int i;
    BOOL failed;
    ca_objseq_t orgc = c;
    assert(n >= 0);
   
    for(i=0;i<n;i++) {
    
	failed = ca_obj_oodiv(ca_objseq_cval(c),ca_objseq_tval(a),s,args);
	
	if (failed) {
	    ca_objseq_clear(orgc,i - 1,args);
	    return FAILURE;
	} else {
	    c+=ca_obj_size(args);a+=ca_obj_size(args);
	}
    }
    
    return SUCCESS;
}

static void ca_objseq_indivsc(ca_objseq_t a,ca_obj_t s,int n,ca_obj_args args)
{
    assert(n >= 0);
    while (n--) {
	ca_obj_indiv(ca_objseq_cval(a),s,args);
	a+=ca_obj_size(args);
    }
}

static void ca_objseq_oodotsqr(ca_obj_c *c,ca_objseq_t a,int n,ca_obj_args args)
{
    assert(n >= 0);
    ca_obj_oozero(c,args);
    while (n--) {
	ca_obj_inaddsqr(c,+1,ca_objseq_tval(a),+1,args);a += ca_obj_size(args);
    }
}

static void ca_objseq_oodotmul(ca_obj_c *c,ca_objseq_t a,ca_objseq_t b,int n,ca_obj_args args)
{
    assert(n >= 0);
    ca_obj_oozero(c,args);
    while (n--) {
	ca_obj_inaddmul(c,+1,ca_objseq_tval(a),ca_objseq_tval(b),+1,args);
	a += ca_obj_size(args);b += ca_obj_size(args);
    }
}

static void ca_objseq_args_fileOut(id aFiler,ca_obj_args *args)
{
    ca_obj_args_fileOut(aFiler,args);
}
static void ca_objseq_args_fileIn(id aFiler,ca_obj_args *args)
{
    ca_obj_args_fileIn(aFiler,args);
}

static void ca_objseq_fileOut(id aFiler,ca_objseq_t self,int n,ca_obj_args args)
{
    assert(n>=0);
    while (n--) {
	ca_obj_fileOut(aFiler,ca_objseq_cval(self),args);
	self += ca_obj_size(args);
    }
}

static void ca_objseq_fileIn(id aFiler,ca_objseq_t self,int n,ca_obj_args args)
{
    assert(n>=0);
    while (n--) {
	ca_obj_fileIn(aFiler,ca_objseq_cval(self),args);
	self += ca_obj_size(args);
    }
}

static int ca_obj_vardnsrecdegdnspolseq_check(ca_obj_vardnsrecdegdnspolseq_t self,int n,ca_obj_vardnsrecdegdnspol_args args)
{
    if (n) {
	ca_obj_t lcf = ca_objseq_last(self,n,args.sargs);
	assert(!ca_obj_iszero(lcf,args.sargs));
    }
    
    return ca_objseq_check(self,n,args.sargs);
}

static int ca_obj_vardnsrecdegdnspolseq_copy(ca_obj_vardnsrecdegdnspolseq_t c,ca_obj_vardnsrecdegdnspolseq_t a,int n,ca_obj_vardnsrecdegdnspol_args args)
{
    ca_objseq_copy(c,a,n,args.sargs);return n;
}

static int ca_obj_vardnsrecdegdnspolseq_deepcopy(ca_obj_vardnsrecdegdnspolseq_t c,ca_obj_vardnsrecdegdnspolseq_t a,int n,ca_obj_vardnsrecdegdnspol_args args)
{
    ca_objseq_deepcopy(c,a,n,args.sargs);return n;
}

static int ca_obj_vardnsrecdegdnspolseq_count(ca_obj_vardnsrecdegdnspolseq_t self,int n,ca_obj_vardnsrecdegdnspol_args args)
{
    int count = 0;
    while (n--) {
	if (!ca_obj_iszero(ca_objseq_tval(self),args.sargs)) count++;
	self += ca_obj_size(args.sargs);
    }
    return count;
}

static int ca_obj_vardnsrecdegdnspolseq_ord(ca_obj_vardnsrecdegdnspolseq_t self,int n,ca_obj_vardnsrecdegdnspol_args args)
{
    int ord = -1;
    while (n--) {
	if (ca_obj_iszero(ca_objseq_tval(self),args.sargs)) {
	    ord++;self += ca_obj_size(args.sargs);
	} else {
	    break;
	}
    }
    return ord;
}

static int ca_obj_vardnsrecdegdnspolseq_iseq(ca_obj_vardnsrecdegdnspolseq_t a,int an,ca_obj_vardnsrecdegdnspolseq_t b,int bn,ca_obj_vardnsrecdegdnspol_args args)
{
    return (an==bn)?ca_objseq_iseq(a,b,an,args.sargs):0;
}

static int ca_obj_vardnsrecdegdnspolseq_isop(ca_obj_vardnsrecdegdnspolseq_t a,int an,ca_obj_vardnsrecdegdnspolseq_t b,int bn,ca_obj_vardnsrecdegdnspol_args args)
{
    return (an==bn)?ca_objseq_isop(a,b,an,args.sargs):0;
}

static int ca_obj_vardnsrecdegdnspolseq_hash(ca_obj_vardnsrecdegdnspolseq_t a,int an,ca_obj_vardnsrecdegdnspol_args args)
{
    return ca_objseq_hash(a,an,args.sargs);
}

static int ca_obj_vardnsrecdegdnspolseq_isone(ca_obj_vardnsrecdegdnspolseq_t a,int an,ca_obj_vardnsrecdegdnspol_args args)
{
    return an == 1 && ca_obj_isone(ca_objseq_tval(a),args.sargs);
}

static int ca_obj_vardnsrecdegdnspolseq_isminusone(ca_obj_vardnsrecdegdnspolseq_t a,int an,ca_obj_vardnsrecdegdnspol_args args)
{
    return an == 1 && ca_obj_isminusone(ca_objseq_tval(a),args.sargs);
}

static int ca_obj_vardnsrecdegdnspolseq_removezeroes(ca_obj_vardnsrecdegdnspolseq_t a,int n,ca_obj_vardnsrecdegdnspol_args args)
{
    a += n * ca_obj_size(args.sargs);
    while (n--) {
	a -= ca_obj_size(args.sargs);
	if (ca_obj_iszero(ca_objseq_tval(a),args.sargs)) {
	    ca_obj_clear(ca_objseq_cval(a),args.sargs);
	} else {
	    break;
	}
    }
    return n+1;
}

static int ca_obj_vardnsrecdegdnspolseq_delete(ca_obj_vardnsrecdegdnspolseq_t self,int n,ca_obj_vardnsrecdegdnspol_args args)
{
    n = n - 1;assert(n >= 0);
    ca_obj_clear(ca_objseq_cvalat(self,n,args.sargs),args.sargs);
    return ca_obj_vardnsrecdegdnspolseq_removezeroes(self,n,args);
}

static int ca_obj_vardnsrecdegdnspolseq_insert(ca_obj_vardnsrecdegdnspolseq_t self,int n,int e,ca_obj_t s,ca_obj_vardnsrecdegdnspol_args args)
{
    assert(ca_obj_iszero(s,args.sargs) == 0);
    if (e < n) {
	ca_obj_inadd(ca_objseq_cvalat(self,e,args.sargs),+1,s,+1,args.sargs);
	return ca_obj_vardnsrecdegdnspolseq_removezeroes(self,n,args);
    } else {
	ca_objseq_oozero(self + n * ca_obj_size(args.sargs),e + 1 - n,args.sargs);
	ca_obj_inadd(ca_objseq_cvalat(self,e,args.sargs),+1,s,+1,args.sargs);
	return e + 1;
    }
}

static int ca_obj_vardnsrecdegdnspolseq_ooneg(ca_obj_vardnsrecdegdnspolseq_t c,ca_obj_vardnsrecdegdnspolseq_t a,int n,ca_obj_vardnsrecdegdnspol_args args)
{
    ca_objseq_ooneg(c,a,n,args.sargs);return n;
}

static int ca_obj_vardnsrecdegdnspolseq_inneg(ca_obj_vardnsrecdegdnspolseq_t a,int n,ca_obj_vardnsrecdegdnspol_args args)
{
    ca_objseq_inneg(a,n,args.sargs);return n;
}

static int ca_obj_vardnsrecdegdnspolseq_oodbl(ca_obj_vardnsrecdegdnspolseq_t c,ca_obj_vardnsrecdegdnspolseq_t a,int n,int v,ca_obj_vardnsrecdegdnspol_args args)
{
    ca_objseq_oodbl(c,a,n,v,args.sargs);return ca_obj_vardnsrecdegdnspolseq_removezeroes(c,n,args);
}

static int ca_obj_vardnsrecdegdnspolseq_indbl(ca_obj_vardnsrecdegdnspolseq_t a,int n,int v,ca_obj_vardnsrecdegdnspol_args args)
{
    ca_objseq_indbl(a,n,v,args.sargs);return ca_obj_vardnsrecdegdnspolseq_removezeroes(a,n,args);
}

static int ca_obj_vardnsrecdegdnspolseq_ooadd(ca_obj_vardnsrecdegdnspolseq_t c,ca_obj_vardnsrecdegdnspolseq_t a,int an,int v,ca_obj_vardnsrecdegdnspolseq_t b,int bn,int w,ca_obj_vardnsrecdegdnspol_args args)
{
    assert(v*v == 1 && w*w == 1);
    
    if (an == bn) {
	ca_objseq_ooadd(c,a,v,b,w,an,args.sargs);
	return ca_obj_vardnsrecdegdnspolseq_removezeroes(c,an,args);
    } else {
	if (an < bn) {
	    ca_objseq_ooadd(c,a,v,b,w,an,args.sargs);
	    c += an*ca_obj_size(args.sargs);
	    b += an*ca_obj_size(args.sargs);
	    ca_objseq_oonegv(c,b,w,bn-an,args.sargs);
	    return bn;
	} else {
	    ca_objseq_ooadd(c,a,v,b,w,bn,args.sargs);
	    c += bn*ca_obj_size(args.sargs);
	    a += bn*ca_obj_size(args.sargs);
	    ca_objseq_oonegv(c,a,v,an-bn,args.sargs);
	    return an;
	}
    }
}

static int ca_obj_vardnsrecdegdnspolseq_inadd(ca_obj_vardnsrecdegdnspolseq_t a,int an,int v,ca_obj_vardnsrecdegdnspolseq_t b,int bn,int w,ca_obj_vardnsrecdegdnspol_args args)
{
    assert(v*v == 1 && w*w == 1);

    if (an == bn) {
	ca_objseq_inadd(a,v,b,w,an,args.sargs);
	return ca_obj_vardnsrecdegdnspolseq_removezeroes(a,an,args);
    } else {
	if (an < bn) {
	    ca_objseq_inadd(a,v,b,w,an,args.sargs);
	    a += an*ca_obj_size(args.sargs);
	    b += an*ca_obj_size(args.sargs);
	    ca_objseq_oonegv(a,b,w,bn-an,args.sargs);
	    return bn;
	} else {
	    ca_objseq_inadd(a,v,b,w,bn,args.sargs);
	    a += bn*ca_obj_size(args.sargs);
	    ca_objseq_innegv(a,v,an-bn,args.sargs);
	    return an;
	}
    }
}

static int ca_obj_vardnsrecdegdnspolseq_oomulsc(ca_obj_vardnsrecdegdnspolseq_t c,ca_obj_vardnsrecdegdnspolseq_t a,int n,ca_obj_t s,ca_obj_vardnsrecdegdnspol_args args)
{
    ca_objseq_oomulsc(c,a,s,n,args.sargs);return ca_obj_vardnsrecdegdnspolseq_removezeroes(c,n,args);
}

static int ca_obj_vardnsrecdegdnspolseq_inmulsc(ca_obj_vardnsrecdegdnspolseq_t a,int n,ca_obj_t s,ca_obj_vardnsrecdegdnspol_args args)
{
    ca_objseq_inmulsc(a,s,n,args.sargs);return ca_obj_vardnsrecdegdnspolseq_removezeroes(a,n,args);
}

static int ca_obj_vardnsrecdegdnspolseq_ooaddmulsc(ca_obj_vardnsrecdegdnspolseq_t c,ca_obj_vardnsrecdegdnspolseq_t a,int an,int v,ca_obj_vardnsrecdegdnspolseq_t b,int bn,ca_obj_t t,int w,ca_obj_vardnsrecdegdnspol_args args)
{
    assert(v*v == 1 && w*w == 1);
    
    if (an == bn) {
	ca_objseq_ooaddmulsc(c,a,v,b,t,w,an,args.sargs);
	return ca_obj_vardnsrecdegdnspolseq_removezeroes(c,an,args);
    } else {
	if (an < bn) {
	    ca_objseq_ooaddmulsc(c,a,v,b,t,w,an,args.sargs);
	    c += an*ca_obj_size(args.sargs);
	    b += an*ca_obj_size(args.sargs);
	    ca_objseq_oomulscv(c,b,t,w,bn-an,args.sargs);
	    return bn;
	} else {
	    ca_objseq_ooaddmulsc(c,a,v,b,t,w,bn,args.sargs);
	    c += bn*ca_obj_size(args.sargs);
	    a += bn*ca_obj_size(args.sargs);
	    ca_objseq_oonegv(c,a,v,an-bn,args.sargs);
	    return an;
	}
    }
}

static int ca_obj_vardnsrecdegdnspolseq_inaddmulsc(ca_obj_vardnsrecdegdnspolseq_t a,int an,int v,ca_obj_vardnsrecdegdnspolseq_t b,int bn,ca_obj_t t,int w,ca_obj_vardnsrecdegdnspol_args args)
{
    assert(v*v == 1 && w*w == 1);

    if (an == bn) {
	ca_objseq_inaddmulsc(a,v,b,t,w,an,args.sargs);
	return ca_obj_vardnsrecdegdnspolseq_removezeroes(a,an,args);
    } else {
	if (an < bn) {
	    ca_objseq_inaddmulsc(a,v,b,t,w,an,args.sargs);
	    a += an*ca_obj_size(args.sargs);
	    b += an*ca_obj_size(args.sargs);
	    ca_objseq_oomulscv(a,b,t,w,bn-an,args.sargs);
	    return bn;
	} else {
	    ca_objseq_inaddmulsc(a,v,b,t,w,bn,args.sargs);
	    a += bn*ca_obj_size(args.sargs);
	    ca_objseq_innegv(a,v,an-bn,args.sargs);
	    return an;
	}
    }
}

static int ca_obj_vardnsrecdegdnspolseq_oomulscadd(ca_obj_vardnsrecdegdnspolseq_t c,ca_obj_vardnsrecdegdnspolseq_t a,int an,ca_obj_t s,int v,ca_obj_vardnsrecdegdnspolseq_t b,int bn,int w,ca_obj_vardnsrecdegdnspol_args args)
{
    assert(v*v == 1 && w*w == 1);
    
    if (an == bn) {
	ca_objseq_oomulscadd(c,a,s,v,b,w,an,args.sargs);
	return ca_obj_vardnsrecdegdnspolseq_removezeroes(c,an,args);
    } else {
	if (an < bn) {
	    ca_objseq_oomulscadd(c,a,s,v,b,w,an,args.sargs);
	    c += an*ca_obj_size(args.sargs);
	    b += an*ca_obj_size(args.sargs);
	    ca_objseq_oonegv(c,b,w,bn-an,args.sargs);
	    return bn;
	} else {
	    ca_objseq_oomulscadd(c,a,s,v,b,w,bn,args.sargs);
	    c += bn*ca_obj_size(args.sargs);
	    a += bn*ca_obj_size(args.sargs);
	    ca_objseq_oomulscv(c,a,s,v,an-bn,args.sargs);
	    return an;
	}
    }
}

static int ca_obj_vardnsrecdegdnspolseq_inmulscadd(ca_obj_vardnsrecdegdnspolseq_t a,int an,ca_obj_t s,int v,ca_obj_vardnsrecdegdnspolseq_t b,int bn,int w,ca_obj_vardnsrecdegdnspol_args args)
{
    assert(v*v == 1 && w*w == 1);

    if (an == bn) {
	ca_objseq_inmulscadd(a,s,v,b,w,an,args.sargs);
	return ca_obj_vardnsrecdegdnspolseq_removezeroes(a,an,args);
    } else {
	if (an < bn) {
	    ca_objseq_inmulscadd(a,s,v,b,w,an,args.sargs);
	    a += an*ca_obj_size(args.sargs);
	    b += an*ca_obj_size(args.sargs);
	    ca_objseq_oonegv(a,b,w,bn-an,args.sargs);
	    return bn;
	} else {
	    ca_objseq_inmulscadd(a,s,v,b,w,bn,args.sargs);
	    a += bn*ca_obj_size(args.sargs);
	    ca_objseq_inmulscv(a,s,v,an-bn,args.sargs);
	    return an;
	}
    }
}

static int ca_obj_vardnsrecdegdnspolseq_oomulscaddmulsc(ca_obj_vardnsrecdegdnspolseq_t c,ca_obj_vardnsrecdegdnspolseq_t a,int an,ca_obj_t s,int v,ca_obj_vardnsrecdegdnspolseq_t b,int bn,ca_obj_t t,int w,ca_obj_vardnsrecdegdnspol_args args)
{
    assert(v*v == 1 && w*w == 1);
    
    if (an == bn) {
	ca_objseq_oomulscaddmulsc(c,a,s,v,b,t,w,an,args.sargs);
	return ca_obj_vardnsrecdegdnspolseq_removezeroes(c,an,args);
    } else {
	if (an < bn) {
	    ca_objseq_oomulscaddmulsc(c,a,s,v,b,t,w,an,args.sargs);
	    c += an*ca_obj_size(args.sargs);
	    b += an*ca_obj_size(args.sargs);
	    ca_objseq_oomulscv(c,b,t,w,bn-an,args.sargs);
	    return bn;
	} else {
	    ca_objseq_oomulscaddmulsc(c,a,s,v,b,t,w,bn,args.sargs);
	    c += bn*ca_obj_size(args.sargs);
	    a += bn*ca_obj_size(args.sargs);
	    ca_objseq_oomulscv(c,a,s,v,an-bn,args.sargs);
	    return an;
	}
    }
}

static int ca_obj_vardnsrecdegdnspolseq_inmulscaddmulsc(ca_obj_vardnsrecdegdnspolseq_t a,int an,ca_obj_t s,int v,ca_obj_vardnsrecdegdnspolseq_t b,int bn,ca_obj_t t,int w,ca_obj_vardnsrecdegdnspol_args args)
{
    assert(v*v == 1 && w*w == 1);

    if (an == bn) {
	ca_objseq_inmulscaddmulsc(a,s,v,b,t,w,an,args.sargs);
	return ca_obj_vardnsrecdegdnspolseq_removezeroes(a,an,args);
    } else {
	if (an < bn) {
	    ca_objseq_inmulscaddmulsc(a,s,v,b,t,w,an,args.sargs);
	    a += an*ca_obj_size(args.sargs);
	    b += an*ca_obj_size(args.sargs);
	    ca_objseq_oomulscv(a,b,t,w,bn-an,args.sargs);
	    return bn;
	} else {
	    ca_objseq_inmulscaddmulsc(a,s,v,b,t,w,bn,args.sargs);
	    a += bn*ca_obj_size(args.sargs);
	    ca_objseq_inmulscv(a,s,v,an-bn,args.sargs);
	    return an;
	}
    }
}

static BOOL ca_obj_vardnsrecdegdnspolseq_oodivsc(ca_obj_vardnsrecdegdnspolseq_t c,ca_obj_vardnsrecdegdnspolseq_t a,int n,ca_obj_t s,ca_obj_vardnsrecdegdnspol_args args)
{
    return ca_objseq_oodivsc(c,a,s,n,args.sargs);
}

static int ca_obj_vardnsrecdegdnspolseq_indivsc(ca_obj_vardnsrecdegdnspolseq_t a,int n,ca_obj_t s,ca_obj_vardnsrecdegdnspol_args args)
{
    ca_objseq_indivsc(a,s,n,args.sargs);return n;
}

static int ca_obj_vardnsrecdegdnspolseq_oomulmonomsc(ca_obj_vardnsrecdegdnspolseq_t c,ca_obj_vardnsrecdegdnspolseq_t a,int n,int m,ca_obj_t s,int v,ca_obj_vardnsrecdegdnspol_args args)
{
    ca_objseq_oozero(c,m,args.sargs);
    c += m * ca_obj_size(args.sargs);
    ca_objseq_oomulscv(c,a,s,v,n,args.sargs);
    return n + m;
}

static BOOL ca_obj_vardnsrecdegdnspolseq_oodivmonomsc(ca_obj_vardnsrecdegdnspolseq_t c,ca_obj_vardnsrecdegdnspolseq_t a,int n,int m,ca_obj_t s,ca_obj_vardnsrecdegdnspol_args args)
{
    assert(n >= m);
    a += m * ca_obj_size(args.sargs);
    return ca_objseq_oodivsc(c,a,s,n - m,args.sargs);
}

static int ca_obj_vardnsrecdegdnspolseq_ooaddmulmonomsc(ca_obj_vardnsrecdegdnspolseq_t c,ca_obj_vardnsrecdegdnspolseq_t a,int an,int v,ca_obj_vardnsrecdegdnspolseq_t b,int bn,int m,ca_obj_t t,int w,ca_obj_vardnsrecdegdnspol_args args)
{
    assert(v*v == 1 && w*w == 1);
    
    if (an == bn + m) {
	assert(an >= m);ca_objseq_oonegv(c,a,v,m,args.sargs);
	c += m*ca_obj_size(args.sargs);
	a += m*ca_obj_size(args.sargs);
	assert(an >= bn);ca_objseq_ooaddmulsc(c,a,v,b,t,w,bn,args.sargs);
	c -= m*ca_obj_size(args.sargs);
	return ca_obj_vardnsrecdegdnspolseq_removezeroes(c,an,args);
    } else {
	if (an < bn + m) {
	    if (an < m) {
		ca_objseq_oonegv(c,a,v,an,args.sargs);
		c += an*ca_obj_size(args.sargs);
		a += an*ca_obj_size(args.sargs);
		ca_objseq_oozero(c,m-an,args.sargs);
		c += m*ca_obj_size(args.sargs);
		ca_objseq_oomulscv(c,b,t,w,bn,args.sargs);
	    } else {
		assert(an >= m);ca_objseq_oonegv(c,a,v,m,args.sargs);
		c += m*ca_obj_size(args.sargs);
		a += m*ca_obj_size(args.sargs);
		assert(bn > an-m);ca_objseq_ooaddmulsc(c,a,v,b,t,w,an-m,args.sargs);
		c += (an-m)*ca_obj_size(args.sargs);
		a += (an-m)*ca_obj_size(args.sargs);
		ca_objseq_oomulscv(c,b,t,w,bn-(an-m),args.sargs);
	    }
	    return bn + m;
	} else {
	    assert(an >= m);ca_objseq_oonegv(c,a,v,m,args.sargs);
	    c += m*ca_obj_size(args.sargs);
	    a += m*ca_obj_size(args.sargs);
	    assert(an >= bn);ca_objseq_ooaddmulsc(c,a,v,b,t,w,bn,args.sargs);
	    c += bn*ca_obj_size(args.sargs);
	    a += bn*ca_obj_size(args.sargs);
	    assert(an > bn+m);ca_objseq_oonegv(c,a,v,an-bn-m,args.sargs);
	    return an;
	}
    }
}

static int ca_obj_vardnsrecdegdnspolseq_inaddmulmonomsc(ca_obj_vardnsrecdegdnspolseq_t a,int an,int v,ca_obj_vardnsrecdegdnspolseq_t b,int bn,int m,ca_obj_t t,int w,ca_obj_vardnsrecdegdnspol_args args)
{
    assert(v*v == 1 && w*w == 1);
    
    if (an == bn + m) {
	assert(an >= m);ca_objseq_innegv(a,v,m,args.sargs);
	a += m*ca_obj_size(args.sargs);
	assert(an >= bn);ca_objseq_inaddmulsc(a,v,b,t,w,bn,args.sargs);
	a -= m*ca_obj_size(args.sargs);
	return ca_obj_vardnsrecdegdnspolseq_removezeroes(a,an,args);
    } else {
	if (an < bn + m) {
	    if (an < m) {
		ca_objseq_innegv(a,v,an,args.sargs);
		a += an*ca_obj_size(args.sargs);
		ca_objseq_oozero(a,m-an,args.sargs);
		a += m*ca_obj_size(args.sargs);
		ca_objseq_oomulscv(a,b,t,w,bn,args.sargs);
	    } else {
		assert(an >= m);ca_objseq_innegv(a,v,m,args.sargs);
		a += m*ca_obj_size(args.sargs);
		assert(bn > an-m);ca_objseq_inaddmulsc(a,v,b,t,w,an-m,args.sargs);
		a += (an-m)*ca_obj_size(args.sargs);
		ca_objseq_oomulscv(a,b,t,w,bn-(an-m),args.sargs);
	    }
	    return bn + m;
	} else {
	    assert(an >= m);ca_objseq_innegv(a,v,m,args.sargs);
	    a += m*ca_obj_size(args.sargs);
	    assert(an >= bn);ca_objseq_inaddmulsc(a,v,b,t,w,bn,args.sargs);
	    a += bn*ca_obj_size(args.sargs);
	    assert(an > bn+m);ca_objseq_innegv(a,v,an-bn-m,args.sargs);
	    return an;
	}
    }
}

static int ca_obj_vardnsrecdegdnspolseq_oomulscaddmulmonomsc(ca_obj_vardnsrecdegdnspolseq_t c,ca_obj_vardnsrecdegdnspolseq_t a,int an,ca_obj_t s,int v,ca_obj_vardnsrecdegdnspolseq_t b,int bn,int m,ca_obj_t t,int w,ca_obj_vardnsrecdegdnspol_args args)
{
    assert(v*v == 1 && w*w == 1);
    
    if (an == bn + m) {
	assert(an >= m);ca_objseq_oomulscv(c,a,s,v,m,args.sargs);
	c += m*ca_obj_size(args.sargs);
	a += m*ca_obj_size(args.sargs);
	assert(an >= bn);ca_objseq_oomulscaddmulsc(c,a,s,v,b,t,w,bn,args.sargs);
	c -= m*ca_obj_size(args.sargs);
	return ca_obj_vardnsrecdegdnspolseq_removezeroes(c,an,args);
    } else {
	if (an < bn + m) {
	    if (an < m) {
		ca_objseq_oomulscv(c,a,s,v,an,args.sargs);
		c += an*ca_obj_size(args.sargs);
		a += an*ca_obj_size(args.sargs);
		ca_objseq_oozero(c,m-an,args.sargs);
		c += m*ca_obj_size(args.sargs);
		ca_objseq_oomulscv(c,b,t,w,bn,args.sargs);
	    } else {
		assert(an >= m);ca_objseq_oomulscv(c,a,s,v,m,args.sargs);
		c += m*ca_obj_size(args.sargs);
		a += m*ca_obj_size(args.sargs);
		assert(bn > an-m);ca_objseq_oomulscaddmulsc(c,a,s,v,b,t,w,an-m,args.sargs);
		c += (an-m)*ca_obj_size(args.sargs);
		a += (an-m)*ca_obj_size(args.sargs);
		ca_objseq_oomulscv(c,b,t,w,bn-(an-m),args.sargs);
	    }
	    return bn + m;
	} else {
	    assert(an >= m);ca_objseq_oomulscv(c,a,s,v,m,args.sargs);
	    c += m*ca_obj_size(args.sargs);
	    a += m*ca_obj_size(args.sargs);
	    assert(an >= bn);ca_objseq_oomulscaddmulsc(c,a,s,v,b,t,w,bn,args.sargs);
	    c += bn*ca_obj_size(args.sargs);
	    a += bn*ca_obj_size(args.sargs);
	    assert(an > bn+m);ca_objseq_oomulscv(c,a,s,v,an-bn-m,args.sargs);
	    return an;
	}
    }
}

static int ca_obj_vardnsrecdegdnspolseq_inmulscaddmulmonomsc(ca_obj_vardnsrecdegdnspolseq_t a,int an,ca_obj_t s,int v,ca_obj_vardnsrecdegdnspolseq_t b,int bn,int m,ca_obj_t t,int w,ca_obj_vardnsrecdegdnspol_args args)
{
    assert(v*v == 1 && w*w == 1);
    
    if (an == bn + m) {
	assert(an >= m);ca_objseq_inmulscv(a,s,v,m,args.sargs);
	a += m*ca_obj_size(args.sargs);
	assert(an >= bn);ca_objseq_inmulscaddmulsc(a,s,v,b,t,w,bn,args.sargs);
	a -= m*ca_obj_size(args.sargs);
	return ca_obj_vardnsrecdegdnspolseq_removezeroes(a,an,args);
    } else {
	if (an < bn + m) {
	    if (an < m) {
		ca_objseq_inmulscv(a,s,v,an,args.sargs);
		a += an*ca_obj_size(args.sargs);
		ca_objseq_oozero(a,m-an,args.sargs);
		a += m*ca_obj_size(args.sargs);
		ca_objseq_oomulscv(a,b,t,w,bn,args.sargs);
	    } else {
		assert(an >= m);ca_objseq_inmulscv(a,s,v,m,args.sargs);
		a += m*ca_obj_size(args.sargs);
		assert(bn > an-m);ca_objseq_inmulscaddmulsc(a,s,v,b,t,w,an-m,args.sargs);
		a += (an-m)*ca_obj_size(args.sargs);
		ca_objseq_oomulscv(a,b,t,w,bn-(an-m),args.sargs);
	    }
	    return bn + m;
	} else {
	    assert(an >= m);ca_objseq_inmulscv(a,s,v,m,args.sargs);
	    a += m*ca_obj_size(args.sargs);
	    assert(an >= bn);ca_objseq_inmulscaddmulsc(a,s,v,b,t,w,bn,args.sargs);
	    a += bn*ca_obj_size(args.sargs);
	    assert(an > bn+m);ca_objseq_inmulscv(a,s,v,an-bn-m,args.sargs);
	    return an;
	}
    }
}
static void ca_obj_vardnsrecdegdnspol_ix_init(ca_obj_vardnsrecdegdnspol_ixt ix,id self)
{
    ca_obj_vardnsrecdegdnspol_t v = [self ca_obj_vardnsrecdegdnspol_value];
    ix->i = -1;ix->n = v->n;
}

static void ca_obj_vardnsrecdegdnspol_ix_clear(ca_obj_vardnsrecdegdnspol_ixt ix)
{
    /* nothing to clear */
}

static int ca_obj_vardnsrecdegdnspol_ix_count(ca_obj_vardnsrecdegdnspol_ixt ix)
{
    return ix->n; /* total number, zero or nonzero */
}

static int ca_obj_vardnsrecdegdnspol_ix_isempty(ca_obj_vardnsrecdegdnspol_ixt ix)
{
    return ix->n == 0; 
}

static int ca_obj_vardnsrecdegdnspol_ix_ismatch(ca_obj_vardnsrecdegdnspol_ixt ix)
{
    assert(-1 <= ix->i && ix->i <= ix->n);
    return (ix->i != -1 && ix->i != ix->n);
}

static void ca_obj_vardnsrecdegdnspol_ix_tofirst(ca_obj_vardnsrecdegdnspol_ixt ix)
{
    ix->i = -1;	/* next = first */
}

static void ca_obj_vardnsrecdegdnspol_ix_tolast(ca_obj_vardnsrecdegdnspol_ixt ix)
{
    ix->i = ix->n;	/* prev = last */
}

static void ca_obj_vardnsrecdegdnspol_ix_to(ca_obj_vardnsrecdegdnspol_ixt ix,int i)
{
    /* conversion to "n-i-1" done in elting routine... */
    if (i < 0) ix->i = -1;else if (i > ix->n) ix->i = ix->n;
    else ix->i = i-1; /* next -> at i */
}

static void ca_obj_vardnsrecdegdnspol_ix_next(ca_obj_vardnsrecdegdnspol_ixt ix)
{
    if (ix->i == ix->n) {
	/* remain on position just after last term */
    } else {
	++(ix->i);
    }
}

static void ca_obj_vardnsrecdegdnspol_ix_prev(ca_obj_vardnsrecdegdnspol_ixt ix)
{
    if (ix->i == -1) {
	/* remain on position just before first term */
    } else {
	--(ix->i);
    }
}
static int ca_obj_vardnsrecdegdnspol_check(ca_obj_vardnsrecdegdnspol_t self,ca_obj_vardnsrecdegdnspol_args args)
{
    assert(self->n <= self->c);
    return ca_obj_vardnsrecdegdnspolseq_check(self->ptr,self->n,args);
}

static ca_obj_vardnsrecdegdnspol_args ca_obj_vardnsrecdegdnspol_getargs(id self)
{
    ca_obj_vardnsrecdegdnspol_args res;
    res.sargs = ca_obj_getargs([[self termZero] coefficient]);
    return res; 
}

static ca_obj_vardnsrecdegdnspol_t ca_obj_vardnsrecdegdnspol_id2t(id object)
{
    return [object ca_obj_vardnsrecdegdnspol_value];
}

static ca_obj_vardnsrecdegdnspol_c *ca_obj_vardnsrecdegdnspol_id2c(id object)
{
    return [object ca_obj_vardnsrecdegdnspol_reference];
}

static id ca_obj_vardnsrecdegdnspol_t2id(id proto,ca_obj_vardnsrecdegdnspol_t f)
{
    return [proto ca_obj_vardnsrecdegdnspol_value:f];
}

static id ca_obj_vardnsrecdegdnspol_c2id(id proto,ca_obj_vardnsrecdegdnspol_c *r)
{
    return [proto ca_obj_vardnsrecdegdnspol_reference:r];
}

static int ca_obj_vardnsrecdegdnspol_isempty(ca_obj_vardnsrecdegdnspol_t self)
{
    return self->n == 0;
}

static void ca_obj_vardnsrecdegdnspol_init(ca_obj_vardnsrecdegdnspol_t self,int c,ca_obj_vardnsrecdegdnspol_args args)
{
    self->n   = 0;
    self->c   = c;
    self->ptr = ca_objseq_alloc(c,args.sargs);
    assert(ca_obj_vardnsrecdegdnspol_check(self,args));
}

static void ca_obj_vardnsrecdegdnspol_copy(ca_obj_vardnsrecdegdnspol_t c,ca_obj_vardnsrecdegdnspol_t a,ca_obj_vardnsrecdegdnspol_args args)
{
    assert(ca_obj_vardnsrecdegdnspol_check(a,args));
    ca_obj_vardnsrecdegdnspol_init(c,a->n,args);
    c->n = ca_obj_vardnsrecdegdnspolseq_copy(c->ptr,a->ptr,a->n,args);
    assert(ca_obj_vardnsrecdegdnspol_check(c,args));
}

static void ca_obj_vardnsrecdegdnspol_deepcopy(ca_obj_vardnsrecdegdnspol_t c,ca_obj_vardnsrecdegdnspol_t a,ca_obj_vardnsrecdegdnspol_args args)
{
    assert(ca_obj_vardnsrecdegdnspol_check(a,args));
    ca_obj_vardnsrecdegdnspol_init(c,a->n,args);
    c->n = ca_obj_vardnsrecdegdnspolseq_deepcopy(c->ptr,a->ptr,a->n,args);
    assert(ca_obj_vardnsrecdegdnspol_check(c,args));
}

static void ca_obj_vardnsrecdegdnspol_move(ca_obj_vardnsrecdegdnspol_t c,ca_obj_vardnsrecdegdnspol_t a,ca_obj_vardnsrecdegdnspol_args args)
{
    c->ptr = a->ptr;c->n = a->n;c->c = a->c;
    a->ptr = NULL;assert(ca_obj_vardnsrecdegdnspol_check(c,args));
}

static void ca_obj_vardnsrecdegdnspol_destroy(ca_obj_vardnsrecdegdnspol_t self,ca_obj_vardnsrecdegdnspol_args args)
{
    /* needed e.g. after a failed oodiv operation */
    self->ptr = ca_objseq_free(self->ptr,args.sargs);
}

static void ca_obj_vardnsrecdegdnspol_clear(ca_obj_vardnsrecdegdnspol_t self,ca_obj_vardnsrecdegdnspol_args args)
{
    ca_objseq_clear(self->ptr,self->n,args.sargs);
    ca_obj_vardnsrecdegdnspol_destroy(self,args);
}

static int ca_obj_vardnsrecdegdnspol_count(ca_obj_vardnsrecdegdnspol_t self,ca_obj_vardnsrecdegdnspol_args args)
{
    return ca_obj_vardnsrecdegdnspolseq_count(self->ptr,self->n,args); /* num non-zero coefs */
}

static unsigned ca_obj_vardnsrecdegdnspol_hash(ca_obj_vardnsrecdegdnspol_t a,ca_obj_vardnsrecdegdnspol_args args)
{
    return ca_obj_vardnsrecdegdnspolseq_hash(a->ptr,a->n,args);
}

static int ca_obj_vardnsrecdegdnspol_iseq(ca_obj_vardnsrecdegdnspol_t a,ca_obj_vardnsrecdegdnspol_t b,ca_obj_vardnsrecdegdnspol_args args)
{
    return (a==b)?YES:ca_obj_vardnsrecdegdnspolseq_iseq(a->ptr,a->n,b->ptr,b->n,args);
}

static int ca_obj_vardnsrecdegdnspol_isone(ca_obj_vardnsrecdegdnspol_t self,ca_obj_vardnsrecdegdnspol_args args)
{
    return ca_obj_vardnsrecdegdnspolseq_isone(self->ptr,self->n,args);
}

static int ca_obj_vardnsrecdegdnspol_isminusone(ca_obj_vardnsrecdegdnspol_t self,ca_obj_vardnsrecdegdnspol_args args)
{
    return ca_obj_vardnsrecdegdnspolseq_isminusone(self->ptr,self->n,args);
}

static int ca_obj_vardnsrecdegdnspol_deg(ca_obj_vardnsrecdegdnspol_t self ,ca_obj_vardnsrecdegdnspol_args args)
{
    return self->n - 1;
}

static int ca_obj_vardnsrecdegdnspol_ord(ca_obj_vardnsrecdegdnspol_t self ,ca_obj_vardnsrecdegdnspol_args args)
{
    return ca_obj_vardnsrecdegdnspolseq_ord(self->ptr,self->n,args);
}

static int ca_obj_vardnsrecdegdnspol_maxdeg(ca_obj_vardnsrecdegdnspol_t self ,ca_obj_vardnsrecdegdnspol_args args)
{
    return self->n - 1;
}

static int ca_obj_vardnsrecdegdnspol_mindeg(ca_obj_vardnsrecdegdnspol_t self ,ca_obj_vardnsrecdegdnspol_args args)
{
    return ca_obj_vardnsrecdegdnspolseq_ord(self->ptr,self->n,args);
}

static ca_obj_t ca_obj_vardnsrecdegdnspol_scalat(ca_obj_vardnsrecdegdnspol_t self,ca_obj_vardnsrecdegdnspol_ixt ix,ca_obj_vardnsrecdegdnspol_args args)
{
    assert(ca_obj_vardnsrecdegdnspol_ix_ismatch(ix) && ix->n == self->n);
    return ca_objseq_at(self->ptr,ix->n - ix->i - 1,args.sargs);
}

static int ca_obj_vardnsrecdegdnspol_expat(ca_obj_vardnsrecdegdnspol_t self,ca_obj_vardnsrecdegdnspol_ixt ix,ca_obj_vardnsrecdegdnspol_args args)
{
    assert(ca_obj_vardnsrecdegdnspol_ix_ismatch(ix) && ix->n == self->n);
    return ix->n - ix->i - 1;
}

static ca_obj_t ca_obj_vardnsrecdegdnspol_scalfirst(ca_obj_vardnsrecdegdnspol_t self,ca_obj_vardnsrecdegdnspol_args args)
{
    assert(ca_obj_vardnsrecdegdnspol_isempty(self) == NO);
    return ca_objseq_last(self->ptr,self->n,args.sargs);
}

static int ca_obj_vardnsrecdegdnspol_expfirst(ca_obj_vardnsrecdegdnspol_t self,ca_obj_vardnsrecdegdnspol_args args)
{
    assert(ca_obj_vardnsrecdegdnspol_isempty(self) == NO);
    return self->n - 1;
}

static void ca_obj_vardnsrecdegdnspol_expand(ca_obj_vardnsrecdegdnspol_t self,ca_obj_vardnsrecdegdnspol_args args)
{
    self->c   = self->n + self->c + 1;
    self->ptr = ca_objseq_realloc(self->ptr,self->c,args.sargs);
    assert(self->n < self->c);
}

static void ca_obj_vardnsrecdegdnspol_remove(ca_obj_vardnsrecdegdnspol_t self,ca_obj_vardnsrecdegdnspol_args args)
{
    assert(ca_obj_vardnsrecdegdnspol_check(self,args) && ca_obj_vardnsrecdegdnspol_isempty(self) == NO);
    self->n = ca_obj_vardnsrecdegdnspolseq_delete(self->ptr,self->n,args);
    assert(ca_obj_vardnsrecdegdnspol_check(self,args));
}

static void ca_obj_vardnsrecdegdnspol_insert(ca_obj_vardnsrecdegdnspol_t self,int e,ca_obj_t s,ca_obj_vardnsrecdegdnspol_args args)
{
    assert(ca_obj_vardnsrecdegdnspol_check(self,args));
    while (self->c < e + 1) ca_obj_vardnsrecdegdnspol_expand(self,args);
    self->n = ca_obj_vardnsrecdegdnspolseq_insert(self->ptr,self->n,e,s,args);
    assert(ca_obj_vardnsrecdegdnspol_check(self,args));
}

static int ca_obj_vardnsrecdegdnspol_iszero(ca_obj_vardnsrecdegdnspol_t self,ca_obj_vardnsrecdegdnspol_args args)
{
    return ca_obj_vardnsrecdegdnspol_isempty(self);
}

static int ca_obj_vardnsrecdegdnspol_isop(ca_obj_vardnsrecdegdnspol_t a,ca_obj_vardnsrecdegdnspol_t b,ca_obj_vardnsrecdegdnspol_args args)
{
    assert(a != b);return ca_obj_vardnsrecdegdnspolseq_isop(a->ptr,a->n,b->ptr,b->n,args);
}

static void ca_obj_vardnsrecdegdnspol_ooneg(ca_obj_vardnsrecdegdnspol_t c,ca_obj_vardnsrecdegdnspol_t a,ca_obj_vardnsrecdegdnspol_args args)
{
    ca_obj_vardnsrecdegdnspol_init(c,a->n,args);
    c->n = ca_obj_vardnsrecdegdnspolseq_ooneg(c->ptr,a->ptr,a->n,args);
    assert(ca_obj_vardnsrecdegdnspol_check(c,args));
}

static void ca_obj_vardnsrecdegdnspol_inneg(ca_obj_vardnsrecdegdnspol_t a,ca_obj_vardnsrecdegdnspol_args args)
{
    a->n = ca_obj_vardnsrecdegdnspolseq_inneg(a->ptr,a->n,args);
    assert(ca_obj_vardnsrecdegdnspol_check(a,args));
}

static void ca_obj_vardnsrecdegdnspol_oodbl(ca_obj_vardnsrecdegdnspol_t c,ca_obj_vardnsrecdegdnspol_t a,int v,ca_obj_vardnsrecdegdnspol_args args)
{
    ca_obj_vardnsrecdegdnspol_init(c,a->n,args);
    c->n = ca_obj_vardnsrecdegdnspolseq_oodbl(c->ptr,a->ptr,a->n,v,args);
    assert(ca_obj_vardnsrecdegdnspol_check(c,args));
}

static void ca_obj_vardnsrecdegdnspol_indbl(ca_obj_vardnsrecdegdnspol_t a,int v,ca_obj_vardnsrecdegdnspol_args args)
{
    ca_obj_vardnsrecdegdnspolseq_indbl(a->ptr,a->n,v,args);
    assert(ca_obj_vardnsrecdegdnspol_check(a,args));
}

static void ca_obj_vardnsrecdegdnspol_ooadd(ca_obj_vardnsrecdegdnspol_t c,ca_obj_vardnsrecdegdnspol_t a,int v,ca_obj_vardnsrecdegdnspol_t b,int w,ca_obj_vardnsrecdegdnspol_args args)
{
    assert(a!=b);
    ca_obj_vardnsrecdegdnspol_init(c,MAX(a->n,b->n),args);
    c->n = ca_obj_vardnsrecdegdnspolseq_ooadd(c->ptr,a->ptr,a->n,v,b->ptr,b->n,w,args);
    assert(ca_obj_vardnsrecdegdnspol_check(c,args));
}

static void ca_obj_vardnsrecdegdnspol_inadd(ca_obj_vardnsrecdegdnspol_t a,int v,ca_obj_vardnsrecdegdnspol_t b,int w,ca_obj_vardnsrecdegdnspol_args args)
{
    assert(a!=b);
    while (a->c < b->n) ca_obj_vardnsrecdegdnspol_expand(a,args);
    a->n = ca_obj_vardnsrecdegdnspolseq_inadd(a->ptr,a->n,v,b->ptr,b->n,w,args);
    assert(ca_obj_vardnsrecdegdnspol_check(a,args));
}

static void ca_obj_vardnsrecdegdnspol_oomulsc(ca_obj_vardnsrecdegdnspol_t c,ca_obj_vardnsrecdegdnspol_t a,ca_obj_t s,ca_obj_vardnsrecdegdnspol_args args)
{
    ca_obj_vardnsrecdegdnspol_init(c,a->n,args);
    c->n = ca_obj_vardnsrecdegdnspolseq_oomulsc(c->ptr,a->ptr,a->n,s,args);
    assert(ca_obj_vardnsrecdegdnspol_check(c,args));
}

static void ca_obj_vardnsrecdegdnspol_inmulsc(ca_obj_vardnsrecdegdnspol_t a,ca_obj_t s,ca_obj_vardnsrecdegdnspol_args args)
{
    a->n = ca_obj_vardnsrecdegdnspolseq_inmulsc(a->ptr,a->n,s,args);
    assert(ca_obj_vardnsrecdegdnspol_check(a,args));
}

static void ca_obj_vardnsrecdegdnspol_ooaddmulsc(ca_obj_vardnsrecdegdnspol_t c,ca_obj_vardnsrecdegdnspol_t a,int v,ca_obj_vardnsrecdegdnspol_t b,ca_obj_t t,int w, ca_obj_vardnsrecdegdnspol_args args)
{
    ca_obj_vardnsrecdegdnspol_init(c,MAX(a->n,b->n),args);
    c->n=ca_obj_vardnsrecdegdnspolseq_ooaddmulsc(c->ptr,a->ptr,a->n,v,b->ptr,b->n,t,w,args);
    assert(ca_obj_vardnsrecdegdnspol_check(c,args));
}

static void ca_obj_vardnsrecdegdnspol_inaddmulsc(ca_obj_vardnsrecdegdnspol_t a,int v,ca_obj_vardnsrecdegdnspol_t b,ca_obj_t t,int w,ca_obj_vardnsrecdegdnspol_args args)
{
    while (a->c < b->n) ca_obj_vardnsrecdegdnspol_expand(a,args);
    a->n = ca_obj_vardnsrecdegdnspolseq_inaddmulsc(a->ptr,a->n,v,b->ptr,b->n,t,w,args);
    assert(ca_obj_vardnsrecdegdnspol_check(a,args));
}

static void ca_obj_vardnsrecdegdnspol_oomulscadd(ca_obj_vardnsrecdegdnspol_t c,ca_obj_vardnsrecdegdnspol_t a,ca_obj_t s,int v,ca_obj_vardnsrecdegdnspol_t b,int w, ca_obj_vardnsrecdegdnspol_args args)
{
    ca_obj_vardnsrecdegdnspol_init(c,MAX(a->n,b->n),args);
    c->n = ca_obj_vardnsrecdegdnspolseq_oomulscadd(c->ptr,a->ptr,a->n,s,v,b->ptr,b->n,w,args);
    assert(ca_obj_vardnsrecdegdnspol_check(c,args));
}

static void ca_obj_vardnsrecdegdnspol_inmulscadd(ca_obj_vardnsrecdegdnspol_t a,ca_obj_t s,int v,ca_obj_vardnsrecdegdnspol_t b,int w,ca_obj_vardnsrecdegdnspol_args args)
{
    while (a->c < b->n) ca_obj_vardnsrecdegdnspol_expand(a,args);
    a->n = ca_obj_vardnsrecdegdnspolseq_inmulscadd(a->ptr,a->n,s,v,b->ptr,b->n,w,args);
    assert(ca_obj_vardnsrecdegdnspol_check(a,args));
}

static void ca_obj_vardnsrecdegdnspol_oomulscaddmulsc(ca_obj_vardnsrecdegdnspol_t c,ca_obj_vardnsrecdegdnspol_t a,ca_obj_t s,int v,ca_obj_vardnsrecdegdnspol_t b,ca_obj_t t,int w, ca_obj_vardnsrecdegdnspol_args args)
{
    ca_obj_vardnsrecdegdnspol_init(c,MAX(a->n,b->n),args);
    c->n = ca_obj_vardnsrecdegdnspolseq_oomulscaddmulsc(c->ptr,a->ptr,a->n,s,v,b->ptr,b->n,t,w,args);
    assert(ca_obj_vardnsrecdegdnspol_check(c,args));
}

static void ca_obj_vardnsrecdegdnspol_inmulscaddmulsc(ca_obj_vardnsrecdegdnspol_t a,ca_obj_t s,int v,ca_obj_vardnsrecdegdnspol_t b,ca_obj_t t,int w,ca_obj_vardnsrecdegdnspol_args args)
{
    while (a->c < b->n) ca_obj_vardnsrecdegdnspol_expand(a,args);
    a->n = ca_obj_vardnsrecdegdnspolseq_inmulscaddmulsc(a->ptr,a->n,s,v,b->ptr,b->n,t,w,args);
    assert(ca_obj_vardnsrecdegdnspol_check(a,args));
}

static BOOL ca_obj_vardnsrecdegdnspol_oodivsc(ca_obj_vardnsrecdegdnspol_t c,ca_obj_vardnsrecdegdnspol_t a,ca_obj_t s,ca_obj_vardnsrecdegdnspol_args args)
{
    BOOL failed;
    ca_obj_vardnsrecdegdnspol_init(c,a->n,args);
    failed = ca_obj_vardnsrecdegdnspolseq_oodivsc(c->ptr,a->ptr,a->n,s,args);
    if (failed) {
	/* the actual scalars are already freed */
	ca_obj_vardnsrecdegdnspol_destroy(c,args);
    } else {
	c->n = a->n;
	assert(ca_obj_vardnsrecdegdnspol_check(c,args));
    }
    return failed;
}

static void ca_obj_vardnsrecdegdnspol_indivsc(ca_obj_vardnsrecdegdnspol_t a,ca_obj_t s,ca_obj_vardnsrecdegdnspol_args args)
{
    a->n = ca_obj_vardnsrecdegdnspolseq_indivsc(a->ptr,a->n,s,args);
    assert(ca_obj_vardnsrecdegdnspol_check(a,args));
}

static void ca_obj_vardnsrecdegdnspol_oomulmonomsc(ca_obj_vardnsrecdegdnspol_t c,ca_obj_vardnsrecdegdnspol_t b,ca_unimonom_t m,ca_obj_t t,int w,ca_obj_vardnsrecdegdnspol_args args)
{
    ca_obj_vardnsrecdegdnspol_init(c,b->n + m,args);
    c->n = ca_obj_vardnsrecdegdnspolseq_oomulmonomsc(c->ptr,b->ptr,b->n,m,t,w,args);
    assert(ca_obj_vardnsrecdegdnspol_check(c,args));
}

static void ca_obj_vardnsrecdegdnspol_inmulmonomsc(ca_obj_vardnsrecdegdnspol_t b,ca_unimonom_t m,ca_obj_t t,int w,ca_obj_vardnsrecdegdnspol_args args)
{
    ca_obj_vardnsrecdegdnspol_c tmp;ca_obj_vardnsrecdegdnspol_oomulmonomsc(&tmp,b,m,t,w,args);
    ca_obj_vardnsrecdegdnspol_clear(b,args);ca_obj_vardnsrecdegdnspol_move(b,&tmp,args);
}

static void ca_obj_vardnsrecdegdnspol_ooaddmulmonomsc(ca_obj_vardnsrecdegdnspol_t c,ca_obj_vardnsrecdegdnspol_t a,int v,ca_obj_vardnsrecdegdnspol_t b,ca_unimonom_t m,ca_obj_t t,int w, ca_obj_vardnsrecdegdnspol_args args)
{
    ca_obj_vardnsrecdegdnspol_init(c,MAX(a->n,b->n + m),args);
    c->n = ca_obj_vardnsrecdegdnspolseq_ooaddmulmonomsc(c->ptr,a->ptr,a->n,v,b->ptr,b->n,m,t,w,args);
    assert(ca_obj_vardnsrecdegdnspol_check(c,args));
}

static void ca_obj_vardnsrecdegdnspol_inaddmulmonomsc(ca_obj_vardnsrecdegdnspol_t a,int v,ca_obj_vardnsrecdegdnspol_t b,ca_unimonom_t m,ca_obj_t t,int w,ca_obj_vardnsrecdegdnspol_args args)
{
    while (a->c < b->n + m) ca_obj_vardnsrecdegdnspol_expand(a,args);
    a->n = ca_obj_vardnsrecdegdnspolseq_inaddmulmonomsc(a->ptr,a->n,v,b->ptr,b->n,m,t,w,args);
    assert(ca_obj_vardnsrecdegdnspol_check(a,args));
}

static void ca_obj_vardnsrecdegdnspol_oomulscaddmulmonomsc(ca_obj_vardnsrecdegdnspol_t c,ca_obj_vardnsrecdegdnspol_t a,ca_obj_t s,int v,ca_obj_vardnsrecdegdnspol_t b,ca_unimonom_t m,ca_obj_t t,int w, ca_obj_vardnsrecdegdnspol_args args)
{
    ca_obj_vardnsrecdegdnspol_init(c,MAX(a->n,b->n + m),args);
    c->n = ca_obj_vardnsrecdegdnspolseq_oomulscaddmulmonomsc(c->ptr,a->ptr,a->n,s,v,b->ptr,b->n,m,t,w,args);
    assert(ca_obj_vardnsrecdegdnspol_check(c,args));
}

static void ca_obj_vardnsrecdegdnspol_inmulscaddmulmonomsc(ca_obj_vardnsrecdegdnspol_t a,ca_obj_t s,int v,ca_obj_vardnsrecdegdnspol_t b,ca_unimonom_t m,ca_obj_t t,int w,ca_obj_vardnsrecdegdnspol_args args)
{
    a->n = ca_obj_vardnsrecdegdnspolseq_inmulscaddmulmonomsc(a->ptr,a->n,s,v,b->ptr,b->n,m,t,w,args);
    assert(ca_obj_vardnsrecdegdnspol_check(a,args));
}

static BOOL ca_obj_vardnsrecdegdnspol_oodivmonomsc(ca_obj_vardnsrecdegdnspol_t c,ca_obj_vardnsrecdegdnspol_t b,ca_unimonom_t m,ca_obj_t t, ca_obj_vardnsrecdegdnspol_args args)
{
    if (ca_obj_vardnsrecdegdnspol_ord(b,args) < m) {
	return FAILURE;
    } else {
	BOOL failed;
	ca_obj_vardnsrecdegdnspol_init(c,b->n - m,args);
	failed = ca_obj_vardnsrecdegdnspolseq_oodivmonomsc(c->ptr,b->ptr,b->n,m,t,args);
	if (failed) {
	    /* the actual scalars are already freed */
	    ca_obj_vardnsrecdegdnspol_destroy(c,args);
	} else {
	    c->n = b->n - m;
	    assert(ca_obj_vardnsrecdegdnspol_check(c,args));
	}
	return failed;
    }
}

static void ca_obj_vardnsrecdegdnspol_indivmonomsc(ca_obj_vardnsrecdegdnspol_t b,ca_unimonom_t m,ca_obj_t t,ca_obj_vardnsrecdegdnspol_args args)
{
    ca_obj_vardnsrecdegdnspol_c tmp;
    BOOL failed = ca_obj_vardnsrecdegdnspol_oodivmonomsc(&tmp,b,m,t,args);
    if (failed) { fprintf(stderr,"Exact Division Failed");abort(); }
    ca_obj_vardnsrecdegdnspol_clear(b,args);ca_obj_vardnsrecdegdnspol_move(b,&tmp,args);
}

static void ca_obj_vardnsrecdegdnspol_args_fileOut(id aFiler,ca_obj_vardnsrecdegdnspol_args *args)
{
    ca_objseq_args_fileOut(aFiler,&args->sargs);
}
static void ca_obj_vardnsrecdegdnspol_args_fileIn(id aFiler,ca_obj_vardnsrecdegdnspol_args *args)
{
    ca_objseq_args_fileIn(aFiler,&args->sargs);
}

static void ca_obj_vardnsrecdegdnspol_fileOut(id aFiler,ca_obj_vardnsrecdegdnspol_t self,ca_obj_vardnsrecdegdnspol_args args)
{
    int n = self->n;
    [aFiler fileOut:&n type:'i'];
    assert(ca_obj_vardnsrecdegdnspol_check(self,args));
    ca_objseq_fileOut(aFiler,self->ptr,n,args.sargs);
}

static void ca_obj_vardnsrecdegdnspol_fileIn(id aFiler,ca_obj_vardnsrecdegdnspol_t self,ca_obj_vardnsrecdegdnspol_args args)
{
    int n;
    [aFiler fileIn:&n type:'i'];
    ca_obj_vardnsrecdegdnspol_init(self,n,args);
    ca_objseq_fileIn(aFiler,self->ptr,n,args.sargs);self->n = n;
    assert(self->n == n && ca_obj_vardnsrecdegdnspol_check(self,args));
}

@implementation ca_obj_vardnsrecdegdns_polynomial : ca_vardnsrecdegdns_polynomial

- _setUpScalarZero:aScalar coefficientZero:aCoef symbols:aCltn
{
    id aSymbol;
    
    assert([aCoef isZero] && [aScalar isZero]);
    assert([aCoef class_vardnsrecdegdns_polynomial] == self);
     
    aScalar  = [aScalar cheapCopy];
    aSymbol  = [[aCltn lastMember] cheapCopy];
    termZero = [CATermClass newScalarZero:aScalar coefficient:aCoef symbol:aSymbol exponent:1];
    aScalar  = [aScalar cheapCopy];aCltn = [aCltn cheapCopy];
    monomialZero = [CAMonomialClass newScalar:aScalar symbols:aCltn];
    scalarZero   = aScalar;
    symbols      = aCltn;
    
    ca_obj_vardnsrecdegdnspol_init(&value,2 /* capacity */,ca_obj_vardnsrecdegdnspol_getargs(self));
    assert([self check]);return self;
}

+ newScalarZero:aScalar coefficientZero:aCoef symbols:aCltn
{
    return [[super new] _setUpScalarZero:aScalar coefficientZero:aCoef symbols:aCltn];
}

- empty
{
    ca_obj_vardnsrecdegdnspol_c c;assert([self check]);
    ca_obj_vardnsrecdegdnspol_init(&c,2 /* capacity */ ,ca_obj_vardnsrecdegdnspol_getargs(self));
    return ca_obj_vardnsrecdegdnspol_c2id(self,&c);
}

- (int) numTerms
{
    /* doesn't take getargs in degsps case */
    assert([self check]);return ca_obj_vardnsrecdegdnspol_count(&value ,ca_obj_vardnsrecdegdnspol_getargs(self));
}

- (ca_obj_vardnsrecdegdnspol_t)ca_obj_vardnsrecdegdnspol_value
{
    return &value;
}

- ca_obj_vardnsrecdegdnspol_value:(ca_obj_vardnsrecdegdnspol_t)aValue
{
    self = [self clone];
    ca_obj_vardnsrecdegdnspol_copy(&value,aValue,ca_obj_vardnsrecdegdnspol_getargs(self));
    assert([self check]);return self;
}

- (ca_obj_vardnsrecdegdnspol_t)ca_obj_vardnsrecdegdnspol_reference
{
    return &value;
}

- ca_obj_vardnsrecdegdnspol_reference:(ca_obj_vardnsrecdegdnspol_c *)aReference
{
    self = [self clone];
    ca_obj_vardnsrecdegdnspol_move(&value,aReference,ca_obj_vardnsrecdegdnspol_getargs(self));
    assert([self check]);return self;
}

- copy
{
    ca_obj_vardnsrecdegdnspol_c c;assert([self check]);
    ca_obj_vardnsrecdegdnspol_copy(&c,&value,ca_obj_vardnsrecdegdnspol_getargs(self));
    return ca_obj_vardnsrecdegdnspol_c2id(self,&c);
}

- deepCopy
{
    ca_obj_vardnsrecdegdnspol_c c;assert([self check]);
    ca_obj_vardnsrecdegdnspol_deepcopy(&c,&value,ca_obj_vardnsrecdegdnspol_getargs(self));
    return ca_obj_vardnsrecdegdnspol_c2id(self,&c);
}

- (BOOL) isEmpty
{
    return ca_obj_vardnsrecdegdnspol_isempty(&value);
}

- (BOOL) isOne
{
    return ca_obj_vardnsrecdegdnspol_isone(&value,ca_obj_vardnsrecdegdnspol_getargs(self));
}

- (BOOL) isMinusOne
{
    return ca_obj_vardnsrecdegdnspol_isminusone(&value,ca_obj_vardnsrecdegdnspol_getargs(self));
}

- (unsigned) hash
{
    return ca_obj_vardnsrecdegdnspol_hash(ca_obj_vardnsrecdegdnspol_id2t(self),ca_obj_vardnsrecdegdnspol_getargs(self));
}

- (BOOL) isEqual:b
{
    [self checkSameClass:b];
    if (self==b) {
    return YES;
    } else {
    return ca_obj_vardnsrecdegdnspol_iseq(ca_obj_vardnsrecdegdnspol_id2t(self),ca_obj_vardnsrecdegdnspol_id2t(b),ca_obj_vardnsrecdegdnspol_getargs(self));
    }
}

- (BOOL) notEqual:b
{
    [self checkSameClass:b];
    if (self==b) {
    return NO;
    } else {
    return !ca_obj_vardnsrecdegdnspol_iseq(ca_obj_vardnsrecdegdnspol_id2t(self),ca_obj_vardnsrecdegdnspol_id2t(b),ca_obj_vardnsrecdegdnspol_getargs(self));
    }
}

- (BOOL) isZero
{
    assert([self check]);
    return ca_obj_vardnsrecdegdnspol_iszero(ca_obj_vardnsrecdegdnspol_id2t(self),ca_obj_vardnsrecdegdnspol_getargs(self));
}

- (BOOL) notZero
{
    assert([self check]);
    return !ca_obj_vardnsrecdegdnspol_iszero(ca_obj_vardnsrecdegdnspol_id2t(self),ca_obj_vardnsrecdegdnspol_getargs(self));
}

- (BOOL) isOpposite:b
{
    assert([self checkSameClass:b] && self != b);
    return ca_obj_vardnsrecdegdnspol_isop(ca_obj_vardnsrecdegdnspol_id2t(self),ca_obj_vardnsrecdegdnspol_id2t(b),ca_obj_vardnsrecdegdnspol_getargs(self));
}

- (BOOL) notOpposite:b
{
    assert([self checkSameClass:b] && self != b);
    return !ca_obj_vardnsrecdegdnspol_isop(ca_obj_vardnsrecdegdnspol_id2t(self),ca_obj_vardnsrecdegdnspol_id2t(b),ca_obj_vardnsrecdegdnspol_getargs(self));
}

- negate
{
    ca_obj_vardnsrecdegdnspol_c c;assert([self check]);
    ca_obj_vardnsrecdegdnspol_ooneg(&c,ca_obj_vardnsrecdegdnspol_id2t(self),ca_obj_vardnsrecdegdnspol_getargs(self));
    return ca_obj_vardnsrecdegdnspol_c2id(self,&c);
}

- negateSelf
{
    if (refCount>1) return idReplace(self,[self negate]);
    assert([self check]);
    ca_obj_vardnsrecdegdnspol_inneg(ca_obj_vardnsrecdegdnspol_id2c(self),ca_obj_vardnsrecdegdnspol_getargs(self));
    return [self invalidate];
}

- _double:(int)v
{
    ca_obj_vardnsrecdegdnspol_c c;assert([self check]);
    ca_obj_vardnsrecdegdnspol_oodbl(&c,ca_obj_vardnsrecdegdnspol_id2t(self),v,ca_obj_vardnsrecdegdnspol_getargs(self));
    return ca_obj_vardnsrecdegdnspol_c2id(self,&c);
}

- _doubleSelf:(int)v
{
    if (refCount>1) return idReplace(self,[self _double:v]);
    assert([self check]);
    ca_obj_vardnsrecdegdnspol_indbl(ca_obj_vardnsrecdegdnspol_id2c(self),v,ca_obj_vardnsrecdegdnspol_getargs(self));
    return [self invalidate];
}

- double
{
    ca_obj_vardnsrecdegdnspol_c c;assert([self check]);
    ca_obj_vardnsrecdegdnspol_oodbl(&c,ca_obj_vardnsrecdegdnspol_id2t(self),+1,ca_obj_vardnsrecdegdnspol_getargs(self));
    return ca_obj_vardnsrecdegdnspol_c2id(self,&c);
}

- doubleSelf
{
    if (refCount>1) return idReplace(self,[self double]);
    assert([self check]);
    ca_obj_vardnsrecdegdnspol_indbl(ca_obj_vardnsrecdegdnspol_id2c(self),+1,ca_obj_vardnsrecdegdnspol_getargs(self));
    return [self invalidate];
}

- _add:(int)v:b:(int)w
{
    ca_obj_vardnsrecdegdnspol_c c;
    assert([self sameClass:b] && v*v == 1 && w*w == 1 && self != b);
    ca_obj_vardnsrecdegdnspol_ooadd(&c,ca_obj_vardnsrecdegdnspol_id2t(self),v,ca_obj_vardnsrecdegdnspol_id2t(b),w,ca_obj_vardnsrecdegdnspol_getargs(self));
    return ca_obj_vardnsrecdegdnspol_c2id(self,&c);
}

- _addSelf:(int)v:b:(int)w
{
    assert([self sameClass:b] && v*v == 1 && w*w == 1 && self != b);
    if (refCount>1) return idReplace(self,[self _add:v:b:w]);
    ca_obj_vardnsrecdegdnspol_inadd(ca_obj_vardnsrecdegdnspol_id2c(self),v,ca_obj_vardnsrecdegdnspol_id2t(b),w,ca_obj_vardnsrecdegdnspol_getargs(self));
    return [self invalidate];
}

- add:b
{
    ca_obj_vardnsrecdegdnspol_c c;
    assert([self checkSameClass:b] && self != b);
    ca_obj_vardnsrecdegdnspol_ooadd(&c,ca_obj_vardnsrecdegdnspol_id2t(self),+1,ca_obj_vardnsrecdegdnspol_id2t(b),+1,ca_obj_vardnsrecdegdnspol_getargs(self));
    return ca_obj_vardnsrecdegdnspol_c2id(self,&c);
}

- addSelf:b
{
    assert([self sameClass:b] && self != b);
    if (refCount>1) return idReplace(self,[self add:b]);
    ca_obj_vardnsrecdegdnspol_inadd(ca_obj_vardnsrecdegdnspol_id2c(self),+1,ca_obj_vardnsrecdegdnspol_id2t(b),+1,ca_obj_vardnsrecdegdnspol_getargs(self));
    return [self invalidate];
}

- subtract:b
{
    ca_obj_vardnsrecdegdnspol_c c;
    assert([self checkSameClass:b] && self != b);
    ca_obj_vardnsrecdegdnspol_ooadd(&c,ca_obj_vardnsrecdegdnspol_id2t(self),+1,ca_obj_vardnsrecdegdnspol_id2t(b),-1,ca_obj_vardnsrecdegdnspol_getargs(self));
    return ca_obj_vardnsrecdegdnspol_c2id(self,&c);
}

- subtractSelf:b
{
    assert([self sameClass:b] && self != b);
    if (refCount>1) return idReplace(self,[self subtract:b]);
    ca_obj_vardnsrecdegdnspol_inadd(ca_obj_vardnsrecdegdnspol_id2c(self),+1,ca_obj_vardnsrecdegdnspol_id2t(b),-1,ca_obj_vardnsrecdegdnspol_getargs(self));
    return [self invalidate];
}

- (int) leadingDegree
{
    return ca_obj_vardnsrecdegdnspol_deg(&value,ca_obj_vardnsrecdegdnspol_getargs(self));
}

- (int) lastDegree
{
    return ca_obj_vardnsrecdegdnspol_ord(&value,ca_obj_vardnsrecdegdnspol_getargs(self));
}

- (int) maxDegree
{
    return ca_obj_vardnsrecdegdnspol_maxdeg(&value,ca_obj_vardnsrecdegdnspol_getargs(self));
}

- (int) minDegree
{
    return ca_obj_vardnsrecdegdnspol_mindeg(&value,ca_obj_vardnsrecdegdnspol_getargs(self));
}

- asScalar
{
    if ([self numMembers] == 1) {
	id asScalar,lastTerm,aSequence = [self eachMember];
	asScalar = (lastTerm = [aSequence lastMember])?[lastTerm asScalar]:nil;
	[aSequence free];return asScalar;
    } else {
	return nil;
    }
}

- asSymbol
{
    if ([self numMembers] == 1) {
	id asSymbol,lastTerm,aSequence = [self eachMember];
	asSymbol = (lastTerm = [aSequence lastMember])?[lastTerm asSymbol]:nil;
	[aSequence free];return asSymbol;
    } else {
	return nil;
    }
}

- check
{
    [super check];
    [scalarZero check];[termZero check];[monomialZero check];
    [symbols check];assert([symbols numMembers] >= 1);
    assert([scalarZero isEqual:[monomialZero scalar]]);
    assert([symbols isEqual:[monomialZero symbols]]);
    assert([termZero isZero]&&[termZero exponent]==1&&[termZero symbol]!=nil);
    assert([[symbols lastMember] isEqual:[termZero symbol]]);

    ca_obj_vardnsrecdegdnspol_check(&value,ca_obj_vardnsrecdegdnspol_getargs(self));
    return self;
}

- clear
{
    ca_obj_vardnsrecdegdnspol_clear(&value,ca_obj_vardnsrecdegdnspol_getargs(self));
    /* free args after clearing polynomial value */
    scalarZero = [scalarZero free];
    termZero = [termZero free];monomialZero = [monomialZero free];
    symbols = [symbols free];return [super clear];
}

- clone
{
    self = [super clone];
    scalarZero   = [scalarZero cheapCopy];
    termZero     = [termZero cheapCopy];
    monomialZero = [monomialZero cheapCopy];
    symbols      = [symbols cheapCopy];
    return self;
}

- scalarZero   { return scalarZero;   }
- termZero     { return termZero;     }
- monomialZero { return monomialZero; }
- symbols      { return symbols;      }

- eachTerm
{
    id aSequence = [ca_obj_vardnsrecdegdnspol_sequence newContent:[self cheapCopy]];
    return [CASequenceClass newCarrier:aSequence];
}

- elt_ca_obj_vardnsrecdegdnspol_ix:(ca_obj_vardnsrecdegdnspol_ixt)ix
{
    if (ca_obj_vardnsrecdegdnspol_ix_ismatch(ix)) {
	id c,s;int e;ca_obj_t t;
	t = ca_obj_vardnsrecdegdnspol_scalat(&value,ix,ca_obj_vardnsrecdegdnspol_getargs(self));
	e = ca_obj_vardnsrecdegdnspol_expat(&value,ix,ca_obj_vardnsrecdegdnspol_getargs(self));
	c = ca_obj_t2id([termZero coefficient],t);
	s = (e)?[[termZero symbol] cheapCopy]:nil;
	return [termZero coefficient:c symbol:s exponent:e];
    } else {
	return nil;
    }
}
- removeTerm
{
    if ([self isEmpty]) {
	return nil;
    } else {
	id lt;
	id c,s;int e;ca_obj_t t;
	[self checkRefCountOne];assert([self check]);
	
	t = ca_obj_vardnsrecdegdnspol_scalfirst(&value,ca_obj_vardnsrecdegdnspol_getargs(self));
	e = ca_obj_vardnsrecdegdnspol_expfirst(&value,ca_obj_vardnsrecdegdnspol_getargs(self));
	c = ca_obj_t2id([termZero coefficient],t);
	s = (e)?[[termZero symbol] cheapCopy]:nil;
	lt = [termZero coefficient:c symbol:s exponent:e];
	
	ca_obj_vardnsrecdegdnspol_remove(&value,ca_obj_vardnsrecdegdnspol_getargs(self));
	[self invalidate];assert([self check]);return lt;
    }
}

- insertTerm:aTerm
{
    if ([aTerm isZero])  {
	[aTerm free];return self;
    } else {
	ca_obj_c c;ca_obj_t r;int e;
	assert([aTerm check]);[self checkRefCountOne];assert([self check]);
	r = ca_obj_id2ref([aTerm coefficient],&c);e = [aTerm exponent];
	ca_obj_vardnsrecdegdnspol_insert(&value,e,r,ca_obj_vardnsrecdegdnspol_getargs(self));
	assert([aTerm check]);[aTerm free];
	[self invalidate];assert([self check]);return self;
    }
}

- multiplyCoefficient:s
{
    ca_obj_vardnsrecdegdnspol_c c;
    ca_obj_c sc;
    ca_obj_vardnsrecdegdnspol_oomulsc(&c,ca_obj_vardnsrecdegdnspol_id2t(self),ca_obj_id2ref(s,&sc),ca_obj_vardnsrecdegdnspol_getargs(self));
    return ca_obj_vardnsrecdegdnspol_c2id(self,&c);
}

- multiplySelfCoefficient:s
{
    ca_obj_c sc;
    if (refCount>1) return idReplace(self,[self multiplyCoefficient:s]);
    ca_obj_vardnsrecdegdnspol_inmulsc(ca_obj_vardnsrecdegdnspol_id2c(self),ca_obj_id2ref(s,&sc),ca_obj_vardnsrecdegdnspol_getargs(self));
    return [self invalidate];
}

- divideCoefficient:s
{
    ca_obj_vardnsrecdegdnspol_c c;
    ca_obj_c sc;
    BOOL failed = ca_obj_vardnsrecdegdnspol_oodivsc(&c,ca_obj_vardnsrecdegdnspol_id2t(self),ca_obj_id2ref(s,&sc),ca_obj_vardnsrecdegdnspol_getargs(self));
    return (failed)?nil:ca_obj_vardnsrecdegdnspol_c2id(self,&c);
}

- divideSelfCoefficient:s
{
    ca_obj_c sc;
    if (refCount>1) return idReplace(self,[self divideCoefficient:s]);
    ca_obj_vardnsrecdegdnspol_indivsc(ca_obj_vardnsrecdegdnspol_id2c(self),ca_obj_id2ref(s,&sc),ca_obj_vardnsrecdegdnspol_getargs(self));
    return [self invalidate];
}

- _add:(int)v:B multiplyCoefficient:b:(int)w
{
    ca_obj_vardnsrecdegdnspol_c c;
    ca_obj_c bc;
    ca_obj_vardnsrecdegdnspol_ooaddmulsc(&c,ca_obj_vardnsrecdegdnspol_id2t(self),v,ca_obj_vardnsrecdegdnspol_id2t(B),ca_obj_id2ref(b,&bc),w,ca_obj_vardnsrecdegdnspol_getargs(self));
    return ca_obj_vardnsrecdegdnspol_c2id(self,&c);
}

- _addSelf:(int)v:B multiplyCoefficient:b:(int)w
{
    ca_obj_c bc;
    if (refCount>1) return idReplace(self,[self _add:v:B multiplyCoefficient:b:w]);
    ca_obj_vardnsrecdegdnspol_inaddmulsc(ca_obj_vardnsrecdegdnspol_id2c(self),v,ca_obj_vardnsrecdegdnspol_id2t(B),ca_obj_id2ref(b,&bc),w,ca_obj_vardnsrecdegdnspol_getargs(self));
    return [self invalidate];
}

- _multiplyCoefficient:a:(int)v add:B:(int)w
{
    ca_obj_vardnsrecdegdnspol_c c;
    ca_obj_c ac;
    ca_obj_vardnsrecdegdnspol_oomulscadd(&c,ca_obj_vardnsrecdegdnspol_id2t(self),ca_obj_id2ref(a,&ac),v,ca_obj_vardnsrecdegdnspol_id2t(B),w,ca_obj_vardnsrecdegdnspol_getargs(self));
    return ca_obj_vardnsrecdegdnspol_c2id(self,&c);
}

- _multiplySelfCoefficient:a:(int)v add:B:(int)w
{
    ca_obj_c ac;
    if (refCount>1) return idReplace(self,[self _multiplyCoefficient:a:v add:B:w]);
    ca_obj_vardnsrecdegdnspol_inmulscadd(ca_obj_vardnsrecdegdnspol_id2c(self),ca_obj_id2ref(a,&ac),v,ca_obj_vardnsrecdegdnspol_id2t(B),w,ca_obj_vardnsrecdegdnspol_getargs(self));
    return [self invalidate];
}

- _multiplyCoefficient:a:(int)v add:B multiplyCoefficient:b:(int)w
{
    ca_obj_vardnsrecdegdnspol_c c;
    ca_obj_c ac,bc;
    ca_obj_vardnsrecdegdnspol_oomulscaddmulsc(&c,ca_obj_vardnsrecdegdnspol_id2t(self),ca_obj_id2ref(a,&ac),v,ca_obj_vardnsrecdegdnspol_id2t(B),ca_obj_id2ref(b,&bc),w,ca_obj_vardnsrecdegdnspol_getargs(self));
    return ca_obj_vardnsrecdegdnspol_c2id(self,&c);
}

- _multiplySelfCoefficient:a:(int)v add:B multiplyCoefficient:b:(int)w
{
    ca_obj_c ac,bc;
    if (refCount>1) return idReplace(self,[self _multiplyCoefficient:a:v add:B multiplyCoefficient:b:w]);
    ca_obj_vardnsrecdegdnspol_inmulscaddmulsc(ca_obj_vardnsrecdegdnspol_id2c(self),ca_obj_id2ref(a,&ac),v,ca_obj_vardnsrecdegdnspol_id2t(B),ca_obj_id2ref(b,&bc),w,ca_obj_vardnsrecdegdnspol_getargs(self));
    return [self invalidate];
}
- multiplyTerm:aTerm
{
    ca_obj_vardnsrecdegdnspol_c c;
    ca_obj_t s;
    ca_obj_c sc;
    s = ca_obj_id2ref([aTerm coefficient],&sc);
    ca_obj_vardnsrecdegdnspol_oomulmonomsc(&c,ca_obj_vardnsrecdegdnspol_id2t(self),[aTerm exponent],s,+1,ca_obj_vardnsrecdegdnspol_getargs(self));
    return ca_obj_vardnsrecdegdnspol_c2id(self,&c);
}

- multiplySelfTerm:aTerm
{
    ca_obj_t s;
    ca_obj_c sc;
    if (refCount>1) return idReplace(self,[self multiplyTerm:aTerm]);
    s = ca_obj_id2ref([aTerm coefficient],&sc);
    ca_obj_vardnsrecdegdnspol_inmulmonomsc(ca_obj_vardnsrecdegdnspol_id2c(self),[aTerm exponent],s,+1,ca_obj_vardnsrecdegdnspol_getargs(self));
    return [self invalidate];
}

- _multiplyTerm:aTerm:(int)v
{
    ca_obj_vardnsrecdegdnspol_c c;
    ca_obj_t s;
    ca_obj_c sc;
    s = ca_obj_id2ref([aTerm coefficient],&sc);
    ca_obj_vardnsrecdegdnspol_oomulmonomsc(&c,ca_obj_vardnsrecdegdnspol_id2t(self),[aTerm exponent],s,v,ca_obj_vardnsrecdegdnspol_getargs(self));
    return ca_obj_vardnsrecdegdnspol_c2id(self,&c);
}

- _multiplySelfTerm:aTerm:(int)v
{
    ca_obj_t s;
    ca_obj_c sc;
    if (refCount>1) return idReplace(self,[self _multiplyTerm:aTerm:v]);
    s = ca_obj_id2ref([aTerm coefficient],&sc);
    ca_obj_vardnsrecdegdnspol_inmulmonomsc(ca_obj_vardnsrecdegdnspol_id2c(self),[aTerm exponent],s,v,ca_obj_vardnsrecdegdnspol_getargs(self));
    return [self invalidate];
}

- divideTerm:aTerm
{
    int e;
    ca_obj_vardnsrecdegdnspol_c c;
    BOOL failed;
    ca_obj_t s;
    ca_obj_c sc;
    
    e = [aTerm exponent];
    s = ca_obj_id2ref([aTerm coefficient],&sc);
    failed=ca_obj_vardnsrecdegdnspol_oodivmonomsc(&c,ca_obj_vardnsrecdegdnspol_id2t(self),e,s,ca_obj_vardnsrecdegdnspol_getargs(self));
    return (failed)?nil:ca_obj_vardnsrecdegdnspol_c2id(self,&c);
}

- divideSelfTerm:aTerm
{
    ca_obj_t s;
    ca_obj_c sc;
    if (refCount>1) return idReplace(self,[self divideTerm:aTerm]);
    s = ca_obj_id2ref([aTerm coefficient],&sc);
    ca_obj_vardnsrecdegdnspol_indivmonomsc(ca_obj_vardnsrecdegdnspol_id2c(self),[aTerm exponent],s,ca_obj_vardnsrecdegdnspol_getargs(self));
    return [self invalidate];
}

- _add:(int)v:B multiplyTerm:b:(int)w
{
    ca_obj_vardnsrecdegdnspol_c c;
    ca_obj_c bc;
    ca_obj_t bs;
    bs = ca_obj_id2ref([b coefficient],&bc);
    ca_obj_vardnsrecdegdnspol_ooaddmulmonomsc(&c,ca_obj_vardnsrecdegdnspol_id2c(self),v,ca_obj_vardnsrecdegdnspol_id2t(B),[b exponent],bs,w,ca_obj_vardnsrecdegdnspol_getargs(self));
    return ca_obj_vardnsrecdegdnspol_c2id(self,&c);
}

- _addSelf:(int)v:B multiplyTerm:b:(int)w
{
    ca_obj_c bc;
    ca_obj_t bs;
    if (refCount>1) return idReplace(self,[self _add:v:B multiplyTerm:b:w]);
    bs = ca_obj_id2ref([b coefficient],&bc);
    ca_obj_vardnsrecdegdnspol_inaddmulmonomsc(ca_obj_vardnsrecdegdnspol_id2c(self),v,ca_obj_vardnsrecdegdnspol_id2t(B),[b exponent],bs,w,ca_obj_vardnsrecdegdnspol_getargs(self));
    return [self invalidate];
}

- _multiplyCoefficient:a:(int)v add:B multiplyTerm:b:(int)w
{
    ca_obj_vardnsrecdegdnspol_c c;
    ca_obj_c ac,bc;
    ca_obj_t as,bs;
    as = ca_obj_id2ref(a,&ac);
    bs = ca_obj_id2ref([b coefficient],&bc);
    ca_obj_vardnsrecdegdnspol_oomulscaddmulmonomsc(&c,ca_obj_vardnsrecdegdnspol_id2c(self),as,v,ca_obj_vardnsrecdegdnspol_id2t(B),[b exponent],bs,w,ca_obj_vardnsrecdegdnspol_getargs(self));
    return ca_obj_vardnsrecdegdnspol_c2id(self,&c);
}

- _multiplySelfCoefficient:a:(int)v add:B multiplyTerm:b:(int)w
{
    ca_obj_c ac,bc;
    ca_obj_t as,bs;
    if (refCount>1) return idReplace(self,[self _multiplyCoefficient:a:v add:B multiplyTerm:b:w]);
    as = ca_obj_id2ref(a,&ac);
    bs = ca_obj_id2ref([b coefficient],&bc);
    ca_obj_vardnsrecdegdnspol_inmulscaddmulmonomsc(ca_obj_vardnsrecdegdnspol_id2c(self),as,v,ca_obj_vardnsrecdegdnspol_id2t(B),[b exponent],bs,w,ca_obj_vardnsrecdegdnspol_getargs(self));
    return [self invalidate];
}

- fileOutOn:aFiler
{
    ca_obj_vardnsrecdegdnspol_args args;
    [super fileOutOn:aFiler];
    args = ca_obj_vardnsrecdegdnspol_getargs(self); /* can't do this in fileIn case */
    ca_obj_vardnsrecdegdnspol_args_fileOut(aFiler,&args);
    ca_obj_vardnsrecdegdnspol_fileOut(aFiler,&value,args);
    return self;
}

- fileInFrom:aFiler
{
    ca_obj_vardnsrecdegdnspol_args args;
    [super fileInFrom:aFiler];
    ca_obj_vardnsrecdegdnspol_args_fileIn(aFiler,&args);
    ca_obj_vardnsrecdegdnspol_fileIn(aFiler,&value,args);
    return self;
}

@end

