
/*
 * Computer Algebra Kit (c) 1993,95 by Comp.Alg.Objects.  All Rights Reserved.
 */

#include "cakit.h"

@implementation ca_obj_varspsexpdegsps_polynomial
- check
{
    int n;
    id last;
    
    [super check];
    [scalarZero check];[termZero check];[monomialZero check];
    [monomials check];
    
    last = nil;n = [monomials numMembers];
    while (n--) {
	id monomial = [monomials memberAt:n];
	assert([monomial notZero]);
	if (last) assert([last compareTerms:monomial] > 0);
	last = monomial;
    }

    return self;
}

+ new
{
    return [self notImplemented:_cmd];
}

- _setUpScalarZero:aScalar
{
    assert([aScalar isZero]);
    assert([aScalar class_varspsexpdegsps_polynomial] == self);

    aScalar  = [aScalar cheapCopy];
    termZero = [CATermClass newScalar:aScalar symbol:nil exponent:0];
    aScalar  = [aScalar cheapCopy];
    monomialZero = [CAMonomialClass newScalar:aScalar];

    scalarZero = aScalar;
    monomials  = [CACollectionClass new];

    assert([self check]);return self;
}

+ newScalarZero:aScalar
{
    return [[super new] _setUpScalarZero:aScalar];
}

- copy
{
    int i,n;id new;
 
    /* don't use [monomials copy] -> sends cheapCopy */
    new = [monomials empty];
    for(n = [monomials numMembers],i=0;i<n;i++) {
	id monomial = [monomials memberAt:i];[new insert:[monomial copy]];
    }

    return [self _monomials:new];
}

- deepCopy
{
    int i,n;id new;

    /* don't use [monomials deepCopy] -> sends copy */
    new = [monomials empty];
    for(n = [monomials numMembers],i=0;i<n;i++) {
	id monomial = [monomials memberAt:i];[new insert:[monomial deepCopy]];
    }

    return [self _monomials:new];
}

- clear
{
    monomialZero = [monomialZero free];
    scalarZero = [scalarZero free];
    termZero = [termZero free];
    monomials = [monomials free];
    return [super clear];
}

- _monomials { return monomials; } /* super temporal of course */

- scalarZero { return scalarZero; }
- termZero { return termZero; }
- monomialZero { return monomialZero; }

- clone
{
    self = [super clone];
    scalarZero   = [scalarZero cheapCopy];
    termZero     = [termZero cheapCopy];
    monomialZero = [monomialZero cheapCopy];
    monomials = nil;return self;
}

- _monomials:cltn
{
    self = [self clone];monomials = cltn;
    assert([self check]);return self;
}

- empty
{
    return [self _monomials:[CACollectionClass new]];
}

- emptyScalarZero:aZero
{
    id classCarrier = [aZero class_varspsexpdegsps_polynomial];
    return [classCarrier newScalarZero:aZero];
}

- emptyVariableDense:aCltn
{
    id classCarrier = [scalarZero class_vardnsexpdegsps_polynomial];
    return [classCarrier newScalarZero:[scalarZero cheapCopy] symbols:aCltn];
}

- emptyVariableSparse
{
    return [self empty];
}

- emptyExpanded
{
    return [self empty];
}

- emptyRecursive
{
    id classCarrier = [scalarZero class_varspsrecdegsps_polynomial];
    return [classCarrier newScalarZero:[scalarZero cheapCopy]];
}

- emptyDegreeSparse
{
    return [self empty];
}

- emptyDegreeDense
{
    id classCarrier = [scalarZero class_varspsexpdegdns_polynomial];
    return [classCarrier newScalarZero:[scalarZero cheapCopy]];
}

- (BOOL) isEmpty
{
    return [monomials numMembers] == 0;
}

- (BOOL) isZero
{
    return [monomials numMembers] == 0;
}

- (BOOL) isOne
{
    return [monomials numMembers] == 1 && [[monomials lastMember] isOne];
}

- (BOOL) isMinusOne
{
    return [monomials numMembers] == 1 && [[monomials lastMember] isMinusOne];
}

- (BOOL) sameClass:b
{
    return [super sameClass:b] && [scalarZero isEqual:[b scalarZero]];
}

- (BOOL) isEqual:b
{
    assert([self sameClass:b]);return [monomials isEqual:[b _monomials]];
}

- asScalar
{
    return ([monomials numMembers] == 1)?[[monomials lastMember] asScalar]:nil;
}

- asSymbol
{
    return ([monomials numMembers] == 1)?[[monomials lastMember] asSymbol]:nil;
}

- (int) numMonomials
{
    return [monomials numMembers];
}

- eachMonomial
{
    return [monomials eachMemberReversed];
}

- removeMonomial
{
    id lt;
    assert([self checkRefCountOne] == self && [self check] == self);
    lt = [monomials removeMember];[self invalidate];
    return lt;
}

- insertMonomial:aMonomial
{
    assert([self checkRefCountOne] == self && [self check] == self);
    
    if ([aMonomial isZero])  {
	[aMonomial free];return self;
    } else {
	int n = [monomials numMembers];
	while (n--) {
	    int cmp;
	    id monomial = [monomials memberAt:n];
	    cmp = [monomial compareTerms:aMonomial];
	    if (cmp == 0) {
		id sum = [monomial add:aMonomial];[aMonomial free];
		if ([sum isZero]) {
		    [[monomials removeMemberAt:n] free];[sum free];
		    assert([self check]);return [self invalidate];
		} else  {
		    [[monomials replaceMemberAt:n with:sum] free];
		    assert([self check]);return [self invalidate];
		}
	    } else {
		if (cmp > 0) {
		    continue;
		} else {
		    [monomials insert:aMonomial at:n+1];
		    assert([self check]);return [self invalidate];
		}
	    }
	}
	[monomials insert:aMonomial at:0];
	assert([self check]);return [self invalidate];
    }
}

@end

