#include "cakit.h"

static ca_obj_args ca_obj_getargs(id object)
{
    ca_obj_args args;args.proto = object;return args;
}

static int ca_obj_size(ca_obj_args args)
{
    return 1;			/* pointer increment */
}

static int ca_obj_bsize(ca_obj_args args)
{
    return sizeof(ca_obj_c);	/* byte size carrier */
}

#if 0
static ca_obj_t  ca_obj_id2t(id object) { /* not needed */ }
static ca_obj_c *ca_obj_id2t(id object) { /* not needed */ }
#endif

static ca_obj_t ca_obj_id2ref(id object,ca_obj_c *ref)
{
    return object;			/* read-only, scratch space "ref" */
}

static id ca_obj_t2id(id proto,ca_obj_t t)
{
    return [t cheapCopy];		/* new object, contains copy of "t" */
}

static id ca_obj_c2id(id proto,ca_obj_c *c)
{
    return *c;				/* new object, contains "c" */
}

static int ca_obj_check(ca_obj_t self,ca_obj_args args)
{
    assert(args.proto && self);[args.proto check];[self check];return 1;
}

static void ca_obj_oozero(ca_obj_c *c,ca_obj_args args)
{
    *c = [args.proto zero];
}

static void ca_obj_copy(ca_obj_c *c,ca_obj_t a,ca_obj_args args)
{
    *c = [a cheapCopy];
}

static void ca_obj_deepcopy(ca_obj_c *c,ca_obj_t a,ca_obj_args args)
{
    *c = [a deepCopy];
}

static void ca_obj_move(ca_obj_c *c,ca_obj_c *a,ca_obj_args args)
{
    *c = *a;*a = nil;
}

static void ca_obj_clear(ca_obj_c *c,ca_obj_args args)
{
    *c = [*c free];
}

static unsigned ca_obj_hash(ca_obj_t a,ca_obj_args args)
{
    return [a hash];
}

static int ca_obj_iseq(ca_obj_t a,ca_obj_t b,ca_obj_args args)
{
    return (a==b)?YES:[a isEqual:b];
}

static int ca_obj_sgn(ca_obj_t a,ca_obj_args args)
{
    return [a sign];
}

static int ca_obj_cmp(ca_obj_t a,ca_obj_t b,ca_obj_args args)
{
    return (a==b)?0:[a compare:b];
}

static int ca_obj_iszero(ca_obj_t a,ca_obj_args args)
{
    return [a isZero];
}

static int ca_obj_isop(ca_obj_t a,ca_obj_t b,ca_obj_args args)
{
    return [a isOpposite:b];
}

static void ca_obj_ooneg(ca_obj_c *c,ca_obj_t a,ca_obj_args args)
{
    *c = [a negate];
}

static void ca_obj_inneg(ca_obj_c *c,ca_obj_args args)
{
    *c = [*c negateSelf];
}

static void ca_obj_oodbl(ca_obj_c *c,ca_obj_t a,int v,ca_obj_args args)
{
    *c = [a _double:v];
}

static void ca_obj_indbl(ca_obj_c *c,int v,ca_obj_args args)
{
    *c = [*c _doubleSelf:v];
}

static void ca_obj_ooadd(ca_obj_c *c,ca_obj_t a,int v,ca_obj_t b,int w,ca_obj_args args)
{
    *c = [a _add:v:b:w];
}

static void ca_obj_inadd(ca_obj_c *c,int v,ca_obj_t b,int w,ca_obj_args args)
{
    *c = [*c _addSelf:v:b:w];
}

static int ca_obj_isone(ca_obj_t a,ca_obj_args args)
{
    return [a isOne];
}

static int ca_obj_isminusone(ca_obj_t a,ca_obj_args args)
{
    return [a isMinusOne];
}

static void ca_obj_oosqr(ca_obj_c *c,ca_obj_t a,ca_obj_args args)
{
    *c = [a square];
}

static void ca_obj_insqr(ca_obj_c *c,ca_obj_args args)
{
    *c = [*c squareSelf];
}

static void ca_obj_oomul(ca_obj_c *c,ca_obj_t a,ca_obj_t b,ca_obj_args args)
{
    *c = [a multiply:b];
}

static void ca_obj_inmul(ca_obj_c *c,ca_obj_t b,ca_obj_args args)
{
    *c = [*c multiplySelf:b];
}

static void ca_obj_oomulv(ca_obj_c *c,ca_obj_t a,ca_obj_t b,int v,ca_obj_args args)
{
    *c = [a _multiply:b:v];
}

static void ca_obj_inmulv(ca_obj_c *c,ca_obj_t b,int v,ca_obj_args args)
{
    *c = [*c _multiplySelf:b:v];
}

static void ca_obj_ooaddmul(ca_obj_c *c,ca_obj_t a,int v,ca_obj_t b,ca_obj_t t,int w,ca_obj_args args)
{
    *c = [a _add:v:b multiply:t:w];
}

static void ca_obj_inaddmul(ca_obj_c *c,int v,ca_obj_t b,ca_obj_t t,int w,ca_obj_args args)
{
    *c = [*c _addSelf:v:b multiply:t:w];
}

static void ca_obj_oomuladd(ca_obj_c *c,ca_obj_t a,ca_obj_t s,int v,ca_obj_t b,int w,ca_obj_args args)
{
    *c = [a _multiply:s:v add:b:w];
}

static void ca_obj_inmuladd(ca_obj_c *c,ca_obj_t s,int v,ca_obj_t b,int w,ca_obj_args args)
{
    *c = [*c _multiplySelf:s:v add:b:w];
}

static void ca_obj_oomuladdmul(ca_obj_c *c,ca_obj_t a,ca_obj_t s,int v,ca_obj_t b,ca_obj_t t,int w,ca_obj_args args)
{
    *c = [a _multiply:s:v add:b multiply:t:w];
}

static void ca_obj_inmuladdmul(ca_obj_c *c,ca_obj_t s,int v,ca_obj_t b,ca_obj_t t,int w,ca_obj_args args)
{
    *c = [*c _multiplySelf:s:v add:b multiply:t:w];
}

static void ca_obj_ooaddsqr(ca_obj_c *c,ca_obj_t a,int v,ca_obj_t b,int w,ca_obj_args args)
{
    *c = [a _addSquare:v:b:w];
}

static void ca_obj_inaddsqr(ca_obj_c *c,int v,ca_obj_t b,int w,ca_obj_args args)
{
    *c = [*c _addSelfSquare:v:b:w];
}

static void ca_obj_ooinv(ca_obj_c *c,ca_obj_t a,ca_obj_args args)
{
    *c = [a inverse];
}

static void ca_obj_ininv(ca_obj_c *c,ca_obj_args args)
{
    *c = [*c inverseSelf];
}

static BOOL ca_obj_oodiv(ca_obj_c *c,ca_obj_t a,ca_obj_t b,ca_obj_args args)
{
    id Q = [a divide:b];
    if (Q) {
	*c = Q;return SUCCESS;
    } else {
	return FAILURE;
    }
}

static void ca_obj_indiv(ca_obj_c *c,ca_obj_t b,ca_obj_args args)
{
    id Q = [*c divideSelf:b];
    if (Q) {
	*c = Q;
    } else {
	fprintf(stderr,"-exact division failed\n");abort();
    }
}

static void ca_obj_args_fileOut(id aFiler,ca_obj_args *args) {}
static void ca_obj_args_fileIn(id aFiler,ca_obj_args *args) {}

static void ca_obj_fileOut(id aFiler,ca_obj_c *a,ca_obj_args args)
{
    [aFiler fileOut:a type:'@'];
}

static void ca_obj_fileIn(id aFiler,ca_obj_c *c,ca_obj_args args)
{
    [aFiler fileIn:c type:'@'];
}


/*
 * Computer Algebra Kit (c) 1993,95 by Comp.Alg.Objects.  All Rights Reserved.
 */

#if ca_obj_pervalue
static ca_obj_t ca_objseq_tval(ca_objseq_t self)
{
    return *self;
}
static ca_obj_c *ca_objseq_cval(ca_objseq_t self)
{
    return self;
}
#else
static ca_obj_t ca_objseq_tval(ca_objseq_t self)
{
    return self;
}
static ca_obj_c *ca_objseq_cval(ca_objseq_t self)
{
    return self;
}
#endif

static int ca_objseq_check(ca_objseq_t self,int n,ca_obj_args args)
{
    while (n--) {
	ca_obj_check(ca_objseq_tval(self),args);
	self += ca_obj_size(args);
    }
    return 1;
}

static ca_objseq_t ca_objseq_alloc(int n,ca_obj_args args)
{
    return (ca_objseq_t)OC_Malloc(n * ca_obj_bsize(args));
}

static ca_objseq_t ca_objseq_realloc(ca_objseq_t self,int n,ca_obj_args args)
{
    return (ca_objseq_t)OC_Realloc(self,n * ca_obj_bsize(args));
}

static ca_objseq_t ca_objseq_free(ca_objseq_t self,ca_obj_args args)
{
    OC_Free(self);return NULL;
}

static void ca_objseq_oozero(ca_objseq_t c,int n,ca_obj_args args)
{
    while (n--) {
	ca_obj_oozero(ca_objseq_cval(c),args);
	c += ca_obj_size(args);
    }
}

static void ca_objseq_copy(ca_objseq_t c,ca_objseq_t a,int n,ca_obj_args args)
{
    assert(n >= 0);
    while (n--) {
	ca_obj_copy(ca_objseq_cval(c),ca_objseq_tval(a),args);
	c+=ca_obj_size(args);a+=ca_obj_size(args);
    }
}

static void ca_objseq_deepcopy(ca_objseq_t c,ca_objseq_t a,int n,ca_obj_args args)
{
    assert(n >= 0);
    while (n--) {
	ca_obj_deepcopy(ca_objseq_cval(c),ca_objseq_tval(a),args);
	c+=ca_obj_size(args);a+=ca_obj_size(args);
    }
}

#if ca_obj_isvalue
static void ca_objseq_clear(ca_objseq_t self,int n,ca_obj_args args)
{
    /* nothing to clear */
}
#else
static void ca_objseq_clear(ca_objseq_t self,int n,ca_obj_args args)
{
    while (n--) {
	ca_obj_clear(self,args);
	self+=ca_obj_size(args);
    }
}
#endif /* ca_obj_isvalue */

static int ca_objseq_iseq(ca_objseq_t a,ca_objseq_t b,int n,ca_obj_args args)
{
    assert(n >= 0 && a != b);
    while (n--) {
	if (!ca_obj_iseq(ca_objseq_tval(a),ca_objseq_tval(b),args)) {
	    return 0;
	} else {
	    a+=ca_obj_size(args);b+=ca_obj_size(args);
	}
    }
    return 1;
}

static unsigned ca_objseq_hash(ca_objseq_t a,int n,ca_obj_args args)
{
    assert(n >= 0);
    return (n)?ca_obj_hash(ca_objseq_tval(a),args):0;
}

static void ca_objseq_place(ca_objseq_t self,ca_obj_t a,int i,ca_obj_args args)
{
    ca_obj_c *c = ca_objseq_cval(self + i * ca_obj_size(args));
    ca_obj_clear(c,args);ca_obj_copy(c,a,args);
}

static int ca_objseq_insertlast(ca_objseq_t self,ca_obj_t a,int n,ca_obj_args args)
{
    ca_obj_c *c;
    assert(n >= 0);
    c = ca_objseq_cval(self + n * ca_obj_size(args));
    ca_obj_copy(c,a,args);return ++n;
}

static int ca_objseq_insertfirst(ca_objseq_t self,ca_obj_t a,int n,ca_obj_args args)
{
    int j;
    assert(n > 0);
    self += n * ca_obj_size(args);
    j=n;while(j--) {
	ca_objseq_t t;
	t = self - ca_obj_size(args);
	ca_obj_move(ca_objseq_cval(self),ca_objseq_cval(t),args);
	self = t;
    }
    ca_obj_copy(ca_objseq_cval(self),a,args);
    return ++n;
}

static int ca_objseq_insertat(ca_objseq_t self,ca_obj_t a,int i,int n,ca_obj_args args)
{
    assert(0 <= i && i < n);
    self += i*ca_obj_size(args);
    return i + ca_objseq_insertfirst(self,a,n-i,args);
}

static int ca_objseq_freelast(ca_objseq_t self,int n,ca_obj_args args)
{
    ca_obj_c *c;assert(0 < n);
    --n;c = ca_objseq_cval(self + n * ca_obj_size(args));
    ca_obj_clear(c,args);return n;
}

static int ca_objseq_freefirst(ca_objseq_t self,int n,ca_obj_args args)
{
    int j;
    assert(0 < n);
    ca_obj_clear(ca_objseq_cval(self),args);
    --n;j=n;while(j--) {
	ca_objseq_t t;
	t = self+ca_obj_size(args);
	ca_obj_move(ca_objseq_cval(self),ca_objseq_cval(t),args);
	self = t;
    }
    return n;
}

static int ca_objseq_freeat(ca_objseq_t self,int i,int n,ca_obj_args args)
{
    assert(0 <= i && i < n);
    self += i*ca_obj_size(args);
    return i + ca_objseq_freefirst(self,n-i,args);
}

static ca_obj_t ca_objseq_at(ca_objseq_t self,int i,ca_obj_args args)
{
    ca_obj_t res;assert(0 <= i);
    res = ca_objseq_tval(self + i * ca_obj_size(args));
    assert(ca_obj_check(res,args));
    return res;
}

static ca_obj_t ca_objseq_last(ca_objseq_t self,int n,ca_obj_args args)
{
    return ca_objseq_at(self,n-1,args);
}

static ca_obj_c *ca_objseq_cvalat(ca_objseq_t self,int i,ca_obj_args args)
{
    assert(0 <= i);return ca_objseq_cval(self + i * ca_obj_size(args));
}

static int ca_objseq_iszero(ca_objseq_t a,int n,ca_obj_args args)
{
    assert(n >= 0);
    while (n--) {
	if (ca_obj_iszero(ca_objseq_tval(a),args)) {
	    a+=ca_obj_size(args);
	} else {
	    return 0;
	}
    }
    return 1;
}

static int ca_objseq_isop(ca_objseq_t a,ca_objseq_t b,int n,ca_obj_args args)
{
    assert(n >= 0 && a != b);
    while (n--) {
	if (!ca_obj_isop(ca_objseq_tval(a),ca_objseq_tval(b),args)) {
	    return 0;
	} else {
	    a+=ca_obj_size(args);b+=ca_obj_size(args);
	}
    }
    return 1;
}

static void ca_objseq_ooneg(ca_objseq_t c,ca_objseq_t a,int n,ca_obj_args args)
{
    assert(n >= 0);
    while (n--) {
	ca_obj_ooneg(ca_objseq_cval(c),ca_objseq_tval(a),args);
	c+=ca_obj_size(args);a+=ca_obj_size(args);
    }
}

static void ca_objseq_inneg(ca_objseq_t a,int n,ca_obj_args args)
{
    assert(n >= 0);
    while (n--) {
	ca_obj_inneg(ca_objseq_cval(a),args);
	a += ca_obj_size(args);
    }
}

static void ca_objseq_oonegv(ca_objseq_t c,ca_objseq_t a,int v,int n,ca_obj_args args)
{
    assert(v*v == 1);if (v == -1) ca_objseq_ooneg(c,a,n,args);
    else ca_objseq_copy(c,a,n,args);
}

static void ca_objseq_innegv(ca_objseq_t a,int v,int n,ca_obj_args args)
{
    assert(v*v == 1);if (v == -1) ca_objseq_inneg(a,n,args);
}

static void ca_objseq_oodbl(ca_objseq_t c,ca_objseq_t a,int v,int n,ca_obj_args args)
{
    assert(n >= 0 && v*v == 1);
    while (n--) {
	ca_obj_oodbl(ca_objseq_cval(c),ca_objseq_tval(a),v,args);
	c+=ca_obj_size(args);a+=ca_obj_size(args);
    }
}

static void ca_objseq_indbl(ca_objseq_t a,int v,int n,ca_obj_args args)
{
    assert(n >= 0 && v*v == 1);
    while (n--) {
	ca_obj_indbl(ca_objseq_cval(a),v,args);
	a += ca_obj_size(args);
    }
}

static void ca_objseq_ooadd(ca_objseq_t c,ca_objseq_t a,int v,ca_objseq_t b,int w,int n,ca_obj_args args)
{
    assert(n >= 0 && a != b && v*v == 1 && w*w == 1);
    while (n--) {
	ca_obj_ooadd(ca_objseq_cval(c),ca_objseq_tval(a),v,ca_objseq_tval(b),w,args);
	c+=ca_obj_size(args);a+=ca_obj_size(args);b+=ca_obj_size(args);
    }
}

static void ca_objseq_inadd(ca_objseq_t a,int v,ca_objseq_t b,int w,int n,ca_obj_args args)
{
    assert(n >= 0 && a != b && v*v == 1 && w*w == 1);
    while (n--) {
	ca_obj_inadd(ca_objseq_cval(a),v,ca_objseq_tval(b),w,args);
	a+=ca_obj_size(args);b+=ca_obj_size(args);
    }
}

static void ca_objseq_oomulsc(ca_objseq_t c,ca_objseq_t a,ca_obj_t s,int n,ca_obj_args args)
{
    assert(n >= 0);
    while (n--) {
	ca_obj_oomul(ca_objseq_cval(c),ca_objseq_tval(a),s,args);
	c+=ca_obj_size(args);a+=ca_obj_size(args);
    }
}

static void ca_objseq_inmulsc(ca_objseq_t a,ca_obj_t s,int n,ca_obj_args args)
{
    assert(n >= 0);
    while (n--) {
	ca_obj_inmul(ca_objseq_cval(a),s,args);
	a+=ca_obj_size(args);
    }
}

static void ca_objseq_oomulscv(ca_objseq_t c,ca_objseq_t a,ca_obj_t s,int v,int n,ca_obj_args args)
{
    assert(n >= 0 && v*v == 1);
    while (n--) {
	ca_obj_oomulv(ca_objseq_cval(c),ca_objseq_tval(a),s,v,args);
	c+=ca_obj_size(args);a+=ca_obj_size(args);
    }
}

static void ca_objseq_inmulscv(ca_objseq_t a,ca_obj_t s,int v,int n,ca_obj_args args)
{
    assert(n >= 0 && v*v == 1);
    while (n--) {
	ca_obj_inmulv(ca_objseq_cval(a),s,v,args);
	a+=ca_obj_size(args);
    }
}

static void ca_objseq_ooaddmulsc(ca_objseq_t c,ca_objseq_t a,int v,ca_objseq_t b,ca_obj_t t,int w,int n,ca_obj_args args)
{
    assert(n >= 0 && v*v == 1 && w*w == 1);
    while (n--) {
	ca_obj_ooaddmul(ca_objseq_cval(c),ca_objseq_tval(a),v,ca_objseq_tval(b),t,w,args);
	a+=ca_obj_size(args);b+=ca_obj_size(args);c+=ca_obj_size(args);
    }
}

static void ca_objseq_oomulscadd(ca_objseq_t c,ca_objseq_t a,ca_obj_t s,int v,ca_objseq_t b,int w,int n,ca_obj_args args)
{
    assert(n >= 0 && v*v == 1 && w*w == 1);
    while (n--) {
	ca_obj_oomuladd(ca_objseq_cval(c),ca_objseq_tval(a),s,v,ca_objseq_tval(b),w,args);
	a+=ca_obj_size(args);b+=ca_obj_size(args);c+=ca_obj_size(args);
    }
}

static void ca_objseq_oomulscaddmulsc(ca_objseq_t c,ca_objseq_t a,ca_obj_t s,int v,ca_objseq_t b,ca_obj_t t,int w,int n,ca_obj_args args)
{
    assert(n >= 0 && v*v == 1 && w*w == 1);
    while (n--) {
	ca_obj_oomuladdmul(ca_objseq_cval(c),ca_objseq_tval(a),s,v,ca_objseq_tval(b),t,w,args);
	a+=ca_obj_size(args);b+=ca_obj_size(args);c+=ca_obj_size(args);
    }
}

static void ca_objseq_inaddmulsc(ca_objseq_t a,int v,ca_objseq_t b,ca_obj_t t,int w,int n,ca_obj_args args)
{
    assert(n >= 0 && v*v == 1 && w*w == 1);
    while (n--) {
	ca_obj_inaddmul(ca_objseq_cval(a),v,ca_objseq_tval(b),t,w,args);
	a+=ca_obj_size(args);b+=ca_obj_size(args);
    }
}

static void ca_objseq_inmulscadd(ca_objseq_t a,ca_obj_t s,int v,ca_objseq_t b,int w,int n,ca_obj_args args)
{
    assert(n >= 0 && v*v == 1 && w*w == 1);
    while (n--) {
	ca_obj_inmuladd(ca_objseq_cval(a),s,v,ca_objseq_tval(b),w,args);
	a+=ca_obj_size(args);b+=ca_obj_size(args);
    }
}

static void ca_objseq_inmulscaddmulsc(ca_objseq_t a,ca_obj_t s,int v,ca_objseq_t b,ca_obj_t t,int w,int n,ca_obj_args args)
{
    assert(n >= 0 && v*v == 1 && w*w == 1);
    while (n--) {
	ca_obj_inmuladdmul(ca_objseq_cval(a),s,v,ca_objseq_tval(b),t,w,args);
	a+=ca_obj_size(args);b+=ca_obj_size(args);
    }
}

static BOOL ca_objseq_oodivsc(ca_objseq_t c,ca_objseq_t a,ca_obj_t s,int n,ca_obj_args args)
{
    int i;
    BOOL failed;
    ca_objseq_t orgc = c;
    assert(n >= 0);
   
    for(i=0;i<n;i++) {
    
	failed = ca_obj_oodiv(ca_objseq_cval(c),ca_objseq_tval(a),s,args);
	
	if (failed) {
	    ca_objseq_clear(orgc,i - 1,args);
	    return FAILURE;
	} else {
	    c+=ca_obj_size(args);a+=ca_obj_size(args);
	}
    }
    
    return SUCCESS;
}

static void ca_objseq_indivsc(ca_objseq_t a,ca_obj_t s,int n,ca_obj_args args)
{
    assert(n >= 0);
    while (n--) {
	ca_obj_indiv(ca_objseq_cval(a),s,args);
	a+=ca_obj_size(args);
    }
}

static void ca_objseq_oodotsqr(ca_obj_c *c,ca_objseq_t a,int n,ca_obj_args args)
{
    assert(n >= 0);
    ca_obj_oozero(c,args);
    while (n--) {
	ca_obj_inaddsqr(c,+1,ca_objseq_tval(a),+1,args);a += ca_obj_size(args);
    }
}

static void ca_objseq_oodotmul(ca_obj_c *c,ca_objseq_t a,ca_objseq_t b,int n,ca_obj_args args)
{
    assert(n >= 0);
    ca_obj_oozero(c,args);
    while (n--) {
	ca_obj_inaddmul(c,+1,ca_objseq_tval(a),ca_objseq_tval(b),+1,args);
	a += ca_obj_size(args);b += ca_obj_size(args);
    }
}

static void ca_objseq_args_fileOut(id aFiler,ca_obj_args *args)
{
    ca_obj_args_fileOut(aFiler,args);
}
static void ca_objseq_args_fileIn(id aFiler,ca_obj_args *args)
{
    ca_obj_args_fileIn(aFiler,args);
}

static void ca_objseq_fileOut(id aFiler,ca_objseq_t self,int n,ca_obj_args args)
{
    assert(n>=0);
    while (n--) {
	ca_obj_fileOut(aFiler,ca_objseq_cval(self),args);
	self += ca_obj_size(args);
    }
}

static void ca_objseq_fileIn(id aFiler,ca_objseq_t self,int n,ca_obj_args args)
{
    assert(n>=0);
    while (n--) {
	ca_obj_fileIn(aFiler,ca_objseq_cval(self),args);
	self += ca_obj_size(args);
    }
}

static ca_objvec_args ca_objvec_getargs(id self)
{
    ca_objvec_args args;
    args.sargs = ca_obj_getargs([self scalarZero]);
    return args;
}

static int ca_objvec_check(ca_objvec_t self,ca_objvec_args args)
{
    assert(0 <= self->n && self->n <= self->c);
    ca_objseq_check(self->ptr,self->n,args.sargs);return 1;
}

static ca_objvec_t ca_objvec_id2t(id object)
{
    return [object ca_objvec_value];
}

static ca_objvec_c *ca_objvec_id2c(id object)
{
    return [object ca_objvec_reference];
}

static id ca_objvec_t2id(id proto,ca_objvec_t f)
{
    return [proto ca_objvec_value:f];
}

static id ca_objvec_c2id(id proto,ca_objvec_c *r)
{
    return [proto ca_objvec_reference:r];
}

static void ca_objvec_init(ca_objvec_t self,int n,ca_objvec_args args)
{
    self->n   = n;
    self->c   = n;
    self->ptr = ca_objseq_alloc(n,args.sargs);
}

static void ca_objvec_initcount(ca_objvec_t c,int n,ca_objvec_args args)
{
    ca_objvec_init(c,n,args);
    ca_objseq_oozero(c->ptr,n,args.sargs);
}

static void ca_objvec_initcapacity(ca_objvec_t self,int n,ca_objvec_args args)
{
    self->n   = 0;
    self->c   = n;
    self->ptr = ca_objseq_alloc(n,args.sargs);
}

static void ca_objvec_copy(ca_objvec_t c,ca_objvec_t a,ca_objvec_args args)
{
    ca_objvec_init(c,a->n,args);
    ca_objseq_copy(c->ptr,a->ptr,a->n,args.sargs);
}

static void ca_objvec_deepcopy(ca_objvec_t c,ca_objvec_t a,ca_objvec_args args)
{
    ca_objvec_init(c,a->n,args);
    ca_objseq_deepcopy(c->ptr,a->ptr,a->n,args.sargs);
}

static void ca_objvec_move(ca_objvec_t c,ca_objvec_t a,ca_objvec_args args)
{
    c->n   = a->n;
    c->c   = a->c;
    c->ptr = a->ptr;a->ptr = NULL;
}

static void ca_objvec_destroy(ca_objvec_t self,ca_objvec_args args)
{
    /*
     * clearing memory allocated by ca_objvec_init after a failed operation
     * can't do a ca_objseq_clear in that case as the handler doesnt know
     * what elements have been allocated
     */
     
    self->ptr = ca_objseq_free(self->ptr,args.sargs);
}

static void ca_objvec_clear(ca_objvec_t self,ca_objvec_args args)
{
    ca_objseq_clear(self->ptr,self->n,args.sargs);
    ca_objvec_destroy(self,args);
}

static int ca_objvec_count(ca_objvec_t self)
{
    return self->n;
}

static unsigned ca_objvec_hash(ca_objvec_t a,ca_objvec_args args)
{
    return ca_objseq_hash(a->ptr,a->n,args.sargs);
}

static int ca_objvec_iseq(ca_objvec_t a,ca_objvec_t b,ca_objvec_args args)
{
    assert(a != b);
    return (a->n == b->n && ca_objseq_iseq(a->ptr,b->ptr,a->n,args.sargs));
}

static void ca_objvec_expand(ca_objvec_t self,ca_objvec_args args)
{
    assert(self->n == self->c);
    self->c   = self->n + self->c + 1;
    self->ptr = ca_objseq_realloc(self->ptr,self->c,args.sargs);
    assert(self->n < self->c);
}

static void ca_objvec_insertfirst(ca_objvec_t self,ca_obj_t a,ca_objvec_args args)
{
    assert(self->n <= self->c);
    if (self->n == self->c) ca_objvec_expand(self,args);
    self->n = ca_objseq_insertlast(self->ptr,a,self->n,args.sargs);
}

static void ca_objvec_insertat(ca_objvec_t self,ca_obj_t a,int i,ca_objvec_args args)
{
    assert(0 < i && i <= self->n && self->n <= self->c);
    if (self->n == self->c) ca_objvec_expand(self,args);
    
    if (i == self->n) {
    self->n = ca_objseq_insertfirst(self->ptr,a,self->n,args.sargs);
    } else {
    self->n = ca_objseq_insertat(self->ptr,a,self->n-i-1,self->n,args.sargs);
    }
}

static void ca_objvec_place(ca_objvec_t self,ca_obj_t a,int i,ca_objvec_args args)
{
    assert(0 <= i && i < self->n);
    ca_objseq_place(self->ptr,a,self->n - i - 1,args.sargs);
}

static void ca_objvec_freefirst(ca_objvec_t self,ca_objvec_args args)
{
    assert(self->n > 0);
    self->n = ca_objseq_freelast(self->ptr,self->n,args.sargs);
}

static void ca_objvec_freeat(ca_objvec_t self,int i,ca_objvec_args args)
{
    assert(0 < i && i < self->n);
    self->n = ca_objseq_freeat(self->ptr,self->n-i-1,self->n,args.sargs);
}


static ca_obj_t ca_objvec_at(ca_objvec_t self,int ix,ca_objvec_args args)
{
    assert(0 <= ix && ix < self->n);
    return ca_objseq_at(self->ptr,self->n - ix - 1,args.sargs);
}

static ca_obj_t ca_objvec_first(ca_objvec_t self,ca_objvec_args args)
{
    assert(self->n > 0);
    return ca_objseq_last(self->ptr,self->n,args.sargs);
}

static ca_obj_t ca_objvec_elt(ca_objvec_t self,ca_objvec_ixt ix,ca_objvec_args args)
{
    assert(ix->n == self->n);
    return ca_objvec_at(self,ix->i,args);
}

static int ca_objvec_iszero(ca_objvec_t self,ca_objvec_args args)
{
    return ca_objseq_iszero(self->ptr,self->n,args.sargs);
}

static int ca_objvec_isop(ca_objvec_t a,ca_objvec_t b,ca_objvec_args args)
{
    assert(a != b);
    return (a->n == b->n && ca_objseq_isop(a->ptr,b->ptr,a->n,args.sargs));
}

static void ca_objvec_ooneg(ca_objvec_t c,ca_objvec_t a,ca_objvec_args args)
{
    ca_objvec_init(c,a->n,args);
    ca_objseq_ooneg(c->ptr,a->ptr,a->n,args.sargs);
}

static void ca_objvec_inneg(ca_objvec_t a,ca_objvec_args args)
{
    ca_objseq_inneg(a->ptr,a->n,args.sargs);
}

static void ca_objvec_oodbl(ca_objvec_t c,ca_objvec_t a,int v,ca_objvec_args args)
{
    ca_objvec_init(c,a->n,args);
    ca_objseq_oodbl(c->ptr,a->ptr,v,a->n,args.sargs);
}

static void ca_objvec_indbl(ca_objvec_t a,int v,ca_objvec_args args)
{
    ca_objseq_indbl(a->ptr,v,a->n,args.sargs);
}

static void ca_objvec_checkcount(int a,int b)
{
    if (a != b) { fprintf(stderr,"Vector : Dimensions Not Equal\n");abort(); }
}

static void ca_objvec_ooadd(ca_objvec_t c,ca_objvec_t a,int v,ca_objvec_t b,int w,ca_objvec_args args)
{
    assert(a!=b);ca_objvec_checkcount(a->n,b->n);
    ca_objvec_init(c,a->n,args);
    ca_objseq_ooadd(c->ptr,a->ptr,v,b->ptr,w,a->n,args.sargs);
}

static void ca_objvec_inadd(ca_objvec_t a,int v,ca_objvec_t b,int w,ca_objvec_args args)
{
    assert(a!=b);ca_objvec_checkcount(a->n,b->n);
    ca_objseq_inadd(a->ptr,v,b->ptr,w,a->n,args.sargs);
}

static void ca_objvec_oomulsc(ca_objvec_t c,ca_objvec_t a,ca_obj_t s,ca_objvec_args args)
{
    ca_objvec_init(c,a->n,args);
    ca_objseq_oomulsc(c->ptr,a->ptr,s,a->n,args.sargs);
}

static void ca_objvec_inmulsc(ca_objvec_t a,ca_obj_t s,ca_objvec_args args)
{
    ca_objseq_inmulsc(a->ptr,s,a->n,args.sargs);
}

static void ca_objvec_ooaddmulsc(ca_objvec_t c,ca_objvec_t a,int v,ca_objvec_t b,ca_obj_t s,int w,ca_objvec_args args)
{
    assert(a != b);ca_objvec_checkcount(a->n,b->n);
    ca_objvec_init(c,a->n,args);
    ca_objseq_ooaddmulsc(c->ptr,a->ptr,v,b->ptr,s,w,a->n,args.sargs);
}

static void ca_objvec_inaddmulsc(ca_objvec_t a,int v,ca_objvec_t b,ca_obj_t s,int w,ca_objvec_args args)
{
    assert(a != b);ca_objvec_checkcount(a->n,b->n);
    ca_objseq_inaddmulsc(a->ptr,v,b->ptr,s,w,a->n,args.sargs);
}

static void ca_objvec_oomulscadd(ca_objvec_t c,ca_objvec_t a,ca_obj_t s,int v,ca_objvec_t b,int w,ca_objvec_args args)
{
    assert(a != b);ca_objvec_checkcount(a->n,b->n);
    ca_objvec_init(c,a->n,args);
    ca_objseq_oomulscadd(c->ptr,a->ptr,s,v,b->ptr,w,a->n,args.sargs);
}

static void ca_objvec_inmulscadd(ca_objvec_t a,ca_obj_t s,int v,ca_objvec_t b,int w,ca_objvec_args args)
{
    assert(a != b);ca_objvec_checkcount(a->n,b->n);
    ca_objseq_inmulscadd(a->ptr,s,v,b->ptr,w,a->n,args.sargs);
}

static void ca_objvec_oomulscaddmulsc(ca_objvec_t c,ca_objvec_t a,ca_obj_t s,int v,ca_objvec_t b,ca_obj_t t,int w,ca_objvec_args args)
{
    assert(a != b);ca_objvec_checkcount(a->n,b->n);
    ca_objvec_init(c,a->n,args);
    ca_objseq_oomulscaddmulsc(c->ptr,a->ptr,s,v,b->ptr,t,w,a->n,args.sargs);
}

static void ca_objvec_inmulscaddmulsc(ca_objvec_t a,ca_obj_t s,int v,ca_objvec_t b,ca_obj_t t,int w,ca_objvec_args args)
{
    assert(a != b);ca_objvec_checkcount(a->n,b->n);
    ca_objseq_inmulscaddmulsc(a->ptr,s,v,b->ptr,t,w,a->n,args.sargs);
}

static BOOL ca_objvec_oodivsc(ca_objvec_t c,ca_objvec_t a,ca_obj_t s,ca_objvec_args args)
{
    BOOL failed;
    
    ca_objvec_init(c,a->n,args);
    failed = ca_objseq_oodivsc(c->ptr,a->ptr,s,a->n,args.sargs);
    if (failed) ca_objvec_destroy(c,args);
    
    return failed;
}

static void ca_objvec_indivsc(ca_objvec_t a,ca_obj_t s,ca_objvec_args args)
{
    ca_objseq_indivsc(a->ptr,s,a->n,args.sargs);
}

static void ca_objvec_oodotmul(ca_obj_c *c,ca_objvec_t a,ca_objvec_t b,ca_objvec_args args)
{
    assert(a != b);ca_objvec_checkcount(a->n,b->n);
    ca_objseq_oodotmul(c,a->ptr,b->ptr,a->n,args.sargs);
}

static void ca_objvec_oodotsqr(ca_obj_c *c,ca_objvec_t a,ca_objvec_args args)
{
    ca_objseq_oodotsqr(c,a->ptr,a->n,args.sargs);
}

static void ca_objvec_args_fileOut(id aFiler,ca_objvec_args *args)
{
    ca_objseq_args_fileOut(aFiler,&args->sargs);
}
static void ca_objvec_args_fileIn(id aFiler,ca_objvec_args *args)
{
    ca_objseq_args_fileIn(aFiler,&args->sargs);
}

static void ca_objvec_fileOut(id aFiler,ca_objvec_t self,ca_objvec_args args)
{
    [aFiler fileOut:&self->n type:'i'];
    ca_objseq_fileOut(aFiler,self->ptr,self->n,args.sargs);
}

static void ca_objvec_fileIn(id aFiler,ca_objvec_t self,ca_objvec_args args)
{
    int n;
    [aFiler fileIn:&n type:'i']; 
    ca_objvec_init(self,n,args);
    ca_objseq_fileIn(aFiler,self->ptr,self->n,args.sargs);
}

static void ca_objvec_ix_init(ca_objvec_ixt ix,id self)
{
    ca_objvec_t v = [self ca_objvec_value];
    ix->n = v->n;
}

static void ca_objvec_ix_copy(ca_objvec_ixt c,ca_objvec_ixt a)
{
    c->i = a->i;c->n = a->n;
}

static void ca_objvec_ix_clear(ca_objvec_ixt ix)
{
    /* nothing to clear */
}

static int ca_objvec_ix_count(ca_objvec_ixt ix)
{
    return ix->n;
}

static int ca_objvec_ix_isempty(ca_objvec_ixt ix)
{
    return ix->n == 0;
}

static int ca_objvec_ix_ismatch(ca_objvec_ixt ix)
{
    assert(-1 <= ix->i && ix->i <= ix->n);
    return 0 <= ix->i && ix->i < ix->n;
}

static void ca_objvec_ix_tofirst(ca_objvec_ixt ix)
{
    ix->i = -1;	/* next -> first */
}

static void ca_objvec_ix_tolast(ca_objvec_ixt ix)
{
    ix->i = ix->n; /* prev -> last */
}

static void ca_objvec_ix_to(ca_objvec_ixt ix,int i)
{
    /* the actual position is n-i-1; conversion done in elting routine... */
    if (i < 0) ix->i = -1;else if (i > ix->n) ix->i = ix->n;
    else ix->i = i-1; /* next -> at i */
}

static void ca_objvec_ix_next(ca_objvec_ixt ix)
{
    ix->i = (ix->i < ix->n)?ix->i + 1:ix->n;
}

static void ca_objvec_ix_prev(ca_objvec_ixt ix)
{
    ix->i = (0 <= ix->i)?ix->i - 1:-1;
}
@implementation ca_obj_vector : ca_vector

- check
{
    [super check];
    [scalarZero check];ca_objvec_check(&value,ca_objvec_getargs(self));
    return self;
}


- _setUpScalarZero:aScalarZero numScalars:(int)numScalars
{
    scalarZero = aScalarZero;
    ca_objvec_initcount(&value,numScalars,ca_objvec_getargs(self));
    assert([self check]);return self;
}

+ newScalarZero:aScalarZero numScalars:(int)numScalars
{
    return [[super new] _setUpScalarZero:aScalarZero numScalars:numScalars];
}

- copy
{
    ca_objvec_c c;assert([self check]);
    ca_objvec_copy(&c,&value,ca_objvec_getargs(self));
    return ca_objvec_c2id(self,&c);
}

- deepCopy
{
    ca_objvec_c c;assert([self check]);
    ca_objvec_deepcopy(&c,&value,ca_objvec_getargs(self));
    return ca_objvec_c2id(self,&c);
}

- clear
{
    scalarZero = [scalarZero free];
    ca_objvec_clear(&value,ca_objvec_getargs(self));
    return [super clear];
}

- (ca_objvec_t)ca_objvec_value
{
    return &value;
}

- ca_objvec_value:(ca_objvec_t)aValue
{
    self = [self clone];
    ca_objvec_copy(&value,aValue,ca_objvec_getargs(self));
    assert([self check]);return self;
}

- (ca_objvec_t)ca_objvec_reference
{
    return &value;
}

- ca_objvec_reference:(ca_objvec_c *)aReference
{
    self = [self clone];
    ca_objvec_move(&value,aReference,ca_objvec_getargs(self));
    assert([self check]);return self;
}

- clone
{
    self = [super clone];
    scalarZero = [scalarZero cheapCopy];
    return self;
}

- capacity:(int)aCapacity
{
    ca_objvec_c c;assert([self check]);
    ca_objvec_initcapacity(&c,aCapacity,ca_objvec_getargs(self));
    return ca_objvec_c2id(self,&c);
}

- numScalars:(int)numScalars
{
    ca_objvec_c c;assert([self check]);
    ca_objvec_initcount(&c,numScalars,ca_objvec_getargs(self));
    return ca_objvec_c2id(self,&c);
}


- scalarZero
{
    return scalarZero;
}

- (int) numScalars
{
    assert([self check]);return ca_objvec_count(&value);
}


- insertScalar:aScalar
{
    ca_obj_c c;
    assert([aScalar check]);[self checkRefCountOne];assert([self check]);
    ca_objvec_insertfirst(&value,ca_obj_id2ref(aScalar,&c),ca_objvec_getargs(self));
    assert([aScalar check]);[aScalar free];
    assert([self check]);[self invalidate];return self;
}

- insertScalar:aScalar at:(int)i
{
    ca_obj_c c;
    assert(aScalar);[self checkRefCountOne];assert([self check]);
    ca_objvec_insertat(&value,ca_obj_id2ref(aScalar,&c),i,ca_objvec_getargs(self));
    assert([aScalar check]);[aScalar free];
    assert([self check]);[self invalidate];return self;
}


- removeScalar
{
    if ([self numScalars]) {
	id res;
	ca_obj_t t = ca_objvec_first(&value,ca_objvec_getargs(self));
	assert([self check]);[self checkRefCountOne];
	res = ca_obj_t2id(scalarZero,t);
	ca_objvec_freefirst(&value,ca_objvec_getargs(self));
	assert([self check]);assert([res check]);[self invalidate];return res;
    } else {
	return nil;
    }
}

- removeScalarAt:(int)i
{
    id res;
    assert([self check]);[self checkRefCountOne];
    res = ca_obj_t2id(scalarZero,ca_objvec_at(&value,i,ca_objvec_getargs(self)));
    ca_objvec_freeat(&value,i,ca_objvec_getargs(self));
    assert([self check]);assert([res check]);[self invalidate];return res;
}


- placeScalar:aScalar at:(int)i
{
    ca_obj_c c;
    assert([aScalar check]);assert([self check]);[self checkRefCountOne];
    ca_objvec_place(&value,ca_obj_id2ref(aScalar,&c),i,ca_objvec_getargs(self));
    assert([aScalar check]);[aScalar free];
    assert([self check]);[self invalidate];return self;
}

- replaceScalarAt:(int)i with:aScalar
{
    id res;
    ca_obj_c c;
    ca_obj_t t = ca_objvec_at(&value,i,ca_objvec_getargs(self));
    assert([self check]);[self checkRefCountOne];
    res = ca_obj_t2id(scalarZero,t);
    ca_objvec_place(&value,ca_obj_id2ref(aScalar,&c),i,ca_objvec_getargs(self));
    assert([aScalar check]);[aScalar free];
    assert([self check]);assert([res check]);[self invalidate];return res;
}


- eachScalar
{
    id aSequence = [ca_objvec_sequence newContent:[self cheapCopy]];
    return [CASequenceClass newCarrier:aSequence];
}

- elt_ca_objvec_ix:(ca_objvec_ixt)ix
{
    if (ca_objvec_ix_ismatch(ix)) {
	ca_obj_t t = ca_objvec_elt(&value,ix,ca_objvec_getargs(self));
	return ca_obj_t2id(scalarZero,t);
    } else {
	return nil;
    }
}


- dotMultiply:b
{
    ca_obj_c c;	/* carrier for scalar */
    ca_objvec_oodotmul(&c,&value,[b ca_objvec_value],ca_objvec_getargs(self));
    /* now promote the carrier to object */
    /* all of this used to be very difficult in 0.6 */
    return ca_obj_c2id(scalarZero,&c);
}

- dotSquare
{
    ca_obj_c c;	/* carrier for scalar */
    ca_objvec_oodotsqr(&c,&value,ca_objvec_getargs(self));
    /* now promote the carrier to object */
    /* all of this used to be very difficult in 0.6 */
    return ca_obj_c2id(scalarZero,&c);
}


- fileOutOn:aFiler
{
    ca_objvec_args args;
    assert([self check]);
    [super fileOutOn:aFiler];
    args = ca_objvec_getargs(self);
    ca_objvec_args_fileOut(aFiler,&args);
    ca_objvec_fileOut(aFiler,&value,args);
    return self;
}

- fileInFrom:aFiler
{
    ca_objvec_args args;
    [super fileInFrom:aFiler];
    ca_objvec_args_fileIn(aFiler,&args);
    ca_objvec_fileIn(aFiler,&value,args);
    return self;
}

- (unsigned) hash
{
    return ca_objvec_hash(ca_objvec_id2t(self),ca_objvec_getargs(self));
}

- (BOOL) isEqual:b
{
    [self checkSameClass:b];
    if (self==b) {
    return YES;
    } else {
    return ca_objvec_iseq(ca_objvec_id2t(self),ca_objvec_id2t(b),ca_objvec_getargs(self));
    }
}

- (BOOL) notEqual:b
{
    [self checkSameClass:b];
    if (self==b) {
    return NO;
    } else {
    return !ca_objvec_iseq(ca_objvec_id2t(self),ca_objvec_id2t(b),ca_objvec_getargs(self));
    }
}

- (BOOL) isZero
{
    assert([self check]);
    return ca_objvec_iszero(ca_objvec_id2t(self),ca_objvec_getargs(self));
}

- (BOOL) notZero
{
    assert([self check]);
    return !ca_objvec_iszero(ca_objvec_id2t(self),ca_objvec_getargs(self));
}

- (BOOL) isOpposite:b
{
    assert([self checkSameClass:b] && self != b);
    return ca_objvec_isop(ca_objvec_id2t(self),ca_objvec_id2t(b),ca_objvec_getargs(self));
}

- (BOOL) notOpposite:b
{
    assert([self checkSameClass:b] && self != b);
    return !ca_objvec_isop(ca_objvec_id2t(self),ca_objvec_id2t(b),ca_objvec_getargs(self));
}

- negate
{
    ca_objvec_c c;assert([self check]);
    ca_objvec_ooneg(&c,ca_objvec_id2t(self),ca_objvec_getargs(self));
    return ca_objvec_c2id(self,&c);
}

- negateSelf
{
    if (refCount>1) return idReplace(self,[self negate]);
    assert([self check]);
    ca_objvec_inneg(ca_objvec_id2c(self),ca_objvec_getargs(self));
    return [self invalidate];
}

- _double:(int)v
{
    ca_objvec_c c;assert([self check]);
    ca_objvec_oodbl(&c,ca_objvec_id2t(self),v,ca_objvec_getargs(self));
    return ca_objvec_c2id(self,&c);
}

- _doubleSelf:(int)v
{
    if (refCount>1) return idReplace(self,[self _double:v]);
    assert([self check]);
    ca_objvec_indbl(ca_objvec_id2c(self),v,ca_objvec_getargs(self));
    return [self invalidate];
}

- double
{
    ca_objvec_c c;assert([self check]);
    ca_objvec_oodbl(&c,ca_objvec_id2t(self),+1,ca_objvec_getargs(self));
    return ca_objvec_c2id(self,&c);
}

- doubleSelf
{
    if (refCount>1) return idReplace(self,[self double]);
    assert([self check]);
    ca_objvec_indbl(ca_objvec_id2c(self),+1,ca_objvec_getargs(self));
    return [self invalidate];
}

- _add:(int)v:b:(int)w
{
    ca_objvec_c c;
    assert([self sameClass:b] && v*v == 1 && w*w == 1 && self != b);
    ca_objvec_ooadd(&c,ca_objvec_id2t(self),v,ca_objvec_id2t(b),w,ca_objvec_getargs(self));
    return ca_objvec_c2id(self,&c);
}

- _addSelf:(int)v:b:(int)w
{
    assert([self sameClass:b] && v*v == 1 && w*w == 1 && self != b);
    if (refCount>1) return idReplace(self,[self _add:v:b:w]);
    ca_objvec_inadd(ca_objvec_id2c(self),v,ca_objvec_id2t(b),w,ca_objvec_getargs(self));
    return [self invalidate];
}

- add:b
{
    ca_objvec_c c;
    assert([self checkSameClass:b] && self != b);
    ca_objvec_ooadd(&c,ca_objvec_id2t(self),+1,ca_objvec_id2t(b),+1,ca_objvec_getargs(self));
    return ca_objvec_c2id(self,&c);
}

- addSelf:b
{
    assert([self sameClass:b] && self != b);
    if (refCount>1) return idReplace(self,[self add:b]);
    ca_objvec_inadd(ca_objvec_id2c(self),+1,ca_objvec_id2t(b),+1,ca_objvec_getargs(self));
    return [self invalidate];
}

- subtract:b
{
    ca_objvec_c c;
    assert([self checkSameClass:b] && self != b);
    ca_objvec_ooadd(&c,ca_objvec_id2t(self),+1,ca_objvec_id2t(b),-1,ca_objvec_getargs(self));
    return ca_objvec_c2id(self,&c);
}

- subtractSelf:b
{
    assert([self sameClass:b] && self != b);
    if (refCount>1) return idReplace(self,[self subtract:b]);
    ca_objvec_inadd(ca_objvec_id2c(self),+1,ca_objvec_id2t(b),-1,ca_objvec_getargs(self));
    return [self invalidate];
}

- multiplyScalar:s
{
    ca_objvec_c c;
    ca_obj_c sc;
    ca_objvec_oomulsc(&c,ca_objvec_id2t(self),ca_obj_id2ref(s,&sc),ca_objvec_getargs(self));
    return ca_objvec_c2id(self,&c);
}

- multiplySelfScalar:s
{
    ca_obj_c sc;
    if (refCount>1) return idReplace(self,[self multiplyScalar:s]);
    ca_objvec_inmulsc(ca_objvec_id2c(self),ca_obj_id2ref(s,&sc),ca_objvec_getargs(self));
    return [self invalidate];
}

- divideScalar:s
{
    ca_objvec_c c;
    ca_obj_c sc;
    BOOL failed = ca_objvec_oodivsc(&c,ca_objvec_id2t(self),ca_obj_id2ref(s,&sc),ca_objvec_getargs(self));
    return (failed)?nil:ca_objvec_c2id(self,&c);
}

- divideSelfScalar:s
{
    ca_obj_c sc;
    if (refCount>1) return idReplace(self,[self divideScalar:s]);
    ca_objvec_indivsc(ca_objvec_id2c(self),ca_obj_id2ref(s,&sc),ca_objvec_getargs(self));
    return [self invalidate];
}

- _add:(int)v:B multiplyScalar:b:(int)w
{
    ca_objvec_c c;
    ca_obj_c bc;
    assert([self sameClass:B] && [scalarZero sameClass:b] && v*v == 1 && w*w == 1);
    ca_objvec_ooaddmulsc(&c,ca_objvec_id2t(self),v,ca_objvec_id2t(B),ca_obj_id2ref(b,&bc),w,ca_objvec_getargs(self));
    return ca_objvec_c2id(self,&c);
}

- _addSelf:(int)v:B multiplyScalar:b:(int)w
{
    ca_obj_c bc;
    if (refCount>1) return idReplace(self,[self _add:v:B multiplyScalar:b:w]);
    assert([self sameClass:B] && [scalarZero sameClass:b] && v*v == 1 && w*w == 1);
    ca_objvec_inaddmulsc(ca_objvec_id2c(self),v,ca_objvec_id2t(B),ca_obj_id2ref(b,&bc),w,ca_objvec_getargs(self));
    return [self invalidate];
}

- _multiplyScalar:a:(int)v add:B:(int)w
{
    ca_objvec_c c;
    ca_obj_c ac;
    assert([scalarZero sameClass:a] && [self sameClass:B] && v*v == 1 && w*w == 1);
    ca_objvec_oomulscadd(&c,ca_objvec_id2t(self),ca_obj_id2ref(a,&ac),v,ca_objvec_id2t(B),w,ca_objvec_getargs(self));
    return ca_objvec_c2id(self,&c);
}

- _multiplySelfScalar:a:(int)v add:B:(int)w
{
    ca_obj_c ac;
    if (refCount>1) return idReplace(self,[self _multiplyScalar:a:v add:B:w]);
    assert([scalarZero sameClass:a] && [self sameClass:B] && v*v == 1 && w*w == 1);
    ca_objvec_inmulscadd(ca_objvec_id2c(self),ca_obj_id2ref(a,&ac),v,ca_objvec_id2t(B),w,ca_objvec_getargs(self));
    return [self invalidate];
}

- _multiplyScalar:a:(int)v add:B multiplyScalar:b:(int)w
{
    ca_objvec_c c;
    ca_obj_c ac,bc;
    assert([scalarZero sameClass:a] && [self sameClass:B] && [scalarZero sameClass:b] && v*v == 1 && w*w == 1);
    ca_objvec_oomulscaddmulsc(&c,ca_objvec_id2t(self),ca_obj_id2ref(a,&ac),v,ca_objvec_id2t(B),ca_obj_id2ref(b,&bc),w,ca_objvec_getargs(self));
    return ca_objvec_c2id(self,&c);
}

- _multiplySelfScalar:a:(int)v add:B multiplyScalar:b:(int)w
{
    ca_obj_c ac,bc;
    if (refCount>1) return idReplace(self,[self _multiplyScalar:a:v add:B multiplyScalar:b:w]);
    assert([scalarZero sameClass:a] && [self sameClass:B] && [scalarZero sameClass:b] && v*v == 1 && w*w == 1);
    ca_objvec_inmulscaddmulsc(ca_objvec_id2c(self),ca_obj_id2ref(a,&ac),v,ca_objvec_id2t(B),ca_obj_id2ref(b,&bc),w,ca_objvec_getargs(self));
    return [self invalidate];
}
@end

