#include "cakit.h"

static void ca_objvec_ix_init(ca_objvec_ixt ix,id self)
{
    ca_objvec_t v = [self ca_objvec_value];
    ix->n = v->n;
}

static void ca_objvec_ix_copy(ca_objvec_ixt c,ca_objvec_ixt a)
{
    c->i = a->i;c->n = a->n;
}

static void ca_objvec_ix_clear(ca_objvec_ixt ix)
{
    /* nothing to clear */
}

static int ca_objvec_ix_count(ca_objvec_ixt ix)
{
    return ix->n;
}

static int ca_objvec_ix_isempty(ca_objvec_ixt ix)
{
    return ix->n == 0;
}

static int ca_objvec_ix_ismatch(ca_objvec_ixt ix)
{
    assert(-1 <= ix->i && ix->i <= ix->n);
    return 0 <= ix->i && ix->i < ix->n;
}

static void ca_objvec_ix_tofirst(ca_objvec_ixt ix)
{
    ix->i = -1;	/* next -> first */
}

static void ca_objvec_ix_tolast(ca_objvec_ixt ix)
{
    ix->i = ix->n; /* prev -> last */
}

static void ca_objvec_ix_to(ca_objvec_ixt ix,int i)
{
    /* the actual position is n-i-1; conversion done in elting routine... */
    if (i < 0) ix->i = -1;else if (i > ix->n) ix->i = ix->n;
    else ix->i = i-1; /* next -> at i */
}

static void ca_objvec_ix_next(ca_objvec_ixt ix)
{
    ix->i = (ix->i < ix->n)?ix->i + 1:ix->n;
}

static void ca_objvec_ix_prev(ca_objvec_ixt ix)
{
    ix->i = (0 <= ix->i)?ix->i - 1:-1;
}
@implementation ca_objvec_sequence : ca_sequence

- _setUpContent:anObject
{
    content = anObject;
    ca_objvec_ix_init(&ix,content);
    return self;
}

+ newContent:anObject
{
    return [[super new] _setUpContent:anObject];
}

- clear
{
    ca_objvec_ix_clear(&ix);
    content = [content free];
    if (currentMember) currentMember = [currentMember free];
    return [super clear];
}

- (int) numMembers
{
    return ca_objvec_ix_count(&ix);
}

- (BOOL) isEmpty
{
    return ca_objvec_ix_isempty(&ix);
}

- toFirstMember
{
    ca_objvec_ix_tofirst(&ix);
    return self;
}

- toLastMember
{
    ca_objvec_ix_tolast(&ix);
    return self;
}

- toMemberAt:(int)i
{
    ca_objvec_ix_to(&ix,i);
    return self;
}

- currentMember
{
    if (currentMember) currentMember = [currentMember free];
    return currentMember = [content elt_ca_objvec_ix:&ix];
}

- nextMember
{
    ca_objvec_ix_next(&ix);
    return [self currentMember];
}

- previousMember
{
    ca_objvec_ix_prev(&ix);
    return [self currentMember];
}

@end

