
/*
 * Computer Algebra Kit (c) 1993,95 by Comp.Alg.Objects.  All Rights Reserved.
 */

#include "cakit.h"

@implementation ca_recpolscalar_sequence
- _setUpContent:aPolynomial
{
    assert([aPolynomial isRecursive]);
    content = aPolynomial;eachTerm = [aPolynomial eachTerm];
    eachScalar = nil;return self;
}

+ newContent:aPolynomial
{
    return [[super new] _setUpContent:aPolynomial];
}

- clear
{
    content = [content free];
    eachTerm = [eachTerm free];
    if (eachScalar) eachScalar = [eachScalar free];
    return [super clear];
}

- toFirstMember
{
    if (eachScalar) eachScalar = [eachScalar free];
    [eachTerm toFirstMember];return self;
}

- toLastMember
{
    if (eachScalar) eachScalar = [eachScalar free];
    [eachTerm toLastMember];return self;
}

- (BOOL) isEmpty
{
    return [eachTerm isEmpty];
}

- (int) numMembers
{
    [self notImplemented:_cmd]; return 0;
}

- toMemberAt:(int)i
{
    [self notImplemented:_cmd]; return self;
}

- nextMember
{
    id nextMember;
    
    if (eachScalar) {
	if (nextMember = [eachScalar nextMember]) return nextMember;
	eachScalar = [eachScalar free];
    }
    
    if (nextMember = [eachTerm nextMember]) {
	id c = [nextMember coefficient];
	if ([c sameClass:[content scalarZero]]) {
	    return c;
	} else {
	    eachScalar = [[c eachScalar] toFirstMember];
	    return [self nextMember];
	}
    } else {
	return nil;
    }
}

- previousMember
{
    id prevMember;
    
    if (eachScalar) {
	if (prevMember = [eachScalar previousMember]) return prevMember;
	eachScalar = [eachScalar free];
    }
    
    if (prevMember = [eachTerm previousMember]) {
	id c = [prevMember coefficient];
	if ([c sameClass:[content scalarZero]]) {
	    return c;
	} else {
	    eachScalar = [[c eachScalar] toLastMember];
	    return [self previousMember];
	}
    } else {
	return nil;
    }
}

@end

