
/*
 * Computer Algebra Kit (c) 1993,97 by Comp.Alg.Objects.  All Rights Reserved.
 */

#ifndef __CATERM_HEADER__
#define __CATERM_HEADER__

#include "cobject.h"

typedef int ca_unimonom_t;
typedef int ca_unimonom_c;
typedef unsigned ca_unimonom_args; /* unused */

#define ca_unimonom_isvalue	1
#define ca_unimonom_pervalue	1

@interface Term : CAObject
{
    id		scalarZero;
    id		coefficient;
    id		symbol;
    int		exponent;	
}
- check;

- _setUpScalarZero:aZero coefficient:aCoefficient symbol:aSymbol exponent:(int)anExponent;
- newScalarZero:aScalar coefficient:aCoefficient symbol:aSymbol exponent:(int)anExponent;
+ newScalarZero:aZero coefficient:aCoefficient symbol:aSymbol exponent:(int)anExponent;
- newScalar:aScalar symbol:aSymbol exponent:(int)anExponent;
+ newScalar:aScalar symbol:aSymbol exponent:(int)anExponent;
- newCoefficient:aCoefficient symbol:aSymbol exponent:(int)anExponent;
+ newCoefficient:aCoefficient symbol:aSymbol exponent:(int)anExponent;
- copy;
- deepCopy;
- clone;
- clear;
- coefficient:aCoefficient symbol:aSymbol exponent:(int)anExponent;
- coefficient:aCoefficient exponent:(int)anExponent;
- coefficient:aCoefficient;
- symbol:aSymbol exponent:(int)anExponent;

- addSymbolsTo:aCltn;
- scalarZero;
- coefficient;
- (BOOL) isCoefficient;
- symbol;
- (int) exponent;
- (int) degree;
- (unsigned) hash;
- (BOOL) isEqual:b;
- (int) compareSymbols:aTerm;
- (int) compareExponents:b;

- (int) intValue;
- intValue:(int)aValue;
- (float) floatValue;
- floatValue:(float)aValue;
- asScalar;
- scalar:aScalar;
- asSymbol;
- symbol:aSymbol;
- asNumerical;
- asModp:(unsigned short)p;

- zero;
- (BOOL) isZero;
- (BOOL) isOpposite:b;
- negate;
- double;
- add:b;
- subtract:b;

- one;
- (BOOL) isOne;
- (BOOL) isMinusOne;
- square;
- inverse;
- multiplyScalar:b;
- multiplyCoefficient:b;
- varspsMultiplyCoefficient:b;
- multiply:b;
- divideScalar:b;
- divideCoefficient:b;
- varspsDivideCoefficient:b;
- subtractExponents:b;
- divide:b;

- power:(int)n;
- root:(int)n;
- squareRoot;

- frobenius;
- frobeniusInverse;

- derive;
- integrate;
- substitute:(STR)aSymbol by:aPolynomial;
- makeDegreeDense;
- makeDegreeSparse;
- changeRepresentationTo:aPrototype;
- makeVariableSparse;

- powerAsExpression;
- asExpression;

- (BOOL) printsLeadingSign;
- (BOOL) printsSum;
- (BOOL) printsProduct;
- printToFile:(FILE *)aFile;

- fileOutOn:aFiler;
- fileInFrom:aFiler;
@end

#endif /* __CATERM_HEADER__ */

