
/*
 * Portable Object Compiler (c) 1996, 97 by Stes & Lerman.
 * All Rights Reserved.
 */

#include "objc1.h"
#include "yacc.h" /* different for C++ */

/*
 * TokenName function for C lexical scanner.
 */

char *tokenName(int token)
{
	switch(token) {
		case AUTO_TOKEN : return "auto";
		case BREAK_TOKEN : return "break";
		case CASE_TOKEN : return "case";
		case CHAR_TOKEN : return "char";
		case CONTINUE_TOKEN : return "continue";
		case DEFAULT_TOKEN : return "default";
		case DO_TOKEN : return "do";
		case DOUBLE_TOKEN : return "double";
		case ELSE_TOKEN : return "else";
		case ENUM_TOKEN : return "enum";
		case EXTERN_TOKEN : return "extern";
		case FLOAT_TOKEN : return "float";
		case FOR_TOKEN : return "for";
		case GOTO_TOKEN : return "goto";
		case IF_TOKEN : return "if";
		case INT_TOKEN : return "int";
		case LONG_TOKEN : return "long";
		case REGISTER_TOKEN : return "register";
		case RETURN_TOKEN : return "return";
		case SHORT_TOKEN : return "short";
		case SIZEOF_TOKEN : return "sizeof";
		case STATIC_TOKEN : return "static";
		case STRUCT_TOKEN : return "struct";
		case SWITCH_TOKEN : return "switch";
		case TYPEDEF_TOKEN : return "typedef";
		case UNION_TOKEN : return "union";
		case UNSIGNED_TOKEN : return "unsigned";
		case VOID_TOKEN : return "void";
		case WHILE_TOKEN : return "while";
		
		case SIGNED_TOKEN : return 	"signed";
		
		case ATDEFS_TOKEN : return "@defs";
		case ATSELECTOR_TOKEN : return "@selector";
		case ATEND_TOKEN : return "@end";
		case ATENCODE_TOKEN : return "@encode";
		case ID_TOKEN : return "id";
		
		case INLINE_TOKEN : return "inline";
		
		case ASM_TOKEN : return "asm";
		
		case __SIGNED___TOKEN : return "__signed__";
		case __UNSIGNED___TOKEN : return "__unsigned__";
		case __ATTRIBUTE___TOKEN : return "__attribute__";
		case __ASM_TOKEN : return "__asm";
		case __ASM___TOKEN  : return "__asm__";
		case __INLINE___TOKEN : return "__inline__";
		case __INLINE_TOKEN : return "__inline";
		case __EXTENSION___TOKEN : return 	"__extension__";
		
		case LPAREN_TOKEN : return "(";
		case RPAREN_TOKEN : return ")";
		case LBRACK_TOKEN : return "[";
		case RBRACK_TOKEN : return "]";
		case ARROW_TOKEN : return "->";
		case DOT_TOKEN : return ".";
		case NOT_TOKEN : return "!";
		case COMPL_TOKEN : return "~";
		case INCR_TOKEN : return "++";
		case DECR_TOKEN : return "--";
		case MUL_TOKEN : return "*";
		case DIV_TOKEN : return "/";
		case MOD_TOKEN : return "%";
		case PLUS_TOKEN : return "+";
		case MINUS_TOKEN : return "-";
		case SHIFTL_TOKEN : return "<<";
		case SHIFTR_TOKEN : return ">>";
		case EQ_TOKEN : return "==";
		case AND_TOKEN : return "&";
		case XOR_TOKEN : return "^";
		case OR_TOKEN : return "|";
		case LOGAND_TOKEN : return "&&";
		case LOGOR_TOKEN : return "||";
		case QUEST_TOKEN : return "?";
		case COLON_TOKEN : return ":";
		case ASSIGN_TOKEN : return "=";
		case COMMA_TOKEN : return ",";
		case SEMI_TOKEN  : return ";";
		case LBRACE_TOKEN : return "{";
		case RBRACE_TOKEN : return "}";
		case ELLIPSIS_TOKEN : return "...";
		
		case IDENTIFIER_TOKEN : return "IDENTIFIER_TOKEN";
		case STRING_TOKEN : return "STRING_TOKEN";
		case CONSTANT_TOKEN : return "CONSTANT_TOKEN";
		case BUILTINFUNCTION_TOKEN : return "BUILTINFUNCTION_TOKEN";
	}

	return NULL;
}
