
/*
 * Portable Object Compiler (c) 1996, 97 by Stes & Lerman.  All Rights Reserved.
 */

#ifdef __PORTABLE_OBJC__

#ifndef __OBJECT_H__
#define __OBJECT_H__

#include "objcrt.h"

#define __objcrt_revision__ "1.8.1"

@interface Object
{
	id isa;
	unsigned short attr;  /* compatibility Stepstone */
	unsigned short objID; /* compatibility Stepstone */
}

+ initialize;
+ subclasses;
+ poseAs:superClass;
+ addMethodsTo:superClass;
+ subclass:(STR)name;
+ inheritsFrom:aClass;
- initialize;

+ new;
- new;
- copy;
- deepCopy;
- free;
+ free;

- self;
- yourself;
- class;
- superclass;
+ class;
+ superclass;
- add:anObject;
- (STR) name;
+ (STR) name;
- findClass:(STR)aClassName;
- (SEL) selOfSTR:(STR)aSelName;
- idOfSTR:(STR)aClassName;

- (unsigned) hash;
- (BOOL) isEqual:anObject;
- idEqual:anObject;
+ (BOOL) isEqual:anObject;
- (BOOL) isSame:anObject;
- (BOOL) notEqual:anObject;
- (BOOL) notSame:anObject;
- (int) compare:anObject;

- (BOOL) respondsTo:(SEL)aSelector;
- (BOOL) isMemberOf:aClass;
- (BOOL) isKindOf:aClass;

- (BOOL) isTrue;
- (BOOL) isFalse;
- ifTrue:aBlock;
- ifTrue:trueBlock ifFalse:falseBlock;
- ifFalse:aBlock;
- ifFalse:falseBlock ifTrue:trueBlock;

- subclassResponsibility:(SEL)aSelector;
- subclassResponsibility;
- shouldNotImplement:(SEL)aSelector from:superClass;
- notImplemented:(SEL)aSelector;
- doesNotRecognize:(SEL)aSelector;
- doesNotUnderstand:(SEL)aSelector;
- error:(STR)format,...;

- (IMP) methodFor:(SEL)aSelector;
+ (IMP) instanceMethodFor:(SEL)aSelector;

- perform:(SEL)aSelector;
- perform:(SEL)aSelector with:anObject;
- perform:(SEL)aSelector with:anObject with:otherObject;
- perform:(SEL)aSelector with:anObject with:otherObject with:thirdObj;

- print;
+ print;
- printLine;
- show;
- printToFile:(FILE *)aFile;

#ifdef __STPSTN__
- printOn:(IOD)anIOD;
#else
- printOn:(FILE *)anIOD;
#endif /* __STPSTN__ */


+ (STR) objcrtRevision;

+ readFrom:(STR)aFileName;
- (BOOL) storeOn:(STR)aFileName;

/* compiler generated */
- fileOutIdsFor:aFiler;
- fileInIdsFrom:aFiler;

/* compile without including AsciiFiler */
- fileOut:(void *)value type:(char)typeDesc;
- fileIn:(void *)value type:(char)typeDesc;

- fileOutOn:aFiler;
+ fileInFrom:aFiler;
- fileInFrom:aFiler;
- awake;
- awakeFrom:aFiler;

@end

#endif /* __OBJECT_H__ */

#endif /* __PORTABLE_OBJC__ */


