
/*
 * Portable Object Compiler (c) 1996 by Stes & Lerman.  All Rights Reserved.
 */

#include "objpak.h"

@implementation Assoc

/*****************************************************************************
 *
 * Creation
 *
 ****************************************************************************/

- setUpKey:aKey value:aValue
{
    key = aKey;
    value = aValue;
    return self;
}

+ key:aKey
{
    return [self key:aKey value:nil];
}

+ key:aKey value:aValue
{
    id newObj = [super new];
    [newObj setUpKey:aKey value:aValue];
    return newObj;
}

/*****************************************************************************
 *
 * Interrogation
 *
 ****************************************************************************/

- key
{
    return key;
}

- (STR) str
{ 
    return [key str]; 
}

- value
{
    return value;
}

/*****************************************************************************
 *
 * Comparison
 *
 ****************************************************************************/

- (unsigned) hash
{
    return [key hash];
}

- (BOOL) isEqual:anAssoc
{
    return (self == anAssoc)?YES:[key isEqual:[anAssoc key]];
}

- (int) compare:anAssoc
{
    return [key compare:[anAssoc key]];
}

/*****************************************************************************
 *
 * Assignment
 *
 ****************************************************************************/

- value:aValue
{
    id tmp = value; value = aValue; return tmp; 
}

/*****************************************************************************
 *
 * Printing
 *
 ****************************************************************************/

- printToFile:(FILE *)aFile
{
    [key printToFile:aFile];fprintf(aFile,"\t");[value printToFile:aFile];
    return self;
}

@end

