
/*
 * Portable Object Compiler (c) 1996 by Stes & Lerman.  All Rights Reserved.
 */

#ifndef __OBJSTR_H__
#define __OBJSTR_H__

#include "array.h"

typedef struct objstr {
    int		count;
    int		capacity;
    char*	ptr;
} *objstr_t;

@interface String : Array
{
    struct objstr	value;
}

+ new;
+ new:(unsigned)nChars;
+ str:(STR)strValue;
+ chars:(STR)strValue count:(int)n;
+ sprintf:(STR)format,...;
- copy;
- deepCopy;
- free;

- (int) compare:aStr;
- (int) compareSTR:(STR)strValue;
- (unsigned) hash;
- (int) dictCompare:aStr;
- (BOOL) isEqual:aStr;
- (BOOL) isEqualSTR:(STR)strValue;
- idEqualSTR:(STR)strValue;

- (objstr_t) objstrValue;
- (unsigned) size;
- (char) charAt:(unsigned)anOffset;
- (char) charAt:(unsigned)anOffset put:(char)aChar;

- (STR) strcat:(STR)aBuffer;
- concatSTR:(STR)strValue;
- concatenateSTR:(STR)aString;
- assignSTR:(STR)strValue;
- assignSTR:(STR)strValue length:(unsigned)nChars;

- (double) asDouble;
- (int) asInt;
- (long) asLong;
- asSTR:(STR)aBuffer maxSize:(int)aSize;
- (STR) str;
- (STR) strCopy;

- toLower;
- toUpper;

- printToFile:(FILE *)aFile;

#ifdef __PORTABLE_OBJC__
- fileOutOn:aFiler;
- fileInFrom:aFiler;
#endif /* __PORTABLE_OBJC__ */

@end

#endif /* __OBJSTR_H__ */

