
/*
 * Portable Object Compiler (c) 1997,98 by Stes & Lerman.  All Rights Reserved.
 */

#ifndef __OBJCLTN_H__
#define __OBJCLTN_H__

#include "cltn.h"

/* the name of this class in older versions of objpak */
#define Collection OrdCltn
/* full name */
#define OrderedCollection OrdCltn

typedef struct objcol {
    int		count;
    int		capacity;
    id*		ptr;
} *objcol_t;

@interface OrdCltn : Cltn
{
    struct objcol	value;
}

+ new;
+ new:(unsigned)n;
+ with:(int)nArgs,...;
+ with:firstObject with:nextObject;
+ add:firstObject;
- copy;
- deepCopy;
- emptyYourself;
- freeContents;
- free;

- (objcol_t) objcolValue;
- (unsigned) size;
- (BOOL) isEmpty;
- idEmpty;
- (unsigned) lastOffset;
- eachElement;
- firstElement;
- lastElement;

- (unsigned) hash;
- (BOOL) isEqual:aCltn;

- add:anObject;
- addYourself;
- addFirst:newObject;
- addLast:newObject;
- addIfAbsent:anObject;
- addIfAbsentMatching:anObject;

- boundsError:(unsigned)i in:(SEL)aSelector;
- at:(unsigned )anOffset insert:anObject;
- couldntFind:anObject in:(SEL)aSelector;
- insert:newObject after:oldObject;
- insert:newObject before:oldObject;

- after:anObject;
- before:anObject;
- at:(unsigned )anOffset;
- at:(unsigned )anOffset put:anObject;

- removeFirst;
- removeLast;
- removeAt:(unsigned )anOffset;
- removeAtIndex:(unsigned )anOffset;
- remove:oldObject;
- remove:oldObject ifAbsent:exceptionBlock;

- (BOOL) includesAllOf:aCol;
- (BOOL) includesAnyOf:aCol;

- addContentsTo:aCol;
- addContentsOf:aCol;
- addAll:aCol;
- removeContentsOf:aCol;
- removeContentsFrom:aCol;
- removeAll:aCol;

- asSet;
- asOrdCltn;

- do:aBlock;
- detect:aBlock;
- detect:aBlock ifNone:noneBlock;
- select:testBlock;
- reject:testBlock;
- collect:transformBlock;
- (unsigned) count:aBlock;

- elementsPerform:(SEL)aSelector;
- elementsPerform:(SEL)aSelector with:anObject;
- elementsPerform:(SEL)aSelector with:anObject with:otherObject;
- elementsPerform:(SEL)aSelector with:anObject with:otherObject with:thirdObj;

- find:anObject;
- findMatching:anObject;
- (BOOL) includes:anObject;
- findSTR:(STR )strValue;
- (BOOL) contains:anObject;
- (unsigned) offsetOf:anObject;

- printToFile:(FILE *)aFile;
- reverseDo:aBlock;

#ifdef __PORTABLE_OBJC__
- fileOutOn:aFiler;
- fileInFrom:aFiler;
#endif /* __PORTABLE_OBJC__ */

@end

#endif /* __OBJCLTN_H__ */

