
/*
 * Portable Object Compiler (c) 1997,98 by Stes & Lerman.  All Rights Reserved.
 */

#include "objpak.h"

@implementation Sequence
/*****************************************************************************
 *
 * Creation
 *
 ****************************************************************************/

- setUpCarrier:aCarrier
{
    carrier = aCarrier;return self;
}

+ over:aCarrier
{
    id newObj = [super new];[newObj setUpCarrier:aCarrier];return newObj;
}

- over:aCarrier
{
	return [self notImplemented:_cmd];
}

- copy
{
    return [isa over:[carrier copy]];
}

- free
{
    carrier = [carrier free];return [super free];
}

/*****************************************************************************
 *
 * Interrogation
 *
 ****************************************************************************/

- (unsigned) size
{
    return [carrier size];
}

/*****************************************************************************
 *
 * Accessing
 *
 ****************************************************************************/

- next
{
    return [carrier next];
}

- peek
{
    return [carrier peek];
}

- previous
{
    return [carrier previous];
}

- first
{
    return [carrier first];
}

- last
{
    return [carrier last];
}

/*****************************************************************************
 *
 * Printing
 *
 ****************************************************************************/

- printToFile:(FILE *)aFile
{
    id aMember;
    while ((aMember = [self next])) {
	[aMember printToFile:aFile];fprintf(aFile,"\n");
    }
    return self;
}

/*****************************************************************************
 *
 * Performing
 *
 ****************************************************************************/

- do:aBlock
{
    id aMember;
    while ((aMember = [self next])) [aBlock value:aMember];
    return self;
}

@end

