
/*
 * Portable Object Compiler (c) 1996 by Stes & Lerman.  All Rights Reserved.
 */

#include "objpak.h"

@implementation TreeSequence
static objbbt_t objbbt_first(objbbt_t p)
{
    while (p->llink) p = p->llink;
    return p;
}

static objbbt_t objbbt_last(objbbt_t p)
{
    while (p->rlink) p = p->rlink;
    return p;
}

- setUpSort:aSort
{
    top    = [aSort objbbtTop];
    prev   = NULL;
    next   = (top)?objbbt_first(top):NULL;
    return self;
}

+ over:aSort
{
    id newObj = [super new];[newObj setUpSort:aSort];return newObj;
}

- copy
{
    return [super copy];
}

- free
{
    return [super free];
}

static int objbbt_size(objbbt_t self)
{
    int size = 1;
    if (self->llink) size += objbbt_size(self->llink);
    if (self->rlink) size += objbbt_size(self->rlink);
    return size;
}

- (unsigned) size
{
    return (top)?objbbt_size(top):0;
}

static objbbt_t objbbt_nextulink(objbbt_t p,objbbt_t top)
{
    while (p != top) {
	objbbt_t ulink;
	ulink = p->ulink;
	if (p == ulink->llink) return ulink;
	p = ulink;
    }
    
    return NULL;
}

static objbbt_t objbbt_next(objbbt_t p,objbbt_t top)
{
    objbbt_t link;

    if ((link = p->rlink)) {
	return objbbt_first(link);
    } else {
	return objbbt_nextulink(p,top);
    }
}

- next
{
    if (next) {
	prev = next;
	next = objbbt_next(next,top);
	return prev->key;
    } else {
	return nil;
    }
}

- peek
{
    return (next)?next->key:nil;
}

- previous
{
    return (prev)?prev->key:nil;
}

- first
{
    if (top) {
	objbbt_t first = objbbt_first(top);return first->key;
    } else {
	return nil;
    }
}

- last
{
    if (top) {
	objbbt_t last = objbbt_last(top);return last->key;
    } else {
	return nil;
    }
}

@end

