
/*
 * Portable Object Compiler (c) 1997 by Stes & Lerman  All Rights Reserved.
 */

#ifndef __CLASSDEFINITION_H__
#define __CLASSDEFINITION_H__

@interface ClassDefinition : Node
{
	BOOL prologueEmitted;
	BOOL isImplementation;
	BOOL interfaceEmitted;
	BOOL isCategory;
	id	name; /* for category Object (MyObject), this is MyObject */
	id	superName; /* for category , this is Object */
	id	setOfIVars;
	id	setOfCVars;
	id	setOfITypes;
	id      setOfCTypes;
	id	setOfFMethods;
	id	setOfIMethods;
	id	ivarNodes;
	id	completeSetOfIvars;
	id      setOfIdIVars;
	id	cvarNodes;
	id	completeSetOfCvars;
	id      setOfIdCVars;
	id	interface;
	id	clsDispatchTable;
	id	nstDispatchTable;
}

- free;

+ findInterface:aName;
- addInterface;

- idName;
- (BOOL) isImplementationToken;
- (BOOL) isInterfaceToken;
- processName:myName superName:hisName;
- superName;
- (BOOL) isCategory;
- setIsCategory:(BOOL)flag;
+ declareIvar:aNode Itype:bNode;
- completeSetOfIvars;
- completeSetOfCvars;
+ (BOOL) inMethodImplementation;
+ (BOOL) doesCurrentSetOfIVarsContain:anIdentifier;
+ (BOOL) doesCurrentSetOfCVarsContain:anIdentifier;
- processVars;
- superInterface;
- rootInterface;
- rootName;
+ collectIvarNodes:aNode;
+ collectCvarNodes:aNode;
- makeCurrent;
- setOfIVars;
- setOfCVars;
- setOfIdIVars;
- ivarNodes;
- cvarNodes;
- clearCurrent;
- outputIVarsCommentOn:aStream;

- outputIvarNodesOn:aStream;
- outputCvarNodesOn:aStream;
- (STR) classGlobalFun;
- (STR) classStructFun;
- (STR) metaStructFun;
- outputExternClassGlobalOn:aStream;
- translateInterfaceOn:aStream;

- setIsImplementation:(BOOL)flag;
+ checkForPendingDefinitions;
+ new;
+ end;
+ currentName;
+ current;

- addClsDispatchTable:aMethod;
- addNstDispatchTable:aMethod;
- doModuleDefinitions;

- (STR) structPrivateName;
- outputStructPrivateTypeOn:aStream;
- (STR) structSharedName;
- outputStructSharedTypeOn:aStream;
- (STR) _clsDispatchTblName;
- (STR) _nstDispatchTblName;
- outputClsDispatchTablesOn:aStream;
- outputNstDispatchTablesOn:aStream;
- outputDispatchTablesOn:aStream;
- outputStructSharedClassOn:aStream;
- outputStructSharedMetaClassOn:aStream;
- outputClassGlobalFunCallsOn:aStream;
- translatePrologueOn:aStream;
- outputSuperMessage:aSel argument:(STR)argName on:aStream;
- outputSuperFileOutMessageOn:aStream;
- outputSuperFileInMessageOn:aStream;
- outputFilerMessage:aSel ivar:ivar on:aStream;
- outputFileOutMessage:ivar on:aStream;
- outputFileInMessage:ivar on:aStream;
- outputFileOutCodeOn:aStream;
- outputFileInCodeOn:aStream;
- outputFilerCodeOn:aStream;
- outputAssignClassGlobalOn:aStream;
- translateEpilogueOn:aStream;
- makeSetOfIVarsCurrent;
- clearCurrentSetOfIVars;
- willTranslateMethodImplementationOn:aStream;
- translateOn:aStream;
@end

#endif /* __CLASSDEFINITION_H__ */
