
/*
 * Portable Object Compiler (c) 1996 by Stes & Lerman  All Rights Reserved.
 */

#include "oclib.h"
#include "assert.h"

@implementation MethodDeclarator

- free
{
    return nil;
}

- setIsFactory:(BOOL)flag
{
	isFactory = flag;return self;
}

- (BOOL) isFactory
{
	return isFactory;
}

- setResultType:aNode
{
	resultType = aNode;return self;
}

- setSelector:aNode
{
	selector = aNode;return self;
}

- setEllipsis:aToken
{
	ellipsis = aToken;return self;
}


- processMethod
{
	id aMethod = [MethodInfo new];

	assert(selector);[selector processForMethod:aMethod];
	if (ellipsis) [aMethod addEllipsis:ellipsis];
	if (resultType) [aMethod setResultType:resultType];
	[aMethod setIsFactory:isFactory];

	return aMethod;
}

- method
{
	if (!method) method = [self processMethod];
	return method;
}

- addLocalsTo:aCompound
{
    [method addLocalsTo:aCompound];
    return self;
}


- outputCommentOn:aStream
{
	[aStream printNewline];
	[aStream printNewline];
	[aStream printStr:"/*\n"];
	[aStream printStr:" * "];
	[self outputWithoutTagsOn:aStream];
	[aStream printStr:"\n */\n"];
	[aStream printNewline];
	return self;
}

- outputOn:aStream
{
	[aStream printStr:(isFactory)?"+":"-"];
	return [super outputOn:aStream];
}

- translateOn:aStream
{
	if ([options comments]) [self outputCommentOn:aStream];

	/* force computation of method */
	[[self method] outputFunctionPrototypeOn:aStream];

	[LineTag forceLineTag];
	return self;
}

@end

