
/*
 * Portable Object Compiler (c) 1996 by Stes & Lerman  All Rights Reserved.
 */

#ifndef __METHODINFO_H__
#define __METHODINFO_H__

@interface MethodInfo : Object
{
	BOOL	isFactory;	/* for prototype only  */
	id	name;
	id	resultType;	/* for prototype only  */
	id	argumentTypes;	/* for prototype only  */
	id	arguments;	/* in messageArguments */
	id 	ellipsis;	/* optional ... */
}


- free;
- prototype;
- implement;
+ findPrototypeFor:aName;
- argumentsDefaultToId;
+ findOrWarnPrototype:aMethod;

- (BOOL) isEqual:aMethod;

- fullMethodName;
- functionNameForClass:aClassName;
- setIsFactory:(BOOL)flag;
- (BOOL) isFactory;
- setResultType:aNode;
- addNameComponent:aString;
- addColonToName;
- addEllipsis:aToken;
- addArgumentType:aNode;
- addIdArgumentType;
- addArgument:aNode;
- checkForMethodWith;

- stdMsgArgs;
- stdMsgTypes;
- addLocalsTo:aCompound;

- outputResultTypeOn:aStream;
- outputCastOn:aStream;
- outputArgumentTypesOn:aStream;
- outputArgumentProtosOn:aStream;
- translateArgumentsOn:aStream;
- outputFunctionPrototypeOn:aStream;
@end

#endif /* __METHODINFO_H__ */
