
/*
 * Portable Object Compiler (c) 1996 by Stes & Lerman  All Rights Reserved.
 */

#ifndef __OPTIONS_H__
#define __OPTIONS_H__

extern id options; /* global keeping compiler invocation options */

@interface Options : Object
{
	BOOL	quiet;
	BOOL	version;
	BOOL	outputCode;
	BOOL	translateCode;
	BOOL	outputObjc;
	BOOL	sharedData;
	id	inFile;
	id	outFile;
	id	srcFileName;
	id	lineTagFormat;
	id	initCall;
	id      mainFunction;
	STR	pathSeparator;
	BOOL	doSelTransTbl;
	BOOL	inlineCache;
	BOOL	lineTags;
	BOOL	postLink;
	BOOL    checkBindCalled;
	BOOL	warnClassUsedAsType;
	BOOL	warnUndefinedMethod;
	BOOL    warnInterfaceNotFound;
	BOOL    warnLocalInstance;
	BOOL	isBuffered;
	BOOL	comments;
	BOOL	gnu;
	BOOL	asmKeyword;
	BOOL	llKeyword;
	BOOL	msdos;
	BOOL	watcom;
	BOOL	cplus;
	BOOL 	debugInfo;
	BOOL 	ppi;
	BOOL	onePerFile;
	BOOL	cthreads;
	BOOL	pthreads;
	BOOL	boehm;
	BOOL	blocks;
	BOOL	filerCode;
	id	bind;
	int     lineMax;
	BOOL	ibmvac;
	BOOL    warnLex;
	BOOL    cache;
	BOOL    nilRcvr; 
	BOOL    selfAssign;
	BOOL    cats;
	BOOL	refBind;
}

+ new;

- setLineMax:(int)flag;
- (int) lineMax;
- setCats:(BOOL)flag;
- (BOOL) cats;
- setSelfAssign:(BOOL)flag;
- (BOOL) selfAssign;
- setRefBind:(BOOL)flag;
- (BOOL) refBind;
- setNilRcvr:(BOOL)flag;
- (BOOL) nilRcvr;
- setCache:(BOOL)flag;
- (BOOL) cache;
- setBind:arg;
- bind;
- setFilerCode:(BOOL)flag;
- (BOOL) filerCode;
- setBlocks:(BOOL)flag;
- (BOOL) blocks;
- setPthreads:(BOOL)flag;
- (BOOL) pthreads;
- setCthreads:(BOOL)flag;
- (BOOL) cthreads;
- setBoehm:(BOOL)flag;
- (BOOL) boehm;
- setLLKeyword:(BOOL)flag;
- (BOOL) llKeyword;
- setAsmKeyword:(BOOL)flag;
- (BOOL) asmKeyword;
- setOnePerFile:(BOOL)flag;
- (BOOL) onePerFile;
- setQuiet:(BOOL)flag;
- (BOOL) quiet;
- setPathSeparator:(STR)aSep;
- (STR) pathSeparator;
- setPPI:(BOOL)flag;
- (BOOL) ppi;
- setDebugInfo:(BOOL)flag;
- (BOOL) debugInfo;
- setCplus:(BOOL)flag;
- (BOOL) cplus;
- setMSDOS:(BOOL)flag;
- (BOOL) msdos;
- setWATCOM:(BOOL)flag;
- (BOOL) watcom;
- setIBMVAC:(BOOL)flag;
- (BOOL) ibmvac;
- setGNU:(BOOL)flag;
- (BOOL) gnu;
- setComments:(BOOL)flag;
- (BOOL) comments;
- setOutputCode:(BOOL)flag;
- (BOOL) outputCode;
- setDoSelTransTbl:(BOOL)flag;
- (BOOL) doSelTransTbl;
- setTranslateCode:(BOOL)flag;
- (BOOL) translateCode;
- setBuffered:(BOOL)flag;
- (BOOL) isBuffered;
- setLineTags:(BOOL)flag;
- (BOOL) lineTags;
- setSharedData:(BOOL)flag;
- (BOOL) sharedData;
- setVersion:(BOOL)flag;
- (BOOL) version;
- setInlineCache:(BOOL)flag;
- (BOOL) inlineCache;
- setWarnLex:(BOOL)flag;
- (BOOL) warnLex;
- setWarnClassUsedAsType:(BOOL)flag;
- (BOOL) warnClassUsedAsType;
- setWarnInterfaceNotFound:(BOOL)flag;
- (BOOL) warnInterfaceNotFound;
- setWarnLocalInstance:(BOOL)flag;
- (BOOL) warnLocalInstance;
- setWarnUndefinedMethod:(BOOL)flag;
- (BOOL) warnUndefinedMethod;
- setCheckBindCalled:(BOOL)flag;
- (BOOL) checkBindCalled;
- setPostLink:(BOOL)flag;
- (BOOL) postLink;
- setInFile:aString;
- inFile;
- setSrcFileName:aString;
- srcFileName;
- setOutFile:aString;
- outFile;
- setLineTagFormat:aString;
- lineTagFormat;
- setInitCall:aString;
- initCall;
- setMainFunction:aString;
- mainFunction;
@end

#endif /* __OPTIONS_H__ */

