
/*
 * Portable Object Compiler (c) 1996 by Stes & Lerman  All Rights Reserved.
 */

#include "oclib.h"

@implementation Token

/*****************************************************************************
 *
 * Creation
 *
 ****************************************************************************/


- setUp:(STR)aToken
{
	token = aToken;
	lineTag = [LineTag currentTag];
	return self;
}

- lineTag
{
    return lineTag;
}

+ newToken:(STR)aToken
{
	return [[super new] setUp:aToken];
}

+ str:(STR)aToken
{
	id s = [String str:aToken];
	return [[super new] setUp:[s str]];
}

- free
{
    return nil;
}



- outputOn:stream
{
	[LineTag outputOn:stream until:lineTag];
	[stream printToken:token];
	return self;
}

- outputWithoutTagsOn:stream
{
	[stream printToken:" "];
	[stream printToken:token];
	return self;
}

- outputLineTagOn:stream
{
	[LineTag outputOn:stream until:lineTag];
	return self;
}


- (STR) str
{
    return token;
}

- (BOOL) isEqual:aToken
{
    return (isa == [aToken class] && strcmp(token,[aToken str]) == 0);
}

- (BOOL) isEqualSTR:(STR)s
{
    return strcmp(token,s) == 0;
}

- (BOOL) containsTypedef
{
	return strcmp(token,"typedef") == 0;
}

- (BOOL) containsStatic
{
        /* this method returns YES for any keyword that should
	 * prevent an OCU defining-entry to be generated for
	 * a function definition that has the keyword
	 * stes 12/97 : added inline for Debian header files
	 */

	return (strcmp(token,"static") == 0)
	    || (strcmp(token,"inline") == 0)
	    || (strcmp(token,"__inline") == 0)
	    || (strcmp(token,"__inline__") == 0);
}

- (BOOL) isIdType
{
	return strcmp(token,"id") == 0;
}

- findIdentifier
{
	return nil;
}

- addIvarsTo:aSet addItype:bNode to:bSet
{
    /*
     * stes 10/26 hack so that int* is type
     * we can add to 'bnode' since it's a copy for each identifier
     * of the type (e.g. int *x,y;)
     */
    if (strcmp(token,"*") == 0) [bNode add:[self copy]];
    return self;
}


- asIdentifier
{
	return [Identifier str:token];
}

@end

